/*  descartes
 *  Copyright (C) 2001 Luc Brun
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
*/

#include "export_regions.h"
#include <objet.h>
#include <image.h>

#define Image SELF(img)
#define Dim   SELF(dim)


static image export_image;
static int   export_dim;

static void write_pixels_priv(any_ptr,point,int);

struct export_region
{
  image img;
  int dim;
};

export_region FAIRE_export_region(contour_set contours,
				  export_region_kind kind)
{
  INSTANCIER(export_region);
  
    Image = FAIRE_image();
    Dim = (kind == export_one_region_as_bitmap?1:3);
    
    image_initialize(Image,
		     Dim,
		     contour_set_give_image_largeur(contours),
		     contour_set_give_image_hauteur(contours)
		     );
    return self;
}
void DEFAIRE_export_region(export_region self)
{
  DEFAIRE_image(Image);
  free(self);
}
  
void export_region_do_export(export_region self,
			     contour_set contours,
			     dart f)
{
  assert(self);
  assert(Image);
  assert(!contour_set_is_infinite(contours,f));
  
  export_image = Image;
  export_dim  =  Dim;
  contour_set_apply_function(contours,f,write_pixels_priv);
}

void export_region_save(export_region self,
			char* name)
{
  assert(self);
  assert(name);
  assert(Image);

  image_sauvegarder(Image,name);
}

static void write_pixels_priv(any_ptr obj,
			      point p,
			      int flag)
{
  static int pixel[3],*val_img;
  int i;

  if(export_dim==1)
    pixel[0]=255;
  else
    {
      val_img=(int*)obj;
      for(i=0;i<3;i++)
	pixel[i]=val_img[i];
    }
  image_move_to(export_image,p);
  image_ecrire_pixel(export_image,pixel);
}
  
