/*  descartes
 *  Copyright (C) 2001 Luc Brun
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
*/

#ifndef __GEOMETRIE_H__
#define __GEOMETRIE_H__

#include <contour_set.h>

int    surface_calc         (contour_set,dart);
int    perimetre_calc       (contour_set,dart);
void   mean_calc            (contour_set,dart,int*,int*);
void   points_calc          (contour_set,dart,int*,int*,int*,int*);
int    height_calc          (contour_set,dart);
int    width_calc           (contour_set,dart);
void   center_calc          (contour_set,dart,int*,int*);
double ratio_surface_calc   (contour_set,dart);
double ratio_perimetre_calc (contour_set,dart);
double ratio_pixel_calc     (contour_set,dart);
double log_calc             (contour_set,dart);
void   direction_calc       (contour_set,dart,double*);
double angle_calc           (contour_set,dart,double*,double*);
double elongation_calc      (contour_set,dart);
double elongation_bis_calc  (contour_set,dart);
double give_distance_calc   (Point,Point);
double max_dist_calc        (contour_set,dart);

#endif  /*geometrie.h*/
