/*  descartes
 *  Copyright (C) 2001 Luc Brun
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
*/

#ifdef HAVE_CONFIG_H
#  include <config.h>
#endif



#define __NO_MOVES__
#include <stdio.h>
#include <gtk/gtk.h>

#include "gladesrc.h"
#include "gladesig.h"
#include "my_gtk.h"
#include "interface.h"
#include <list_gen.h>
#include <dart_list.h>
#include <rule.h>
#include <output_segment.h>
#include <seg_tmp.h>
#include <tab_move.h>
#include <tab_mark_dart.h>

#include <type_obj.h>

#include "interface_zoom.h"
#include "support_zoom.h"


gboolean
quitter_event_priv          (GtkWidget       *,
			     GdkEventButton  *,
			     gpointer);

bouleen get_options(char* nom_param,
		    char* param[],
		    int* nb_param)
{
  int i,j;
  
  
  for(i=1;i<*nb_param;i++)
    if(strcmp(param[i],nom_param)==0)
      break;

  if(i==*nb_param)
    return faux;
	  
  for(j=i;j<*nb_param-1;j++)
    {
      param[j] = param[j+1];
    }
  
  *nb_param = *nb_param-1;
  
  return vrai;
}

void usage(char * cmd)
{
  fprintf(stderr,"\nUsage: %s [image [image_seg.pgm]]\n",cmd);
}
int main (int argc, char *argv[])
{
  int i;
  GtkWidget* load;

  if(get_options("-help",argv,&argc))
    {
      usage(argv[0]);
      exit(0);
    }
  if(argc > 3)
    {
      usage(argv[0]);
      exit(2);
    }

  gtk_set_locale ();
  gtk_init (&argc, &argv);
  gdk_rgb_init();
  /*
   * The following code was added by Glade to create one of each component
   * (except popup menus), just so that you see something after building
   * the project. Delete any components that you don't want shown initially.
   */
  Descartes = create_Descartes ();
  gtk_widget_set_uposition(Descartes,1,1);
  gtk_widget_show (Descartes);
  /* Allocation of the garbage collectors of the following objects */
  ALLOC_list_gen();
  ALLOC_dart_list();
  ALLOC_rule();
  ALLOC_output_segment();
  ALLOC_seg_tmp();
  ALLOC_tab_move();
  ALLOC_tab_mark_dart();

  if (argc >=2)
    {
      if(interface_load_image_from_name(argv[1]))
	{
	  load = get_widget(Descartes, "ouvrir_button");
	  gtk_widget_set_sensitive(load,0);
	  
	  load = get_widget(Descartes, "Image");
	  gtk_widget_set_sensitive(load,0);
	}
    }
  for(i=1;i<argc-1;i++)
    argv[i] = argv[i+1];
  argc--;
  if (argc >=2)
    {
      if(interface_load_segmentation_from_name(argv[1]))
	{
	  load = get_widget(Descartes, "Segmentation");
	  gtk_widget_set_sensitive(load,0);

	  load = get_widget(Descartes,"Tableau_de_labels");
	  gtk_widget_set_sensitive(load,0);
	}
    }
  gtk_signal_connect_object (GTK_OBJECT (Descartes), "key_press_event",
			     GTK_SIGNAL_FUNC (quitter_event_priv),
			     NULL);
  

// modif

  gtk_main ();
  return 0;
}


void
on_Image_activate                      (GtkMenuItem     *menuitem,
                                        gpointer         user_data)
{
  
  GtkWidget * ImageSelection;

  ImageSelection =  create_file_selection("Choisir une image",
					  "*.ppm",
					  (GtkSignalFunc)interface_load_image,
					  gtk_widget_destroy);
 
}
void
on_Ouvrir_clicked                      (GtkButton       *button,
                                        gpointer         user_data)
{
  GtkWidget * ImageSelection;

  ImageSelection =  create_file_selection("Choisir une image",
					  "*.ppm",
					  (GtkSignalFunc)interface_load_image,
					  gtk_widget_destroy);
 
}

void
on_load_segmentation_activate               (GtkMenuItem     *menuitem,
                                        gpointer         user_data)
{
  GtkWidget * SegmentationSelection;

  SegmentationSelection =  create_file_selection("Choisir une image segmente",
						 "*.pgm",
						 (GtkSignalFunc)interface_load_segmentation,
						 gtk_widget_destroy);

}

// ---------------------------------------------------------
// Module a modifier
// ---------------------------------------------------------

void on_Tableau_de_labels_activate (GtkMenuItem *menuitem, gpointer user_data)
{
  GtkWidget * TabSelection;

  if(!is_image_chargee())
    {
      create_dialog(" Vous devez d'abord charger une image ! ", gtk_widget_destroy);
      return;
    }

  TabSelection =  create_file_selection("Import d'un tableau de labels",
					"*.p?m",
					(GtkSignalFunc)interface_load_tablabel,
					gtk_widget_destroy);
}

//---------------------------------------------------------------
// Re - Module a modifier
//---------------------------------------------------------------

void on_Tableau_de_labels2_activate (GtkMenuItem *menuitem, gpointer user_data)
{
  GtkWidget * TabSelection;

  if(!is_image_chargee())
    {
      create_dialog("Vous devez d'abord charger une image !", gtk_widget_destroy);
      return;
    }
  
  TabSelection =  create_file_selection("Export du tableau de labels",
					"*.p?m",
					(GtkSignalFunc)interface_save_tablabel,
					gtk_widget_destroy);
}

// -------------- 
// Trash
//--------------
//create_dialog(" Option non encore disponible ! ", gtk_widget_destroy);
// -------------------------------------------------------------------------

void
on_Sauver_activate                     (GtkMenuItem     *menuitem,
                                        gpointer         user_data)
{
  GtkWidget * SegmentationSelection;

  SegmentationSelection =  create_file_selection("Spcifier le nom de l'image segmente",
						 "*.pgm",
						 (GtkSignalFunc)interface_save_segmentation,
						 gtk_widget_destroy);


}
void on_sauver_clicked(GtkButton       *button,
		       gpointer         user_data)
{


  create_file_selection("Spcifier le nom de l'image segmente",
			"*.pgm",
			(GtkSignalFunc)interface_save_segmentation,
			gtk_widget_destroy);

}

void on_zoom_clicked( GtkButton *button, 
		      gpointer user_data )
{
  on_zoom_activate_interface(4);
}


void on_suppression_clicked(GtkButton       *button,
			    gpointer         user_data)
{
  interface_delete_selection();
}
void on_decoupe_clicked(GtkButton       *button,
			gpointer         user_data)
{
  interface_apply_rule(meta_seg_uniform_rule);
}
void
on_Quitter_activate                    (GtkMenuItem     *menuitem,
                                        gpointer         user_data)
{



  create_confirm("Voulez vous vraimment quitter ?",
		gtk_exit,
		gtk_widget_destroy);
}


void
on_Zoom_activate                       (GtkMenuItem     *menuitem,
                                        gpointer         user_data)
{
  on_zoom_activate_interface(GPOINTER_TO_INT(user_data));
}


void
on_R_gion_activate                     (GtkMenuItem     *menuitem,
                                        gpointer         user_data)
{
  interface_set_selection(region_selection);
}


void
on_Segment_activate                    (GtkMenuItem     *menuitem,
                                        gpointer         user_data)
{
  interface_set_selection(segment_selection);
}


void
on_Region_englobante_activate          (GtkMenuItem     *menuitem,
                                        gpointer         user_data)
{
  interface_set_selection(region_englobante_selection);
}


void
on_lissage_activate                    (GtkMenuItem     *menuitem,
                                        gpointer         user_data)
{
  interface_apply_rule(smooth_rule);
}


void
on_suppression_details_activate        (GtkMenuItem     *menuitem,
                                        gpointer         user_data)
{
  interface_apply_rule(remove_details_rule);
}

void
on_suppression_tous_les_details_activate(GtkMenuItem     *menuitem,
					 gpointer         user_data)
{
  interface_apply_rule(remove_all_details_rule);
}

void 
on_suppression_r_gions_incluses_activate(GtkMenuItem     *menuitem,
					 gpointer         user_data)
{
  interface_apply_rule(remove_included_faces_rule);
}


void
on_modifs_elementaires_activate      (GtkMenuItem     *menuitem,
                                        gpointer         user_data)
{

}


void on_Segmentation_activate                    (GtkMenuItem     *menuitem,
						  gpointer algo_type)
{
  GtkWidget* load;
  static bouleen load_active=vrai;
  
  interface_apply_segmentation((segmentation_alg)algo_type);

  if(load_active)
    {
      load = get_widget(Descartes, "Segmentation");
      gtk_widget_set_sensitive(load,0);
      load_active=faux;
    }
}

void
on_supprime_activate                    (GtkMenuItem     *menuitem,
                                        gpointer         user_data)
{
  interface_delete_selection();
}

void
on_Segmentation2_activate              (GtkMenuItem     *menuitem,
                                        gpointer         user_data)
{
}


void
on_CAG_RAG_activate            (GtkMenuItem     *menuitem,
				gpointer         user_data)
{
  interface_apply_rule(meta_seg_uniform_rule);
}

void
on_CAG_RAG_rec_activate            (GtkMenuItem     *menuitem,
				gpointer         user_data)
{
  interface_apply_rule(meta_seg_uniform_rec_rule);
}

void 
on_Export_region_activate               (GtkMenuItem     *menuitem,
                                        gpointer         user_data)
{
  GtkWidget* Export_File;
  char* mask[]={
    "*.pgm",
    "*.ppm"
  };
  
  export_region_kind kind=GPOINTER_TO_INT(user_data);
  interface_set_export_region_mode(kind);
  if(!interface_finite_face_selected())
    {
      create_dialog("Erreur:\nVous devez saisir une rgion finie",
		    gtk_widget_destroy);
      return;
    }
  Export_File =  create_file_selection("Nom de l'image de la region a exporter",
				       mask[kind],
				       (GtkSignalFunc)interface_export_region,
				       gtk_widget_destroy);
}

void
on_info_region_activate                       (GtkMenuItem     *menuitem,
					       gpointer         user_data)
{
  interface_info_region();
}

void
on_histo2d_activate                          (GtkMenuItem       *menuitem,
					      gpointer          user_data)
{
  interface_histo2d();
}

void
on_histogramme_R_activate                    (GtkMenuItem         *menuitem,
					      gpointer            user_data)
{
  interface_histogramme_R(user_data);
}

void
on_histogramme_G_activate                    (GtkMenuItem         *menuitem,
					      gpointer            user_data)
{
  interface_histogramme_G(user_data);
}

void
on_histogramme_B_activate                    (GtkMenuItem         *menuitem,
					      gpointer            user_data)
{
  interface_histogramme_B(user_data);
}

void
on_histogramme_I1_activate                    (GtkMenuItem         *menuitem,
					       gpointer            user_data)
{
  interface_histogramme_I1(user_data);
}

void
on_histogramme_I2_activate                    (GtkMenuItem         *menuitem,
					       gpointer            user_data)
{
  interface_histogramme_I2(user_data);
}

void
on_histogramme_I3_activate                    (GtkMenuItem         *menuitem,
					       gpointer            user_data)
{
  interface_histogramme_I3(user_data);
}

void
on_histogramme_L_activate                    (GtkMenuItem         *menuitem,
					      gpointer            user_data)
{
  interface_histogramme_L(user_data);
}

void
on_histogramme_u_activate                    (GtkMenuItem         *menuitem,
					      gpointer            user_data)
{
  interface_histogramme_u(user_data);
}

void
on_histogramme_v_activate                    (GtkMenuItem         *menuitem,
					      gpointer            user_data)
{
  interface_histogramme_v(user_data);
}

void
on_histogramme_a_activate                    (GtkMenuItem         *menuitem,
					       gpointer            user_data)
{
  interface_histogramme_a(user_data);
}

void
on_histogramme_b_activate                    (GtkMenuItem         *menuitem,
					       gpointer            user_data)
{
  interface_histogramme_b(user_data);
}

void
on_histogramme_Y_activate                    (GtkMenuItem         *menuitem,
					      gpointer            user_data)
{
  interface_histogramme_Y(user_data);
}

void
on_histogramme_I_activate                    (GtkMenuItem         *menuitem,
					      gpointer            user_data)
{
  interface_histogramme_I(user_data);
}

void
on_histogramme_Q_activate                    (GtkMenuItem         *menuitem,
					      gpointer            user_data)
{
  interface_histogramme_Q(user_data);
}

void
on_histogramme_Ht_activate                    (GtkMenuItem         *menuitem,
					       gpointer            user_data)
{
  interface_histogramme_Ht(user_data);
}

void
on_histogramme_St_activate                    (GtkMenuItem         *menuitem,
					       gpointer            user_data)
{
  interface_histogramme_St(user_data);
}

void
on_histogramme_Lt_activate                    (GtkMenuItem         *menuitem,
					       gpointer            user_data)
{
  interface_histogramme_Lt(user_data);
}

void
on_histogramme_Hh_activate                    (GtkMenuItem         *menuitem,
					       gpointer            user_data)
{
  interface_histogramme_Hh(user_data);
}

void
on_histogramme_Sh_activate                    (GtkMenuItem         *menuitem,
					       gpointer            user_data)
{
  interface_histogramme_Sh(user_data);
}

void
on_histogramme_Vh_activate                    (GtkMenuItem         *menuitem,
					       gpointer            user_data)
{
  interface_histogramme_Vh(user_data);
}

void
on_histogramme_Hd_activate                    (GtkMenuItem         *menuitem,
					       gpointer            user_data)
{
  interface_histogramme_Hd(user_data);
}

void
on_histogramme_Ld_activate                    (GtkMenuItem         *menuitem,
					       gpointer            user_data)
{
  interface_histogramme_Ld(user_data);
}

void
on_histogramme_Sd_activate                    (GtkMenuItem         *menuitem,
					       gpointer            user_data)
{
  interface_histogramme_Sd(user_data);
}



void
on_Aide_activate                       (GtkMenuItem     *menuitem,
                                        gpointer         user_data)
{
  
}


void
on_2_activate                          (GtkMenuItem     *menuitem,
                                        gpointer         user_data)
{
  on_zoom_activate_interface(2);
}


void
on_4_activate                          (GtkMenuItem     *menuitem,
                                        gpointer         user_data)
{
  on_zoom_activate_interface(4);
}


void
on_8_activate                          (GtkMenuItem     *menuitem,
                                        gpointer         user_data)
{
  on_zoom_activate_interface(8);
}

gboolean
on_vbox1_button_release_event          (GtkWidget       *widget,
                                        GdkEventButton  *event,
                                        gpointer         user_data)
{
  gint x,y;
  GtkWidget* ximg;

  if(!is_image_chargee())
    {
      create_dialog("Erreur:\n Vous devez d'abord charger une image",
		    gtk_widget_destroy);
	  
      return FALSE;
    }

  ximg=get_widget(Descartes,"ximage");
  gtk_widget_get_pointer(ximg,&x,&y);
  interface_update_selection(x,y);
  printf("Mouse clicked!!event : (%d,%d)\n",x,y);
  return FALSE;

}
gboolean
quitter_event_priv          (GtkWidget       *widget,
			     GdkEventButton  *event,
			     gpointer         user_data)
{
  printf("Ds evnt quitter\n");
  if(event->y == 'q')
    create_confirm("Voulez vous vraimment quitter ?",
		  gtk_exit,
		  gtk_widget_destroy);
    
  return FALSE;
}

