/*  descartes
 *  Copyright (C) 2001 Luc Brun
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
*/

/*  Note: You are free to use whatever license you want.
    Eventually you will be able to edit it within Glade. */

/*  Descartes_ana
 *  Copyright (C) <2000> <Luc Brun>
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
*/
#define __NO_MOVES__
#include <gtk/gtk.h>
#include <gdk/gdkkeysyms.h>
#include "gladesig.h"
#include "gladesrc.h"
#include  "export_regions.h"
#include <segmentation_link.h>

GtkWidget*
get_widget                             (GtkWidget       *widget,
                                        gchar           *widget_name)
{
  GtkWidget *found_widget;

  if (widget->parent)
    widget = gtk_widget_get_toplevel (widget);
  found_widget = (GtkWidget*) gtk_object_get_data (GTK_OBJECT (widget),
                                                   widget_name);
  if (!found_widget)
    g_warning ("Widget not found: %s", widget_name);
  return found_widget;
}

/* This is an internally used function to set notebook tab widgets. */
void
set_notebook_tab                       (GtkWidget       *notebook,
                                        gint             page_num,
                                        GtkWidget       *widget)
{
  GtkNotebookPage *page;
  GtkWidget *notebook_page;

  page = (GtkNotebookPage*) g_list_nth (GTK_NOTEBOOK (notebook)->children, page_num)->data;
  notebook_page = page->child;
  gtk_widget_ref (notebook_page);
  gtk_notebook_remove_page (GTK_NOTEBOOK (notebook), page_num);
  gtk_notebook_insert_page (GTK_NOTEBOOK (notebook), notebook_page,
                            widget, page_num);
  gtk_widget_unref (notebook_page);
}

GtkWidget*
create_Descartes ()
{
  GtkWidget *Descartes;
  GtkWidget *vbox1;
  GtkWidget *menu;
  GtkWidget *Fichier;
  GtkWidget *menu21;
  GtkWidget *Ouvrir;
  GtkWidget *menu22;
  GtkWidget *Image;
  GtkWidget *Segmentation;
  GtkWidget *Importer;
  GtkWidget *menu23;
  GtkWidget *Tableau_de_labels;
  GtkWidget *Exporter;
  GtkWidget *menu24;
  GtkWidget *Tableau_de_labels2;
  GtkWidget *Sauver;
  GtkWidget *Quitter;
  GtkWidget *Zoom;
  GtkWidget *menu25;
  GtkWidget *zoom2,*zoom4,*zoom8,*zoom16;
  GtkWidget *Selection;
  GtkWidget *menu26;
  GtkWidget *R_gion;
  GtkWidget *Segment;
  GtkWidget *Region_englobante;
  GtkWidget *Edition;
  GtkWidget *menu27;
  GtkWidget *lissage;
  GtkWidget *suppression_details;
  GtkWidget *suppression_tous_les_details;
  GtkWidget *suppression_r_gions_incluses;
  GtkWidget *modifs_elementaires;
  GtkWidget *menu28;
  GtkWidget *decoupes_elementaires;
  GtkWidget *menu_decoupes_elementaires;
  GtkWidget *CAG;
  GtkWidget *Local_Seg;
  GtkWidget *Local_Seg_Exp;
  GtkWidget *Global_Seg;
  GtkWidget *suppression;
  GtkWidget *Segmentation2;
  GtkWidget *menu29;
  GtkWidget *CAG_RAG;
  GtkWidget *CAG_RAG_rec;
  GtkWidget *Aide;
  GtkWidget *hbox1;
  GtkWidget *sauver;
  GtkWidget *ouvrir_button;
  GtkWidget *zoom;
  GtkWidget *decoupe;
  GtkWidget *Suppression;
  GtkTooltips *tooltips;
  GtkWidget * darea;
  GtkWidget * scrolled_window;
  GtkWidget * align;

  GtkWidget * Export_regions;
  GtkWidget * Export_region_menu,*Export_save,*menu_region_save;
  GtkWidget * Export_region_bitmap;
  GtkWidget * Export_region_image;
  GtkWidget * Info_region;
  GtkWidget * Histo2d;
  GtkWidget * Histogramme;
  GtkWidget * menu_histogramme;
  GtkWidget * Histogramme_RGB,*menu_histo_RGB;
  GtkWidget * Histogramme_R,*Histogramme_G,*Histogramme_B;
  GtkWidget * Histogramme_I1I2I3,*menu_histo_I1I2I3;
  GtkWidget * Histogramme_I1,*Histogramme_I2,*Histogramme_I3;
  GtkWidget * Histogramme_Luv,*menu_histo_Luv;
  GtkWidget * Histogramme_L,*Histogramme_u,*Histogramme_v;
  GtkWidget * Histogramme_Lab,*menu_histo_Lab;
  GtkWidget * Histogramme_L_bis,*Histogramme_a,*Histogramme_b;
  GtkWidget * Histogramme_YIQ,*menu_histo_YIQ;
  GtkWidget * Histogramme_Y,*Histogramme_I,*Histogramme_Q;
  GtkWidget * Histogramme_HSV,*menu_histo_HSV;
  GtkWidget * Histo_HSL_triangle,*menu_histo_HSL_triangle;
  GtkWidget * Histogramme_Ht,*Histogramme_St,*Histogramme_Lt;
  GtkWidget * Histo_HSV_hex,*menu_histo_HSV_hex;
  GtkWidget * Histogramme_Hh,*Histogramme_Sh,*Histogramme_Vh;
  GtkWidget * Histo_HLS_dhex,*menu_histo_HLS_dhex;
  GtkWidget * Histogramme_Hd,*Histogramme_Ld,*Histogramme_Sd;

  tooltips = gtk_tooltips_new ();

  Descartes = gtk_window_new (GTK_WINDOW_TOPLEVEL);
  gtk_object_set_data (GTK_OBJECT (Descartes), "Descartes", Descartes);
  gtk_window_set_title (GTK_WINDOW (Descartes), "Descartes");
  gtk_window_set_policy (GTK_WINDOW (Descartes), TRUE, TRUE, FALSE);

  vbox1 = gtk_vbox_new (FALSE, 0);
  gtk_object_set_data (GTK_OBJECT (Descartes), "vbox1", vbox1);
  gtk_widget_show (vbox1);
  gtk_container_add (GTK_CONTAINER (Descartes), vbox1);

  menu = gtk_menu_bar_new ();
  gtk_object_set_data (GTK_OBJECT (Descartes), "menu", menu);
  gtk_widget_show (menu);
  gtk_box_pack_start (GTK_BOX (vbox1), menu, FALSE, TRUE, 0);

  Fichier = gtk_menu_item_new_with_label ("File");
  gtk_object_set_data (GTK_OBJECT (Descartes), "Fichier", Fichier);
  gtk_widget_show (Fichier);
  gtk_container_add (GTK_CONTAINER (menu), Fichier);

  menu21 = gtk_menu_new ();
  gtk_object_set_data (GTK_OBJECT (Descartes), "menu21", menu21);
  gtk_menu_item_set_submenu (GTK_MENU_ITEM (Fichier), menu21);

  Ouvrir = gtk_menu_item_new_with_label ("Open");
  gtk_object_set_data (GTK_OBJECT (Descartes), "Ouvrir", Ouvrir);
  gtk_widget_show (Ouvrir);
  gtk_container_add (GTK_CONTAINER (menu21), Ouvrir);

  menu22 = gtk_menu_new ();
  gtk_object_set_data (GTK_OBJECT (Descartes), "menu22", menu22);
  gtk_menu_item_set_submenu (GTK_MENU_ITEM (Ouvrir), menu22);

  Image = gtk_menu_item_new_with_label ("Image");
  gtk_object_set_data (GTK_OBJECT (Descartes), "Image", Image);
  gtk_widget_show (Image);
  gtk_container_add (GTK_CONTAINER (menu22), Image);
  gtk_signal_connect (GTK_OBJECT (Image), "activate",
                      GTK_SIGNAL_FUNC (on_Image_activate),
                      NULL);

  Segmentation = gtk_menu_item_new_with_label ("Segmentation");
  gtk_object_set_data (GTK_OBJECT (Descartes), "Segmentation", Segmentation);
  gtk_widget_show (Segmentation);
  gtk_container_add (GTK_CONTAINER (menu22), Segmentation);
  gtk_signal_connect (GTK_OBJECT (Segmentation), "activate",
                      GTK_SIGNAL_FUNC (on_load_segmentation_activate),
                      NULL);

  Importer = gtk_menu_item_new_with_label ("Import");
  gtk_object_set_data (GTK_OBJECT (Descartes), "Importer", Importer);
  gtk_widget_show (Importer);
  gtk_container_add (GTK_CONTAINER (menu21), Importer);

  menu23 = gtk_menu_new ();
  gtk_object_set_data (GTK_OBJECT (Descartes), "menu23", menu23);
  gtk_menu_item_set_submenu (GTK_MENU_ITEM (Importer), menu23);

  Tableau_de_labels = gtk_menu_item_new_with_label ("Array of labels");
  gtk_object_set_data (GTK_OBJECT (Descartes), 
		       "Tableau_de_labels", 
		       Tableau_de_labels);
  gtk_widget_show (Tableau_de_labels);
  gtk_container_add (GTK_CONTAINER (menu23), Tableau_de_labels);
  gtk_signal_connect (GTK_OBJECT (Tableau_de_labels), "activate",
                      GTK_SIGNAL_FUNC (on_Tableau_de_labels_activate),
                      NULL);

  Exporter = gtk_menu_item_new_with_label ("Export");
  gtk_object_set_data (GTK_OBJECT (Descartes), "Exporter", Exporter);
  gtk_widget_show (Exporter);
  gtk_container_add (GTK_CONTAINER (menu21), Exporter);

  menu24 = gtk_menu_new ();
  gtk_object_set_data (GTK_OBJECT (Descartes), "menu24", menu24);
  gtk_menu_item_set_submenu (GTK_MENU_ITEM (Exporter), menu24);

  Tableau_de_labels2 = gtk_menu_item_new_with_label ("Array of  labels");
  gtk_object_set_data (GTK_OBJECT (Descartes), "Tableau_de_labels2", Tableau_de_labels2);
  gtk_widget_show (Tableau_de_labels2);
  gtk_container_add (GTK_CONTAINER (menu24), Tableau_de_labels2);
  gtk_signal_connect (GTK_OBJECT (Tableau_de_labels2), "activate",
                      GTK_SIGNAL_FUNC (on_Tableau_de_labels2_activate),
                      NULL);

  Sauver = gtk_menu_item_new_with_label ("Save");
  gtk_object_set_data (GTK_OBJECT (Descartes), "Sauver", Sauver);
  gtk_widget_show (Sauver);
  gtk_container_add (GTK_CONTAINER (menu21), Sauver);
  gtk_signal_connect (GTK_OBJECT (Sauver), "activate",
                      GTK_SIGNAL_FUNC (on_Sauver_activate),
                      NULL);

  Quitter = gtk_menu_item_new_with_label ("Quit");
  gtk_object_set_data (GTK_OBJECT (Descartes), "Quitter", Quitter);
  gtk_widget_show (Quitter);
  gtk_container_add (GTK_CONTAINER (menu21), Quitter);
  gtk_signal_connect (GTK_OBJECT (Quitter), "activate",
                      GTK_SIGNAL_FUNC (on_Quitter_activate),
                      NULL);

  Zoom = gtk_menu_item_new_with_label ("Zoom");
  gtk_object_set_data (GTK_OBJECT (Descartes), "Zoom", Zoom);
  gtk_widget_show (Zoom);
  gtk_container_add (GTK_CONTAINER (menu), Zoom);

  menu25 = gtk_menu_new ();
  gtk_object_set_data (GTK_OBJECT (Descartes), "menu25", menu25);
  gtk_menu_item_set_submenu (GTK_MENU_ITEM (Zoom), menu25);

  zoom2 = gtk_menu_item_new_with_label ("Zoom 2");
  gtk_object_set_data (GTK_OBJECT (Descartes), "zoom2", zoom2);
  gtk_widget_show (zoom2);
  gtk_container_add (GTK_CONTAINER (menu25), zoom2);
  gtk_signal_connect (GTK_OBJECT (zoom2), "activate",
                      GTK_SIGNAL_FUNC (on_Zoom_activate),
                      GINT_TO_POINTER(2));

  zoom4 = gtk_menu_item_new_with_label ("Zoom 4");
  gtk_object_set_data (GTK_OBJECT (Descartes), "zoom4", zoom4);
  gtk_widget_show (zoom4);
  gtk_container_add (GTK_CONTAINER (menu25), zoom4);
  gtk_signal_connect (GTK_OBJECT (zoom4), "activate",
                      GTK_SIGNAL_FUNC (on_Zoom_activate),
		      GINT_TO_POINTER(4));

  zoom8 = gtk_menu_item_new_with_label ("Zoom 8");
  gtk_object_set_data (GTK_OBJECT (Descartes), "zoom8", zoom8);
  gtk_widget_show (zoom8);
  gtk_container_add (GTK_CONTAINER (menu25), zoom8);
  gtk_signal_connect (GTK_OBJECT (zoom8), "activate",
                      GTK_SIGNAL_FUNC (on_Zoom_activate),
		      GINT_TO_POINTER(8));

  zoom16 = gtk_menu_item_new_with_label ("Zoom 16");
  gtk_object_set_data (GTK_OBJECT (Descartes), "zoom16", zoom16);
  gtk_widget_show (zoom16);
  gtk_container_add (GTK_CONTAINER (menu25), zoom16);
  gtk_signal_connect (GTK_OBJECT (zoom16), "activate",
                      GTK_SIGNAL_FUNC (on_Zoom_activate),
		      GINT_TO_POINTER(16));

  Selection = gtk_menu_item_new_with_label ("Selection");
  gtk_object_set_data (GTK_OBJECT (Descartes), "Selection", Selection);
  gtk_widget_show (Selection);
  gtk_container_add (GTK_CONTAINER (menu), Selection);

  menu26 = gtk_menu_new ();
  gtk_object_set_data (GTK_OBJECT (Descartes), "menu26", menu26);
  gtk_menu_item_set_submenu (GTK_MENU_ITEM (Selection), menu26);

  R_gion = gtk_menu_item_new_with_label ("Region");
  gtk_object_set_data (GTK_OBJECT (Descartes), "R_gion", R_gion);
  gtk_widget_show (R_gion);
  gtk_container_add (GTK_CONTAINER (menu26), R_gion);
  gtk_signal_connect (GTK_OBJECT (R_gion), "activate",
                      GTK_SIGNAL_FUNC (on_R_gion_activate),
                      NULL);

  Segment = gtk_menu_item_new_with_label ("Segment");
  gtk_object_set_data (GTK_OBJECT (Descartes), "Segment", Segment);
  gtk_widget_show (Segment);
  gtk_container_add (GTK_CONTAINER (menu26), Segment);
  gtk_signal_connect (GTK_OBJECT (Segment), "activate",
                      GTK_SIGNAL_FUNC (on_Segment_activate),
                      NULL);

  Region_englobante = gtk_menu_item_new_with_label ("Including Region");
  gtk_object_set_data (GTK_OBJECT (Descartes), "Region_englobante", Region_englobante);
  gtk_widget_show (Region_englobante);
  gtk_container_add (GTK_CONTAINER (menu26), Region_englobante);
  gtk_signal_connect (GTK_OBJECT (Region_englobante), "activate",
                      GTK_SIGNAL_FUNC (on_Region_englobante_activate),
                      NULL);

  Edition = gtk_menu_item_new_with_label ("Edit");
  gtk_object_set_data (GTK_OBJECT (Descartes), "Edition", Edition);
  gtk_widget_show (Edition);
  gtk_container_add (GTK_CONTAINER (menu), Edition);

  menu27 = gtk_menu_new ();
  gtk_object_set_data (GTK_OBJECT (Descartes), "menu27", menu27);
  gtk_menu_item_set_submenu (GTK_MENU_ITEM (Edition), menu27);

  lissage = gtk_menu_item_new_with_label ("smoothing");
  gtk_object_set_data (GTK_OBJECT (Descartes), "lissage", lissage);
  gtk_widget_show (lissage);
  gtk_container_add (GTK_CONTAINER (menu27), lissage);
  gtk_signal_connect (GTK_OBJECT (lissage), "activate",
                      GTK_SIGNAL_FUNC (on_lissage_activate),
                      NULL);

  suppression_details = gtk_menu_item_new_with_label ("remove details");
  gtk_object_set_data (GTK_OBJECT (Descartes), 
		       "suppression_details", 
		       suppression_details);
  gtk_widget_show (suppression_details);
  gtk_container_add (GTK_CONTAINER (menu27), 
		     suppression_details);
  gtk_signal_connect (GTK_OBJECT (suppression_details), 
		      "activate",
                      GTK_SIGNAL_FUNC (on_suppression_details_activate),
                      NULL);

  suppression_tous_les_details = gtk_menu_item_new_with_label
    ("Remove all details");
  gtk_object_set_data (GTK_OBJECT (Descartes), 
		       "suppression_tous_les_details", 
		       suppression_tous_les_details);
  gtk_widget_show (suppression_tous_les_details);
  gtk_container_add (GTK_CONTAINER (menu27), 
		     suppression_tous_les_details);
  gtk_signal_connect (GTK_OBJECT (suppression_tous_les_details), 
		      "activate",
                      GTK_SIGNAL_FUNC (on_suppression_tous_les_details_activate),
                      NULL);

  suppression_r_gions_incluses = gtk_menu_item_new_with_label ("remove included regions");
  gtk_object_set_data (GTK_OBJECT (Descartes), "suppression_r_gions_incluses", suppression_r_gions_incluses);
  gtk_widget_show (suppression_r_gions_incluses);
  gtk_container_add (GTK_CONTAINER (menu27), suppression_r_gions_incluses);
  gtk_signal_connect (GTK_OBJECT (suppression_r_gions_incluses), "activate",
                      GTK_SIGNAL_FUNC (on_suppression_r_gions_incluses_activate),
                      NULL);

 modifs_elementaires = gtk_menu_item_new_with_label ("Basic modifications");
  gtk_object_set_data (GTK_OBJECT (Descartes), "Modifications_Elementaires",modifs_elementaires);
  gtk_widget_show (modifs_elementaires);
  gtk_container_add (GTK_CONTAINER (menu),modifs_elementaires);
  gtk_signal_connect (GTK_OBJECT (modifs_elementaires), "activate",
                      GTK_SIGNAL_FUNC (on_modifs_elementaires_activate),
                      NULL);
 
  
  
  menu28 = gtk_menu_new ();
  gtk_object_set_data (GTK_OBJECT (Descartes), "menu28", menu28);
  gtk_menu_item_set_submenu (GTK_MENU_ITEM (modifs_elementaires), menu28);

  decoupes_elementaires = gtk_menu_item_new_with_label ("Basic Split algorithms");
  gtk_object_set_data (GTK_OBJECT (Descartes), 
		       "Decoupes_Elementaires",
		       decoupes_elementaires);
  gtk_widget_show (decoupes_elementaires);
  gtk_container_add (GTK_CONTAINER (menu28),
		     decoupes_elementaires);
  
  menu_decoupes_elementaires = gtk_menu_new ();
  gtk_object_set_data (GTK_OBJECT (Descartes), 
		       "menu_decoupes_elmentaires", 
		       menu_decoupes_elementaires);
  gtk_menu_item_set_submenu (GTK_MENU_ITEM (decoupes_elementaires),
			     menu_decoupes_elementaires);


  CAG = gtk_menu_item_new_with_label ("Quantifization with CAG");
  gtk_object_set_data (GTK_OBJECT (Descartes), "CAG", CAG);
  gtk_widget_show (CAG);
  gtk_container_add (GTK_CONTAINER (menu_decoupes_elementaires), CAG);
  gtk_signal_connect (GTK_OBJECT (CAG), "activate",
                      GTK_SIGNAL_FUNC (on_Segmentation_activate),
                      (gpointer)
		      uniform_segmentation);

  Local_Seg = gtk_menu_item_new_with_label ("Segmentation of homogeneous regions");
  gtk_object_set_data (GTK_OBJECT (Descartes), "Local_Seg", Local_Seg);
  gtk_widget_show (Local_Seg);
  gtk_container_add (GTK_CONTAINER (menu_decoupes_elementaires), Local_Seg);
  gtk_signal_connect (GTK_OBJECT (Local_Seg), "activate",
                      GTK_SIGNAL_FUNC (on_Segmentation_activate),
                      (gpointer)local_segmentation);

  Local_Seg_Exp = gtk_menu_item_new_with_label ("Segmentation of  homogeneous regions (Gaussian distribution)");
  gtk_object_set_data (GTK_OBJECT (Descartes), 
		       "Local_Seg_Exp", 
		       Local_Seg_Exp);
  gtk_widget_show (Local_Seg_Exp);
  gtk_container_add (GTK_CONTAINER (menu_decoupes_elementaires), 
		     Local_Seg_Exp);
  gtk_signal_connect (GTK_OBJECT (Local_Seg_Exp), "activate",
                      GTK_SIGNAL_FUNC (on_Segmentation_activate),
                      (gpointer)local_exp_segmentation);

  Global_Seg = gtk_menu_item_new_with_label ("Segmentation with Top-down Quantization");
  gtk_object_set_data (GTK_OBJECT (Descartes), "Global_Seg", Global_Seg);
  gtk_widget_show (Global_Seg);
  gtk_container_add (GTK_CONTAINER (menu_decoupes_elementaires), Global_Seg);
  gtk_signal_connect (GTK_OBJECT (Global_Seg), "activate",
                      GTK_SIGNAL_FUNC (on_Segmentation_activate),
                      (gpointer)global_segmentation);


  suppression = gtk_menu_item_new_with_label ("Remove Selection");
  gtk_object_set_data (GTK_OBJECT (Descartes), 
		       "Supprime_selection", 
		       suppression);
  gtk_widget_show (suppression);
  gtk_container_add (GTK_CONTAINER (menu28), suppression);
  gtk_signal_connect (GTK_OBJECT (suppression), "activate",
                      GTK_SIGNAL_FUNC (on_supprime_activate),
                      NULL);

  Segmentation2 = gtk_menu_item_new_with_label ("Segmentation");
  gtk_object_set_data (GTK_OBJECT (Descartes), "Segmentation2", Segmentation2);
  gtk_widget_show (Segmentation2);
  gtk_container_add (GTK_CONTAINER (menu), Segmentation2);
  gtk_signal_connect (GTK_OBJECT (Segmentation2), "activate",
                      GTK_SIGNAL_FUNC (on_Segmentation2_activate),
                      NULL);

  menu29 = gtk_menu_new ();
  gtk_object_set_data (GTK_OBJECT (Descartes), "menu29", menu29);
  gtk_menu_item_set_submenu (GTK_MENU_ITEM (Segmentation2), menu29);

  CAG_RAG = gtk_menu_item_new_with_label ("Split and Merge (CAG+RAG)");
  gtk_object_set_data (GTK_OBJECT (Descartes), "CAG_RAG", CAG_RAG);
  gtk_widget_show (CAG_RAG);
  gtk_container_add (GTK_CONTAINER (menu29), CAG_RAG);
  gtk_signal_connect (GTK_OBJECT (CAG_RAG), "activate",
                      GTK_SIGNAL_FUNC (on_CAG_RAG_activate),
                      NULL);

  CAG_RAG_rec = gtk_menu_item_new_with_label ("Split and Merge (CAG+RAG) Recursive ");
  gtk_object_set_data (GTK_OBJECT (Descartes), "CAR_RAG_rec", CAG_RAG_rec);
  gtk_widget_show (CAG_RAG_rec);
  gtk_container_add (GTK_CONTAINER (menu29), CAG_RAG_rec);
  gtk_signal_connect (GTK_OBJECT (CAG_RAG_rec), "activate",
                      GTK_SIGNAL_FUNC (on_CAG_RAG_rec_activate),
                      NULL);

  Export_regions = gtk_menu_item_new_with_label ("Region");
  gtk_object_set_data (GTK_OBJECT (Descartes), 
		       "Export_Regions", 
		       Export_regions);
  gtk_widget_show (Export_regions);
  gtk_container_add (GTK_CONTAINER (menu), Export_regions);
  
  Export_region_menu = gtk_menu_new ();
  gtk_object_set_data (GTK_OBJECT (Descartes), 
		       "Export_region_menu", 
		       Export_region_menu);
  gtk_menu_item_set_submenu (GTK_MENU_ITEM (Export_regions), 
			     Export_region_menu);

  Info_region= gtk_menu_item_new_with_label ("Region Infos");
  gtk_object_set_data (GTK_OBJECT (Descartes), "Info_region",Export_save);
  gtk_signal_connect (GTK_OBJECT (Info_region), "activate",
                      GTK_SIGNAL_FUNC (on_info_region_activate),
                      NULL);

  gtk_widget_show (Info_region);
  gtk_container_add (GTK_CONTAINER (Export_region_menu),
		    Info_region);

  Histogramme = gtk_menu_item_new_with_label ("Histogram 1D");
  gtk_object_set_data (GTK_OBJECT (Descartes), "Histogramme",Export_save);
  gtk_widget_show (Histogramme);
  gtk_container_add (GTK_CONTAINER (Export_region_menu),
		     Histogramme);

  menu_histogramme = gtk_menu_new ();
  gtk_object_set_data (GTK_OBJECT (Descartes),
		       "menu_histogramme",
		       menu_histogramme);
  gtk_menu_item_set_submenu (GTK_MENU_ITEM (Histogramme),
			     menu_histogramme);

  Histogramme_RGB = gtk_menu_item_new_with_label ("RGB");
  gtk_object_set_data (GTK_OBJECT (Descartes),
		       "Histogramme_RGB",
		       Histogramme_RGB);
  gtk_widget_show (Histogramme_RGB);
  gtk_container_add (GTK_CONTAINER (menu_histogramme),
		     Histogramme_RGB);

  menu_histo_RGB = gtk_menu_new ();
  gtk_object_set_data (GTK_OBJECT (Descartes),
		       "menu_histo_RGB",
		       menu_histo_RGB);
  gtk_menu_item_set_submenu (GTK_MENU_ITEM (Histogramme_RGB),
			     menu_histo_RGB);

  Histogramme_R = gtk_menu_item_new_with_label ("R");
  gtk_object_set_data (GTK_OBJECT (Descartes),
		       "Histogramme_R",
		       Histogramme_R);
  gtk_widget_show (Histogramme_R);
  gtk_container_add (GTK_CONTAINER (menu_histo_RGB),
		     Histogramme_R);
  gtk_signal_connect (GTK_OBJECT (Histogramme_R), "activate",
                      GTK_SIGNAL_FUNC (on_histogramme_R_activate),
                      "Histogram R (RGB)");

  Histogramme_G = gtk_menu_item_new_with_label ("G");
  gtk_object_set_data (GTK_OBJECT (Descartes),
		       "Histogramme_G",
		       Histogramme_G);
  gtk_widget_show (Histogramme_G);
  gtk_container_add (GTK_CONTAINER (menu_histo_RGB),
		     Histogramme_G);
  gtk_signal_connect (GTK_OBJECT (Histogramme_G), "activate",
                      GTK_SIGNAL_FUNC (on_histogramme_G_activate),
                      "Histogram G (RGB)");

  Histogramme_B = gtk_menu_item_new_with_label ("B");
  gtk_object_set_data (GTK_OBJECT (Descartes),
		       "Histogramme_B",
		       Histogramme_B);
  gtk_widget_show (Histogramme_B);
  gtk_container_add (GTK_CONTAINER (menu_histo_RGB),
		     Histogramme_B);
  gtk_signal_connect (GTK_OBJECT (Histogramme_B), "activate",
                      GTK_SIGNAL_FUNC (on_histogramme_B_activate),
                      "Histogram B (RGB)");


  Histogramme_I1I2I3 = gtk_menu_item_new_with_label ("I1I2I3");
  gtk_object_set_data (GTK_OBJECT (Descartes),
		       "Histogramme_I1I2I3",
		       Histogramme_I1I2I3);
  gtk_widget_show (Histogramme_I1I2I3);
  gtk_container_add (GTK_CONTAINER (menu_histogramme),
		     Histogramme_I1I2I3);

  menu_histo_I1I2I3 = gtk_menu_new ();
  gtk_object_set_data (GTK_OBJECT (Descartes),
		       "menu_histo_I1I2I3",
		       menu_histo_I1I2I3);
  gtk_menu_item_set_submenu (GTK_MENU_ITEM (Histogramme_I1I2I3),
			     menu_histo_I1I2I3);

  Histogramme_I1 = gtk_menu_item_new_with_label ("I1");
  gtk_object_set_data (GTK_OBJECT (Descartes),
		       "Histogramme_I1",
		       Histogramme_I1);
  gtk_widget_show (Histogramme_I1);
  gtk_container_add (GTK_CONTAINER (menu_histo_I1I2I3),
		     Histogramme_I1);
  gtk_signal_connect (GTK_OBJECT (Histogramme_I1), "activate",
                      GTK_SIGNAL_FUNC (on_histogramme_I1_activate),
                      "Histogram I1 (I1I2I3)");

  Histogramme_I2 = gtk_menu_item_new_with_label ("I2");
  gtk_object_set_data (GTK_OBJECT (Descartes),
		       "Histogramme_I2",
		       Histogramme_I2);
  gtk_widget_show (Histogramme_I2);
  gtk_container_add (GTK_CONTAINER (menu_histo_I1I2I3),
		     Histogramme_I2);
  gtk_signal_connect (GTK_OBJECT (Histogramme_I2), "activate",
                      GTK_SIGNAL_FUNC (on_histogramme_I2_activate),
                      "Histogram I2 (I1I2I3)");

  Histogramme_I3 = gtk_menu_item_new_with_label ("I3");
  gtk_object_set_data (GTK_OBJECT (Descartes),
		       "Histogramme_I3",
		       Histogramme_I3);
  gtk_widget_show (Histogramme_I3);
  gtk_container_add (GTK_CONTAINER (menu_histo_I1I2I3),
		     Histogramme_I3);
  gtk_signal_connect (GTK_OBJECT (Histogramme_I3), "activate",
                      GTK_SIGNAL_FUNC (on_histogramme_I3_activate),
                      "Histogram I3 (I1I2I3)");


  Histogramme_Luv = gtk_menu_item_new_with_label ("Luv");
  gtk_object_set_data (GTK_OBJECT (Descartes),
		       "Histogramme_Luv",
		       Histogramme_Luv);
  gtk_widget_show (Histogramme_Luv);
  gtk_container_add (GTK_CONTAINER (menu_histogramme),
		     Histogramme_Luv);

  menu_histo_Luv = gtk_menu_new ();
  gtk_object_set_data (GTK_OBJECT (Descartes),
		       "menu_histo_Luv",
		       menu_histo_Luv);
  gtk_menu_item_set_submenu (GTK_MENU_ITEM (Histogramme_Luv),
			     menu_histo_Luv);

  Histogramme_L = gtk_menu_item_new_with_label ("L");
  gtk_object_set_data (GTK_OBJECT (Descartes),
		       "Histogramme_L",
		       Histogramme_L);
  gtk_widget_show (Histogramme_L);
  gtk_container_add (GTK_CONTAINER (menu_histo_Luv),
		     Histogramme_L);
  gtk_signal_connect (GTK_OBJECT (Histogramme_L), "activate",
                      GTK_SIGNAL_FUNC (on_histogramme_L_activate),
                      "Histogram L (Luv)");

  Histogramme_u = gtk_menu_item_new_with_label ("u");
  gtk_object_set_data (GTK_OBJECT (Descartes),
		       "Histogramme_u",
		       Histogramme_u);
  gtk_widget_show (Histogramme_u);
  gtk_container_add (GTK_CONTAINER (menu_histo_Luv),
		     Histogramme_u);
  gtk_signal_connect (GTK_OBJECT (Histogramme_u), "activate",
                      GTK_SIGNAL_FUNC (on_histogramme_u_activate),
                      "Histogram u (Luv)");

  Histogramme_v = gtk_menu_item_new_with_label ("v");
  gtk_object_set_data (GTK_OBJECT (Descartes),
		       "Histogramme_v",
		       Histogramme_v);
  gtk_widget_show (Histogramme_v);
  gtk_container_add (GTK_CONTAINER (menu_histo_Luv),
		     Histogramme_v);
  gtk_signal_connect (GTK_OBJECT (Histogramme_v), "activate",
                      GTK_SIGNAL_FUNC (on_histogramme_v_activate),
                      "Histogram v (Luv)");


  Histogramme_Lab = gtk_menu_item_new_with_label ("Lab");
  gtk_object_set_data (GTK_OBJECT (Descartes),
		       "Histogramme_Lab",
		       Histogramme_Lab);
  gtk_widget_show (Histogramme_Lab);
  gtk_container_add (GTK_CONTAINER (menu_histogramme),
		     Histogramme_Lab);

  menu_histo_Lab = gtk_menu_new ();
  gtk_object_set_data (GTK_OBJECT (Descartes),
		       "menu_histo_Lab",
		       menu_histo_Lab);
  gtk_menu_item_set_submenu (GTK_MENU_ITEM (Histogramme_Lab),
			     menu_histo_Lab);

  Histogramme_L_bis = gtk_menu_item_new_with_label ("L");
  gtk_object_set_data (GTK_OBJECT (Descartes),
		       "Histogramme_L_bis",
		       Histogramme_L_bis);
  gtk_widget_show (Histogramme_L_bis);
  gtk_container_add (GTK_CONTAINER (menu_histo_Lab),
		     Histogramme_L_bis);
  gtk_signal_connect (GTK_OBJECT (Histogramme_L_bis), "activate",
                      GTK_SIGNAL_FUNC (on_histogramme_L_activate),
                      "Histogram L (Lab)");

  Histogramme_a = gtk_menu_item_new_with_label ("a");
  gtk_object_set_data (GTK_OBJECT (Descartes),
		       "Histogramme_a",
		       Histogramme_a);
  gtk_widget_show (Histogramme_a);
  gtk_container_add (GTK_CONTAINER (menu_histo_Lab),
		     Histogramme_a);
  gtk_signal_connect (GTK_OBJECT (Histogramme_a), "activate",
                      GTK_SIGNAL_FUNC (on_histogramme_a_activate),
                      "Histogram a (Lab)");

  Histogramme_b = gtk_menu_item_new_with_label ("b");
  gtk_object_set_data (GTK_OBJECT (Descartes),
		       "Histogramme_b",
		       Histogramme_b);
  gtk_widget_show (Histogramme_b);
  gtk_container_add (GTK_CONTAINER (menu_histo_Lab),
		     Histogramme_b);
  gtk_signal_connect (GTK_OBJECT (Histogramme_b), "activate",
                      GTK_SIGNAL_FUNC (on_histogramme_b_activate),
                      "Histogram b (Lab)");


  Histogramme_YIQ = gtk_menu_item_new_with_label ("YIQ");
  gtk_object_set_data (GTK_OBJECT (Descartes),
		       "Histogramme_YIQ",
		       Histogramme_YIQ);
  gtk_widget_show (Histogramme_YIQ);
  gtk_container_add (GTK_CONTAINER (menu_histogramme),
		     Histogramme_YIQ);

  menu_histo_YIQ = gtk_menu_new ();
  gtk_object_set_data (GTK_OBJECT (Descartes),
		       "menu_histo_YIQ",
		       menu_histo_YIQ);
  gtk_menu_item_set_submenu (GTK_MENU_ITEM (Histogramme_YIQ),
			     menu_histo_YIQ);

  Histogramme_Y = gtk_menu_item_new_with_label ("Y");
  gtk_object_set_data (GTK_OBJECT (Descartes),
		       "Histogramme_Y",
		       Histogramme_Y);
  gtk_widget_show (Histogramme_Y);
  gtk_container_add (GTK_CONTAINER (menu_histo_YIQ),
		     Histogramme_Y);
  gtk_signal_connect (GTK_OBJECT (Histogramme_Y), "activate",
                      GTK_SIGNAL_FUNC (on_histogramme_Y_activate),
                      "Histogram Y (YIQ)");

  Histogramme_I = gtk_menu_item_new_with_label ("I");
  gtk_object_set_data (GTK_OBJECT (Descartes),
		       "Histogramme_I",
		       Histogramme_I);
  gtk_widget_show (Histogramme_I);
  gtk_container_add (GTK_CONTAINER (menu_histo_YIQ),
		     Histogramme_I);
  gtk_signal_connect (GTK_OBJECT (Histogramme_I), "activate",
                      GTK_SIGNAL_FUNC (on_histogramme_I_activate),
                      "Histogram I (YIQ)");

  Histogramme_Q = gtk_menu_item_new_with_label ("Q");
  gtk_object_set_data (GTK_OBJECT (Descartes),
		       "Histogramme_Q",
		       Histogramme_Q);
  gtk_widget_show (Histogramme_Q);
  gtk_container_add (GTK_CONTAINER (menu_histo_YIQ),
		     Histogramme_Q);
  gtk_signal_connect (GTK_OBJECT (Histogramme_Q), "activate",
                      GTK_SIGNAL_FUNC (on_histogramme_Q_activate),
                      "Histogram Q (YIQ)");

  Histogramme_HSV = gtk_menu_item_new_with_label ("HSV (ou LHS)");
  gtk_object_set_data (GTK_OBJECT (Descartes),
		       "Histogramme_HSV",
		       Histogramme_HSV);
  gtk_widget_show (Histogramme_HSV);
  gtk_container_add (GTK_CONTAINER (menu_histogramme),
		     Histogramme_HSV);

  menu_histo_HSV = gtk_menu_new ();
  gtk_object_set_data (GTK_OBJECT (Descartes),
		       "menu_histo_HSV",
		       menu_histo_HSV);
  gtk_menu_item_set_submenu (GTK_MENU_ITEM (Histogramme_HSV),
			     menu_histo_HSV);
  
  Histo_HSL_triangle = gtk_menu_item_new_with_label ("HSL triangle");
  gtk_object_set_data (GTK_OBJECT (Descartes),
		       "Histo_HSL_triangle",
		       Histo_HSL_triangle);
  gtk_widget_show (Histo_HSL_triangle);
  gtk_container_add (GTK_CONTAINER (menu_histo_HSV),
		     Histo_HSL_triangle);

  menu_histo_HSL_triangle = gtk_menu_new ();
  gtk_object_set_data (GTK_OBJECT (Descartes),
		       "menu_histo_HSL_triangle",
		       menu_histo_HSL_triangle);
  gtk_menu_item_set_submenu (GTK_MENU_ITEM (Histo_HSL_triangle),
			     menu_histo_HSL_triangle);

  Histogramme_Ht = gtk_menu_item_new_with_label ("H");
  gtk_object_set_data (GTK_OBJECT (Descartes),
		       "Histogramme_Ht",
		       Histogramme_Ht);
  gtk_widget_show (Histogramme_Ht);
  gtk_container_add (GTK_CONTAINER (menu_histo_HSL_triangle),
		     Histogramme_Ht);
  gtk_signal_connect (GTK_OBJECT (Histogramme_Ht), "activate",
                      GTK_SIGNAL_FUNC (on_histogramme_Ht_activate),
                      "Histogram H (HSL triangle)");

  Histogramme_St = gtk_menu_item_new_with_label ("S");
  gtk_object_set_data (GTK_OBJECT (Descartes),
		       "Histogramme_St",
		       Histogramme_St);
  gtk_widget_show (Histogramme_St);
  gtk_container_add (GTK_CONTAINER (menu_histo_HSL_triangle),
		     Histogramme_St);
  gtk_signal_connect (GTK_OBJECT (Histogramme_St), "activate",
                      GTK_SIGNAL_FUNC (on_histogramme_St_activate),
                      "Histogram S (HSL triangle)");

  Histogramme_Lt = gtk_menu_item_new_with_label ("L");
  gtk_object_set_data (GTK_OBJECT (Descartes),
		       "Histogramme_Lt",
		       Histogramme_Lt);
  gtk_widget_show (Histogramme_Lt);
  gtk_container_add (GTK_CONTAINER (menu_histo_HSL_triangle),
		     Histogramme_Lt);
  gtk_signal_connect (GTK_OBJECT (Histogramme_Lt), "activate",
                      GTK_SIGNAL_FUNC (on_histogramme_Lt_activate),
                      "Histogram L (HSL triangle)");

  Histo_HSV_hex = gtk_menu_item_new_with_label ("HSV hexcone");
  gtk_object_set_data (GTK_OBJECT (Descartes),
		       "Histo_HSV_hex",
		       Histo_HSV_hex);
  gtk_widget_show (Histo_HSV_hex);
  gtk_container_add (GTK_CONTAINER (menu_histo_HSV),
		     Histo_HSV_hex);

  menu_histo_HSV_hex = gtk_menu_new ();
  gtk_object_set_data (GTK_OBJECT (Descartes),
		       "menu_histo_HSV_hex",
		       menu_histo_HSV_hex);
  gtk_menu_item_set_submenu (GTK_MENU_ITEM (Histo_HSV_hex),
			     menu_histo_HSV_hex);

  Histogramme_Hh = gtk_menu_item_new_with_label ("H");
  gtk_object_set_data (GTK_OBJECT (Descartes),
		       "Histogramme_Hh",
		       Histogramme_Hh);
  gtk_widget_show (Histogramme_Hh);
  gtk_container_add (GTK_CONTAINER (menu_histo_HSV_hex),
		     Histogramme_Hh);
  gtk_signal_connect (GTK_OBJECT (Histogramme_Hh), "activate",
                      GTK_SIGNAL_FUNC (on_histogramme_Hh_activate),
                      "Histogram H (HSV hexcone)");

  Histogramme_Sh = gtk_menu_item_new_with_label ("S");
  gtk_object_set_data (GTK_OBJECT (Descartes),
		       "Histogramme_Sh",
		       Histogramme_Sh);
  gtk_widget_show (Histogramme_Sh);
  gtk_container_add (GTK_CONTAINER (menu_histo_HSV_hex),
		     Histogramme_Sh);
  gtk_signal_connect (GTK_OBJECT (Histogramme_Sh), "activate",
                      GTK_SIGNAL_FUNC (on_histogramme_Sh_activate),
                      "Histogram S (HSV hexcone)");

  Histogramme_Vh = gtk_menu_item_new_with_label ("V");
  gtk_object_set_data (GTK_OBJECT (Descartes),
		       "Histogramme_Vh",
		       Histogramme_Vh);
  gtk_widget_show (Histogramme_Vh);
  gtk_container_add (GTK_CONTAINER (menu_histo_HSV_hex),
		     Histogramme_Vh);
  gtk_signal_connect (GTK_OBJECT (Histogramme_Vh), "activate",
                      GTK_SIGNAL_FUNC (on_histogramme_Vh_activate),
                      "Histogram V (HSV hexcone)");

  Histo_HLS_dhex = gtk_menu_item_new_with_label ("HLS double hexcone");
  gtk_object_set_data (GTK_OBJECT (Descartes),
		       "Histo_HLS_dhex",
		       Histo_HLS_dhex);
  gtk_widget_show (Histo_HLS_dhex);
  gtk_container_add (GTK_CONTAINER (menu_histo_HSV),
		     Histo_HLS_dhex);

  menu_histo_HLS_dhex = gtk_menu_new ();
  gtk_object_set_data (GTK_OBJECT (Descartes),
		       "menu_histo_HLS_dhex",
		       menu_histo_HLS_dhex);
  gtk_menu_item_set_submenu (GTK_MENU_ITEM (Histo_HLS_dhex),
			     menu_histo_HLS_dhex);

  Histogramme_Hd = gtk_menu_item_new_with_label ("H");
  gtk_object_set_data (GTK_OBJECT (Descartes),
		       "Histogramme_Hd",
		       Histogramme_Hd);
  gtk_widget_show (Histogramme_Hd);
  gtk_container_add (GTK_CONTAINER (menu_histo_HLS_dhex),
		     Histogramme_Hd);
  gtk_signal_connect (GTK_OBJECT (Histogramme_Hd), "activate",
                      GTK_SIGNAL_FUNC (on_histogramme_Hd_activate),
                      "Histogram H (HLS double hexcone)");

  Histogramme_Ld = gtk_menu_item_new_with_label ("L");
  gtk_object_set_data (GTK_OBJECT (Descartes),
		       "Histogramme_Ld",
		       Histogramme_Ld);
  gtk_widget_show (Histogramme_Ld);
  gtk_container_add (GTK_CONTAINER (menu_histo_HLS_dhex),
		     Histogramme_Ld);
  gtk_signal_connect (GTK_OBJECT (Histogramme_Ld), "activate",
                      GTK_SIGNAL_FUNC (on_histogramme_Ld_activate),
                      "Histogram L (HLS double hexcone)");

  Histogramme_Sd = gtk_menu_item_new_with_label ("S");
  gtk_object_set_data (GTK_OBJECT (Descartes),
		       "Histogramme_Sd",
		       Histogramme_Sd);
  gtk_widget_show (Histogramme_Sd);
  gtk_container_add (GTK_CONTAINER (menu_histo_HLS_dhex),
		     Histogramme_Sd);
  gtk_signal_connect (GTK_OBJECT (Histogramme_Sd), "activate",
                      GTK_SIGNAL_FUNC (on_histogramme_Sd_activate),
                      "Histogram S (HLS double hexcone)");


  Histo2d = gtk_menu_item_new_with_label ("Histogram 2D");
  gtk_object_set_data (GTK_OBJECT (Descartes), "Histo2d",Export_save);
  gtk_signal_connect (GTK_OBJECT (Histo2d), "activate",
                      GTK_SIGNAL_FUNC (on_histo2d_activate),
                      NULL);

  gtk_widget_show (Histo2d);
  gtk_container_add (GTK_CONTAINER (Export_region_menu),
		     Histo2d);

  Export_save= gtk_menu_item_new_with_label ("Export Region");
  gtk_object_set_data (GTK_OBJECT (Descartes), "Export_save",Export_save);
  gtk_widget_show (Export_save);
  gtk_container_add (GTK_CONTAINER (Export_region_menu),
		     Export_save);

  menu_region_save = gtk_menu_new ();
  gtk_object_set_data (GTK_OBJECT (Descartes), 
		       "menu_region_save", 
		       menu_region_save);
  gtk_menu_item_set_submenu (GTK_MENU_ITEM (Export_save), 
			     menu_region_save);
  
  Export_region_bitmap = gtk_menu_item_new_with_label ("Export (mask)");
  gtk_object_set_data (GTK_OBJECT (Descartes),
		       "Export_region_bitmap", 
		       Export_region_bitmap);
  gtk_widget_show (Export_region_bitmap);
  gtk_container_add (GTK_CONTAINER (menu_region_save), 
		     Export_region_bitmap);
  gtk_signal_connect (GTK_OBJECT (Export_region_bitmap), "activate",
                      GTK_SIGNAL_FUNC (on_Export_region_activate),
                      GINT_TO_POINTER(export_one_region_as_bitmap));
  
  Export_region_image = gtk_menu_item_new_with_label ("Export (image)");
  gtk_object_set_data (GTK_OBJECT (Descartes), 
		       "Export_region_image",
		       Export_region_image);
  gtk_widget_show (Export_region_image);
  gtk_container_add (GTK_CONTAINER (menu_region_save), 
		     Export_region_image);
  gtk_signal_connect (GTK_OBJECT (Export_region_image), 
		      "activate",
                      GTK_SIGNAL_FUNC (on_Export_region_activate),
                      GINT_TO_POINTER(export_one_region)
		      );


  Aide = gtk_menu_item_new_with_label ("Help");
  gtk_object_set_data (GTK_OBJECT (Descartes), "Aide", Aide);
  gtk_widget_show (Aide);
  gtk_container_add (GTK_CONTAINER (menu), Aide);
  gtk_signal_connect (GTK_OBJECT (Aide), "activate",
                      GTK_SIGNAL_FUNC (on_Aide_activate),
                      NULL);

  hbox1 = gtk_hbox_new (FALSE, 0);
  gtk_object_set_data (GTK_OBJECT (Descartes), "hbox1", hbox1);
  gtk_widget_show (hbox1);
  gtk_box_pack_start (GTK_BOX (vbox1), hbox1, FALSE, TRUE, 0);

  ouvrir_button = gtk_button_new_with_label (" Open\nImage");
  gtk_object_set_data (GTK_OBJECT (Descartes), "ouvrir_button",ouvrir_button);
  gtk_widget_show (ouvrir_button);
  gtk_box_pack_start (GTK_BOX (hbox1),ouvrir_button, TRUE, TRUE, 0);
  /*  gtk_widget_set_usize (zoom, 12, -1);*/
  gtk_tooltips_set_tip (tooltips, ouvrir_button, "ouvrir_button", NULL);
  gtk_signal_connect (GTK_OBJECT (ouvrir_button), "clicked",
                      GTK_SIGNAL_FUNC (on_Ouvrir_clicked),
                      NULL);
  sauver = gtk_button_new_with_label ("Save\nSegmentation");
  gtk_object_set_data (GTK_OBJECT (Descartes), "sauver", sauver);
  gtk_widget_show (sauver);
  gtk_box_pack_start (GTK_BOX (hbox1), sauver, TRUE, TRUE, 0);
  /*  gtk_widget_set_usize (sauver, 14, 34);*/
  gtk_container_border_width (GTK_CONTAINER (sauver), 1);
  gtk_tooltips_set_tip (tooltips, sauver, "save the partition", NULL);
  gtk_signal_connect (GTK_OBJECT (sauver), "clicked",
                      GTK_SIGNAL_FUNC (on_sauver_clicked),
                      NULL);


  zoom = gtk_button_new_with_label ("Zoom");
  gtk_object_set_data (GTK_OBJECT (Descartes), "zoom", zoom);
  gtk_widget_show (zoom);
  gtk_box_pack_start (GTK_BOX (hbox1), zoom, TRUE, TRUE, 0);
  /*  gtk_widget_set_usize (zoom, 12, -1);*/
  gtk_tooltips_set_tip (tooltips, zoom, "zoom of the selected region (factor 4)", NULL);
  gtk_signal_connect(GTK_OBJECT(zoom),"clicked",GTK_SIGNAL_FUNC(on_zoom_clicked),NULL);

  decoupe = gtk_button_new_with_label ("Split");
  gtk_object_set_data (GTK_OBJECT (Descartes), "decoupe", decoupe);
  gtk_widget_show (decoupe);
  gtk_box_pack_start (GTK_BOX (hbox1), decoupe, TRUE, TRUE, 0);
  gtk_tooltips_set_tip (tooltips, decoupe, "split a  face", NULL);
  gtk_signal_connect (GTK_OBJECT (decoupe), "clicked",
                      GTK_SIGNAL_FUNC (on_decoupe_clicked),
                      NULL);

  Suppression = gtk_button_new_with_label ("Remove");
  gtk_object_set_data (GTK_OBJECT (Descartes), "Suppression", Suppression);
  gtk_widget_show (Suppression);
  gtk_box_pack_start (GTK_BOX (hbox1), Suppression, TRUE, TRUE, 0);
  gtk_tooltips_set_tip (tooltips, Suppression, "remove the selected object", NULL);
  gtk_signal_connect (GTK_OBJECT (Suppression), "clicked",
                      GTK_SIGNAL_FUNC (on_suppression_clicked),
                      NULL);

  /*  event_box = gtk_event_box_new();
      gtk_object_set_data(GTK_OBJECT (Descartes), "event_box", event_box);
      gtk_widget_show(event_box);
  */



  
  
  scrolled_window = gtk_scrolled_window_new (NULL, NULL);
  gtk_object_set_data (GTK_OBJECT (Descartes), 
	 	       "Scrolled Window", 
		       scrolled_window);
  gtk_container_border_width (GTK_CONTAINER (scrolled_window), 1);
  gtk_scrolled_window_set_policy (GTK_SCROLLED_WINDOW (scrolled_window),
				  GTK_POLICY_AUTOMATIC,GTK_POLICY_AUTOMATIC);
  gtk_container_add(GTK_CONTAINER(vbox1),scrolled_window);
  gtk_widget_show (scrolled_window);

  align = gtk_alignment_new(.5,.5,.0,.0);
  gtk_scrolled_window_add_with_viewport(GTK_SCROLLED_WINDOW(scrolled_window), align);
  gtk_object_set_data(GTK_OBJECT(Descartes), "align", align );

  darea = gtk_drawing_area_new();
  gtk_container_add(GTK_CONTAINER(align),darea);
  gtk_object_set_data (GTK_OBJECT (Descartes), "ximage", darea);

  
  gtk_widget_add_events(darea,GDK_BUTTON_PRESS_MASK);
  gtk_signal_connect_object (GTK_OBJECT (darea), "button_press_event",
			     GTK_SIGNAL_FUNC (on_vbox1_button_release_event),
			     NULL);

  gtk_widget_realize(darea);
  gdk_window_set_cursor(scrolled_window->window,gdk_cursor_new(GDK_HAND1));
  
  /*
    gtk_container_add(GTK_CONTAINER(event_box),scrolled_window);
    gtk_scrolled_window_add_with_viewport(GTK_SCROLLED_WINDOW
    (scrolled_window),
    event_box);    */
					
  
  
  /* fixed_widget = gtk_fixed_new();
  gtk_object_set_data (GTK_OBJECT (Descartes), 
	 	       "Fixed Widget", 
		       fixed_widget);
  gtk_widget_show  (fixed_widget);
  
  gtk_container_add(GTK_CONTAINER(event_box),fixed_widget);
  
  */
    
      
  

  return  Descartes;
}

