/*  descartes
 *  Copyright (C) 2001 Luc Brun
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 */

/*
 * NE PAS EDITER CE FICHIER - il est généré par Glade.
 */

#ifdef HAVE_CONFIG_H
#  include <config.h>
#endif

#include <sys/types.h>
#include <sys/stat.h>
#include <unistd.h>
#include <string.h>

#include <gdk/gdkkeysyms.h>
#include <gtk/gtk.h>
#include "my_gtk.h"

#include "gtk_histo1d.h"
#include "support.h"
#include "interface.h"

#define WIDTH  600
#define HEIGHT 450

static gboolean expose_event_callback  (GtkWidget*,
					GdkEventExpose*,
					gpointer);

static gboolean destroy_event_callback (GtkWidget*,
					GdkEvent*,
					gpointer); 


void on_close1_activate (GtkMenuItem *menuitem,
			 gpointer user_data)
{
  gtk_widget_destroy(GTK_WIDGET(user_data));
}


static gboolean
destroy_event_callback (GtkWidget *widget,
			GdkEvent *event,
			gpointer user_data)
{
  DEFAIRE_histo1d((histo1d)user_data);
  
  return TRUE;
}

static gboolean
expose_event_callback (GtkWidget *widget,
		       GdkEventExpose *event,
		       gpointer user_data)
{
  gint width = widget->allocation.width;
  gint height = widget->allocation.height;
  gint x0 = 5*width/100, y0 = 95*height/100;
  gint xmax = 95*width/100, ymax = 5*height/100;
  gint rx, ry;
  gint xtmp, ytmp, x, y;
  rx = xmax-x0;
  ry = y0-ymax;
  gchar minx[7], maxx[7], maxy[7];
  int MaxX, MinX, MaxY;
  int r,g,b,m0;
  GdkColor color_histo;
  GdkGC* color_histo_gc;

  color_histo_gc = gdk_gc_new((GdkDrawable*)widget->window);
  gdk_gc_ref(color_histo_gc);

  MaxX = histo1d_get_maxX((histo1d)user_data);
  MinX = histo1d_get_minX((histo1d)user_data);
  MaxY = histo1d_get_maxY((histo1d)user_data);

  
  //axe des abscisses
  gdk_draw_line (widget->window,
		 widget->style->black_gc,
		 x0-4, y0,
		 (97*xmax/95),
		 y0);
  
  gdk_draw_line (widget->window,
		 widget->style->black_gc,
		 (97*xmax/95)-5, y0-5,
		 (97*xmax/95)+5, y0);
  
  gdk_draw_line (widget->window,
		 widget->style->black_gc,
		 (97*xmax/95)-5, y0+5,
		 (97*xmax/95)+5, y0);
  
  //axe des ordonnées
  gdk_draw_line (widget->window,
		 widget->style->black_gc,
		 x0-4, y0,
		 x0-4, (5*ymax/5));
  
  gdk_draw_line (widget->window,
		 widget->style->black_gc,
		 x0-9, (5*ymax/5)+5,
		 x0-4, (5*ymax/5)-5);
  
  gdk_draw_line (widget->window,
		 widget->style->black_gc,
		 x0+1, (5*ymax/5)+5,
		 x0-4, (5*ymax/5)-5);
  
  //graduations
  for(x=x0+10; x<xmax; x+=10)
    {
      
      gdk_draw_line (widget->window,
		     widget->style->black_gc,
		     x,y0+1,
		     x,y0-1);
    }
  for(y=y0-10; y>ymax; y-=10)
    {
      gdk_draw_line (widget->window,
		     widget->style->black_gc,
		     x0-5,y,
		     x0-3,y);
    }

  //Informations numériques
  gdk_draw_line(widget->window,
		widget->style->black_gc,
		xmax,y0+3,
		xmax,y0);
  sprintf(minx,"%d",MinX);
  gdk_draw_string(widget->window,
		  widget->style->font,
		  widget->style->black_gc,
		  3*width/100,
		  99*height/100,
		  minx);
  sprintf(maxx,"%d",MaxX);
  gdk_draw_string(widget->window,
		  widget->style->font,
		  widget->style->black_gc,
		  94*width/100,
		  99*height/100,
		  maxx);
  gdk_draw_string(widget->window,
		  widget->style->font,
		  widget->style->black_gc,
		  2*width/100,
		  95*height/100,
		  "0");
  sprintf(maxy,"%d",MaxY);
  gdk_draw_string(widget->window,
		  widget->style->font,
		  widget->style->black_gc,
		  0.5*width/100,
		  4*height/100,
		  maxy);
  
  if(MinX<0)
    {
      gdk_draw_line(widget->window,
		    widget->style->black_gc,
		    (x0+(gfloat)(-MinX)/(gfloat)(MaxX-MinX)*rx),y0+3,
		    (x0+(gfloat)(-MinX)/(gfloat)(MaxX-MinX)*rx),y0);
      gdk_draw_string(widget->window,
		      widget->style->font,
		      widget->style->black_gc,
		      (x0+(gfloat)(-MinX)/(gfloat)(MaxX-MinX)*rx)-4,
		      99*height/100,
		      "0");
    }



  //histogramme

  for(x=MinX; x<=MaxX; x++)
    {
      y = histo1d_get_value((histo1d)user_data,x);
      xtmp=(x0+((gfloat)(x-MinX)/(gfloat)(MaxX-MinX))*rx);
      ytmp=(y0-((gfloat)y/(gfloat)MaxY)*ry);
      
      m0 = y;

	if(m0==0)
	  {
	    r=0;
	    g=0;
	    b=0;
	  }
	else
	  {
	    r = (histo1d_get_M1_red((histo1d)user_data,x))/m0;	    	    
	    g = (histo1d_get_M1_green((histo1d)user_data,x))/m0;
	    b = (histo1d_get_M1_blue((histo1d)user_data,x))/m0;
	  }
	
	color_histo.pixel = y0-ytmp;
	color_histo.red = (r*255);
	color_histo.green = (g*255);
	color_histo.blue = (b*255);

	gdk_colormap_alloc_color(gtk_widget_get_colormap(widget),&color_histo,1,1);
	gdk_gc_set_foreground(color_histo_gc,&color_histo);
	
	gdk_draw_line (widget->window,
		       color_histo_gc,
		       xtmp,y0,
		       xtmp,ytmp);

	gdk_colormap_free_colors(gtk_widget_get_colormap(widget),&color_histo,1);
    }
  
  gdk_gc_unref(color_histo_gc);

  return TRUE;
}

void
on_export_histo_activate (GtkMenuItem *menuitem,
			  gpointer user_data)
{
  GtkWidget* Export_File;
  
  get_store_histo1d((histo1d*)&user_data,WRITE_HISTO);
  
  Export_File =  create_file_selection("Nom de l'histogramme a exporter",
				       ".gnuplot",
				       (GtkSignalFunc)interface_export_histo1d,
				       gtk_widget_destroy);
}


GtkWidget*
create_gtk_histogramme (histo1d histo,
			gchar* title)
{
  GtkWidget *histogramme;
  GtkWidget *vbox1;
  GtkWidget *menubar1;
  GtkWidget *file1;
  GtkWidget *file1_menu;
  GtkAccelGroup *file1_menu_accels;
  GtkWidget *close1;
  GtkWidget *export,*export_menu,*export_histo;
  GtkWidget *curve1;

  histogramme = gtk_window_new (GTK_WINDOW_TOPLEVEL);
  gtk_object_set_data (GTK_OBJECT (histogramme), "histogramme", histogramme);
  gtk_window_set_title (GTK_WINDOW (histogramme), (title));
  gtk_window_set_default_size (GTK_WINDOW (histogramme),
			       (gint)WIDTH ,
			       (gint)HEIGHT);

  vbox1 = gtk_vbox_new (FALSE, 0);
  gtk_widget_ref (vbox1);
  gtk_object_set_data_full (GTK_OBJECT (histogramme), "vbox1", vbox1,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_container_add (GTK_CONTAINER (histogramme), vbox1);

  menubar1 = gtk_menu_bar_new ();
  gtk_widget_ref (menubar1);
  gtk_object_set_data_full (GTK_OBJECT (histogramme), "menubar1", menubar1,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_box_pack_start (GTK_BOX (vbox1), menubar1, FALSE, FALSE, 0);

  file1 = gtk_menu_item_new_with_label (_("File"));
  gtk_widget_ref (file1);
  gtk_object_set_data_full (GTK_OBJECT (histogramme), "file1", file1,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_container_add (GTK_CONTAINER (menubar1), file1);

  file1_menu = gtk_menu_new ();
  gtk_widget_ref (file1_menu);
  gtk_object_set_data_full (GTK_OBJECT (histogramme), "file1_menu", file1_menu,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_menu_item_set_submenu (GTK_MENU_ITEM (file1), file1_menu);
  file1_menu_accels = gtk_menu_ensure_uline_accel_group (GTK_MENU (file1_menu));
  close1 = gtk_menu_item_new_with_label (_("Close"));
  
  gtk_widget_ref (close1);
  gtk_object_set_data_full (GTK_OBJECT (histogramme), "close1", close1,
			    (GtkDestroyNotify) gtk_widget_unref);

  gtk_container_add (GTK_CONTAINER (file1_menu), close1);


  export = gtk_menu_item_new_with_label (_("Export"));
  gtk_widget_ref (export);
  gtk_object_set_data_full (GTK_OBJECT (histogramme), "export", export,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_container_add (GTK_CONTAINER (menubar1), export);

  export_menu = gtk_menu_new ();
  gtk_object_set_data (GTK_OBJECT (histogramme), "menu_export_histo", export_menu);
  gtk_menu_item_set_submenu (GTK_MENU_ITEM (export), export_menu);

  export_histo = gtk_menu_item_new_with_label (_("Export as .gnuplot"));
  gtk_object_set_data (GTK_OBJECT (histogramme), "export_histo", export_histo);
  gtk_widget_show (export_histo);
  gtk_container_add (GTK_CONTAINER (export_menu), export_histo);
  gtk_signal_connect (GTK_OBJECT (export_histo), "activate",
                      GTK_SIGNAL_FUNC (on_export_histo_activate),
                      histo);
  

  curve1 = gtk_drawing_area_new();
  gtk_widget_ref (curve1);
  gtk_object_set_data_full (GTK_OBJECT (histogramme), "curve1", curve1,
			    (GtkDestroyNotify) gtk_widget_unref);

  gtk_container_add (GTK_CONTAINER (vbox1),curve1);

  gtk_signal_connect(GTK_OBJECT(curve1), "expose_event",
		     GTK_SIGNAL_FUNC(expose_event_callback),
		     histo); 
  gtk_signal_connect(GTK_OBJECT(curve1), "destroy_event",
		     GTK_SIGNAL_FUNC(destroy_event_callback),
		     histo); 

  gtk_signal_connect (GTK_OBJECT (close1), "activate",
                      GTK_SIGNAL_FUNC (on_close1_activate),
                      histogramme);

  gtk_widget_show_all(histogramme); 


  return histogramme;
}


