/*  descartes
 *  Copyright (C) 2001 Luc Brun
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 */

/*
 * NE PAS EDITER CE FICHIER - il est généré par Glade.
 */

#ifdef HAVE_CONFIG_H
#  include <config.h>
#endif

#include <sys/types.h>
#include <sys/stat.h>
#include <unistd.h>
#include <string.h>

#include <gdk/gdkkeysyms.h>
#include <gtk/gtk.h>
#include "my_gtk.h"

#include "gtk_histo2d.h"
#include "support.h"
#include "interface.h"


static void on_fermer_activate         (GtkMenuItem*,
					gpointer);

static gboolean on_export_activate     (GtkMenuItem*,
					gpointer);

static gboolean expose_event_callback (GtkWidget*,
				       GdkEventExpose*,
				       gpointer);

static gboolean destroy_event_callback (GtkWidget*,
					GdkEvent*,
					gpointer); 


void on_fermer_activate (GtkMenuItem *menuitem,
			 gpointer user_data)
{
  gtk_widget_destroy(GTK_WIDGET(user_data));
}

static gboolean
on_export_activate (GtkMenuItem *menuitem,
		    gpointer user_data)
{
  GtkWidget *Export_File;

  get_store_histo2d((histo2d*)&user_data,WRITE_HISTO);
  
  Export_File =  create_file_selection("Nom de l'histogramme 2D",
				       ".ppm",
				       (GtkSignalFunc)interface_export_histo2d,
				       gtk_widget_destroy);

  return TRUE;
}

static gboolean
destroy_event_callback (GtkWidget *widget,
			GdkEvent *event,
			gpointer user_data)
{
  DEFAIRE_histo2d((histo2d)user_data);
  
  return TRUE;
}

static gboolean
expose_event_callback(GtkWidget* widget,
		      GdkEventExpose *event,
		      gpointer user_data)
{
  int x,y;
  int ti, tj;
  int e1, e2;
  double c1,c2;
  short int freq_max,freq_cour;
  int r,g,b;
  float t;
  GdkColor color_histo;
  GdkGC* color_histo_gc;

  histo2d_get_taille((histo2d)user_data,&ti,&tj);

  e1 = 60;
  e2 = 60;

  color_histo_gc = gdk_gc_new(widget->window);
  gdk_gc_ref(color_histo_gc);

  freq_max = histo2d_get_freq_max((histo2d)user_data);

  
  gdk_draw_rectangle((GdkDrawable*)widget->window,
		     widget->style->black_gc,
		     TRUE,
		     0,0,
		     widget->allocation.width,
		     widget->allocation.height);

  c1 = (double)(widget->allocation.width-120)/(double)ti;
  c2 = (double)(widget->allocation.height-120)/(double)tj;
  
  //image
  
  for(x=e1; x<(int)(c1*ti)+e1; x++)
    {
      for(y=e2; y<(int)(c2*tj)+e2; y++)
	{
	  freq_cour = histo2d_get_value((histo2d)user_data,
					(gint)((x-e1)/c1),
					(gint)((y-e2)/c2));
	  
	  t = (float)freq_cour/(float)freq_max;
	  r=g=b=0;
	  if(freq_cour>0)
	    {
	      if(freq_cour<(freq_max/2))
		{
		  r = 0;
		  g = (int)(255*2*t);
		  b = (int)(255*(1-2*t));
		}
	      else
		{
		  r = (int)(255*(2*t-1));
		  g = (int)(2*255*(1-t));
		  b = 0;
		}
	    }
	  color_histo.pixel = 1;
	  color_histo.red = (r*255);
	  color_histo.green = (g*255);
	  color_histo.blue = (b*255);
	  
	  gdk_colormap_alloc_color(gtk_widget_get_colormap(widget),&color_histo,1,1);
	  gdk_gc_set_foreground(color_histo_gc,&color_histo);
	  
	  gdk_draw_point (widget->window,
			  color_histo_gc,
			  x,y);
	  
	  gdk_colormap_free_colors(gtk_widget_get_colormap(widget),&color_histo,1);
	}
    }
  gdk_gc_unref(color_histo_gc);
  
  int min1, max1;
  int min2, max2;  
  gchar minw[7], maxw[7], minh[7], maxh[7];

  histo2d_get_minmax((histo2d)user_data,&min1,&max1,&min2,&max2);

  sprintf(minw,"%d",min1);
  sprintf(maxw,"%d",max1);
  sprintf(minh,"%d",min2);
  sprintf(maxh,"%d",max2);

  gdk_draw_string((GdkDrawable*)widget->window,
		  widget->style->font,
		  widget->style->white_gc,
		  e1-10,
		  e2-20,
		  minw);
  gdk_draw_string((GdkDrawable*)widget->window,
		  widget->style->font,
		  widget->style->white_gc,
		  e1+c1*ti-20,
		  e2-20,
		  maxw);
  gdk_draw_string((GdkDrawable*)widget->window,
		  widget->style->font,
		  widget->style->white_gc,
		  e1-50,
		  e2+10,
		  minh);
  gdk_draw_string((GdkDrawable*)widget->window,
		  widget->style->font,
		  widget->style->white_gc,
		  e1-50,
		  e2+c2*tj,
		  maxh);

  return TRUE;
}


GtkWidget*
create_gtk_histo2d (histo2d histo,
		    gchar* title)
{
  GtkWidget *histogramme;
  GtkWidget *vbox1;
  GtkWidget *menubar1;
  GtkWidget *file1;
  GtkWidget *file1_menu;
  GtkAccelGroup *file1_menu_accels;
  GtkWidget *close1;

  GtkWidget *export;
  GtkWidget *export_menu;
  GtkAccelGroup *export_menu_accels;
  GtkWidget *export_image;

  GtkWidget *image;
  gint i,j;

  histo2d_get_taille(histo,&i,&j);

  histogramme = gtk_window_new (GTK_WINDOW_TOPLEVEL);
  gtk_object_set_data (GTK_OBJECT (histogramme), "histogramme", histogramme);
  gtk_window_set_title (GTK_WINDOW (histogramme), (title));
  gtk_window_set_default_size (GTK_WINDOW (histogramme),i+120,j+120);

  vbox1 = gtk_vbox_new (FALSE, 0);
  gtk_widget_ref (vbox1);
  gtk_object_set_data_full (GTK_OBJECT (histogramme), "vbox1", vbox1,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_container_add (GTK_CONTAINER (histogramme), vbox1);

  menubar1 = gtk_menu_bar_new ();
  gtk_widget_ref (menubar1);
  gtk_object_set_data_full (GTK_OBJECT (histogramme), "menubar1", menubar1,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_box_pack_start (GTK_BOX (vbox1), menubar1, FALSE, FALSE, 0);

  file1 = gtk_menu_item_new_with_label (_("File"));
  gtk_widget_ref (file1);
  gtk_object_set_data_full (GTK_OBJECT (histogramme), "file1", file1,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_container_add (GTK_CONTAINER (menubar1), file1);

  file1_menu = gtk_menu_new ();
  gtk_widget_ref (file1_menu);
  gtk_object_set_data_full (GTK_OBJECT (histogramme), "file1_menu", file1_menu,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_menu_item_set_submenu (GTK_MENU_ITEM (file1), file1_menu);
  file1_menu_accels = gtk_menu_ensure_uline_accel_group (GTK_MENU (file1_menu));
  close1 = gtk_menu_item_new_with_label (_("Close"));
  
  gtk_widget_ref (close1);
  gtk_object_set_data_full (GTK_OBJECT (histogramme), "close1", close1,
			    (GtkDestroyNotify) gtk_widget_unref);

  gtk_container_add (GTK_CONTAINER (file1_menu), close1);

  export = gtk_menu_item_new_with_label (_("Export"));
  gtk_widget_ref (export);
  gtk_object_set_data_full (GTK_OBJECT (histogramme), "export", export,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_container_add (GTK_CONTAINER (menubar1), export);

  export_menu = gtk_menu_new ();
  gtk_widget_ref (export_menu);
  gtk_object_set_data_full (GTK_OBJECT (histogramme),
			    "export_menu",export_menu,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_menu_item_set_submenu (GTK_MENU_ITEM (export), export_menu);
  export_menu_accels = gtk_menu_ensure_uline_accel_group (GTK_MENU (export_menu));
  export_image = gtk_menu_item_new_with_label (_("Export as .ppm"));
  
  gtk_widget_ref (export_image);
  gtk_object_set_data_full (GTK_OBJECT (histogramme),
			    "export_image", export_image,
			    (GtkDestroyNotify) gtk_widget_unref);

  gtk_container_add (GTK_CONTAINER (export_menu), export_image);

  gtk_signal_connect(GTK_OBJECT(export_image), "activate",
		     GTK_SIGNAL_FUNC(on_export_activate),
		     histo);


  image = gtk_drawing_area_new();
  gtk_widget_ref (image);
  gtk_object_set_data_full (GTK_OBJECT (histogramme), "image", image,
			    (GtkDestroyNotify) gtk_widget_unref);

  
  //gtk_widget_set_usize(GTK_WIDGET (image),i+120,j+120);  

  gtk_container_add (GTK_CONTAINER (vbox1),image);
  
  gtk_signal_connect(GTK_OBJECT(image), "expose_event",
		     GTK_SIGNAL_FUNC(expose_event_callback),
		     histo);
  
  gtk_signal_connect(GTK_OBJECT(image), "destroy_event",
		     GTK_SIGNAL_FUNC(destroy_event_callback),
		     histo); 

  gtk_signal_connect (GTK_OBJECT (close1), "activate",
                      GTK_SIGNAL_FUNC (on_fermer_activate),
                      histogramme);

  gtk_widget_show_all(histogramme); 


  return histogramme;
}


