/*  descartes
 *  Copyright (C) 2001 Luc Brun
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
*/

/*
 * NE PAS EDITER CE FICHIER - il est gnr par Glade.
 */

#ifdef HAVE_CONFIG_H
#  include <config.h>
#endif

#include <sys/types.h>
#include <sys/stat.h>
#include <unistd.h>
#include <string.h>

#include "my_gtk.h"

#include "gtk_info_region.h"
#include "support.h"
#include "interface.h"

static gchar* list_name[]={"clist_geo","clist_photo","clist_topo"};
static gchar* labels_name[3][2]=
{
{"geo_ppt","geo_val"},
{"photo_ppt","photo_val"},
{"topo_ppt","topo_val"}
};

static gchar* info_name[]={"Geometrical Information",
			   "Photometrical Information",
			   "Topological Information"
};
static gchar* notebook_label[]={"info_ge","info_photo","info_topo"};


#define WIDTH  650
#define HEIGHT 450


void on_fermer1_activate                    (GtkMenuItem     *menuitem,
					     gpointer   user_data)
{
  gtk_widget_destroy(GTK_WIDGET(user_data));
}

void on_export_geo_activate  (GtkMenuItem *menuitem,
			      gpointer user_data)
{
  GtkWidget* Export_File;

  get_store_widget_ppt((GtkWidget**)&user_data,WRITE_WIDGET_PPT);

  Export_File =  create_file_selection("Nom du fichier a exporter",
				       ".csv",
				       (GtkSignalFunc)interface_export_geo_info,
				       gtk_widget_destroy);
}

void on_export_photo_activate  (GtkMenuItem *menuitem,
				gpointer user_data)
{
  GtkWidget* Export_File;

  get_store_widget_ppt((GtkWidget**)&user_data,WRITE_WIDGET_PPT);
  
  Export_File =  create_file_selection("Nom du fichier a exporter",
				       ".csv",
				       (GtkSignalFunc)interface_export_photo_info,
				       gtk_widget_destroy);
}

void on_export_topo_activate  (GtkMenuItem *menuitem,
			       gpointer user_data)
{
  GtkWidget* Export_File;

  get_store_widget_ppt((GtkWidget**)&user_data,WRITE_WIDGET_PPT);
  
  Export_File =  create_file_selection("Nom du fichier a exporter",
				       ".csv",
				       (GtkSignalFunc)interface_export_topo_info,
				       gtk_widget_destroy);
}

GtkWidget*
create_gtk_info_region (void)
{
  GtkWidget *info_region;
  GtkWidget *vbox1;
  GtkWidget *menubar,*Fichier,*file_menu,*close;
  GtkWidget *Export_Infos,*export_menu,*geo,*photo,*topo;
  GtkWidget *notebook1;
  GtkWidget *scrolledwindow;
  GtkWidget *info_ppt,*info_val,*label;
  int i;

  info_region = gtk_window_new (GTK_WINDOW_TOPLEVEL);
  gtk_object_set_data (GTK_OBJECT (info_region), "info_region", info_region);
  gtk_window_set_title (GTK_WINDOW (info_region), _("Information Regions"));
  gtk_window_set_default_size(GTK_WINDOW (info_region), WIDTH, HEIGHT);

  vbox1 = gtk_vbox_new (FALSE, 0);
  gtk_widget_ref (vbox1);
  gtk_object_set_data_full (GTK_OBJECT (info_region), "vbox_info", vbox1,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (vbox1);
  gtk_container_add (GTK_CONTAINER (info_region), vbox1);

  menubar = gtk_menu_bar_new ();
  gtk_widget_ref (menubar);
  gtk_object_set_data_full (GTK_OBJECT (info_region), "menubar_info", menubar,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (menubar);
  gtk_box_pack_start (GTK_BOX (vbox1), menubar, FALSE, TRUE, 0);

  Fichier = gtk_menu_item_new_with_label (_("File"));
  gtk_object_set_data (GTK_OBJECT (info_region), _("Fichier_info"), Fichier);
  gtk_widget_show (Fichier);
  gtk_container_add (GTK_CONTAINER (menubar), Fichier);

  file_menu = gtk_menu_new ();
  gtk_object_set_data (GTK_OBJECT (info_region), "menu_file_info", file_menu);
  gtk_menu_item_set_submenu (GTK_MENU_ITEM (Fichier), file_menu);

  close = gtk_menu_item_new_with_label (_("Close"));
  gtk_object_set_data (GTK_OBJECT (info_region), "close_info", close);
  gtk_widget_show (close);
  gtk_container_add (GTK_CONTAINER (file_menu), close);
  gtk_signal_connect (GTK_OBJECT (close), "activate",
                      GTK_SIGNAL_FUNC (on_fermer1_activate),
                      info_region);

  Export_Infos = gtk_menu_item_new_with_label (_("Export (as .csv)"));
  gtk_object_set_data (GTK_OBJECT (info_region), _("Export_Infos"), Export_Infos);
  gtk_widget_show (Export_Infos);
  gtk_container_add (GTK_CONTAINER (menubar), Export_Infos);

  export_menu = gtk_menu_new ();
  gtk_object_set_data (GTK_OBJECT (info_region), "menu_export_info", export_menu);
  gtk_menu_item_set_submenu (GTK_MENU_ITEM (Export_Infos), export_menu);

  geo = gtk_menu_item_new_with_label (_("Geometrical Information"));
  gtk_object_set_data (GTK_OBJECT (info_region), "geo_info", geo);
  gtk_widget_show (geo);
  gtk_container_add (GTK_CONTAINER (export_menu), geo);


  photo = gtk_menu_item_new_with_label (_("Photometrical Information"));
  gtk_object_set_data (GTK_OBJECT (info_region), "photo_info", photo);
  gtk_widget_show (photo);
  gtk_container_add (GTK_CONTAINER (export_menu), photo);


  topo = gtk_menu_item_new_with_label (_("Topological Information"));
  gtk_object_set_data (GTK_OBJECT (info_region), "topo_info", topo);
  gtk_widget_show (topo);
  gtk_container_add (GTK_CONTAINER (export_menu), topo);


  notebook1 = gtk_notebook_new ();
  gtk_widget_ref (notebook1);
  gtk_object_set_data_full (GTK_OBJECT (info_region), "notebook1", notebook1,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (notebook1);
  gtk_box_pack_start (GTK_BOX (vbox1), notebook1, TRUE, TRUE, 0);


  for(i=0;i<3;i++)
    {
      GtkWidget* clist=gtk_clist_new (2);
      gchar* scrolled_window_name[]={"scrolledwindow1", 
				     "scrolledwindow2", 
				     "scrolledwindow3"
      };
      
      scrolledwindow = gtk_scrolled_window_new (NULL, NULL);
      gtk_widget_ref (scrolledwindow);
      gtk_object_set_data_full (GTK_OBJECT (info_region), 
				scrolled_window_name[i],
				scrolledwindow,
				(GtkDestroyNotify) gtk_widget_unref);
      gtk_widget_show (scrolledwindow);
      gtk_container_add (GTK_CONTAINER (notebook1), scrolledwindow);
      
      gtk_widget_ref (clist);
      gtk_object_set_data_full (GTK_OBJECT (info_region), 
				list_name[i], 
				clist,
				(GtkDestroyNotify) gtk_widget_unref);
      gtk_clist_set_column_justification(GTK_CLIST(clist),
					 1,
					 GTK_JUSTIFY_CENTER);
  
      gtk_widget_show (clist);
      gtk_container_add (GTK_CONTAINER (scrolledwindow),
			 clist);

      gtk_clist_set_column_width (GTK_CLIST (clist), 0, 80);
      gtk_clist_set_column_width (GTK_CLIST (clist), 1, 80);
      gtk_clist_set_column_resizeable (GTK_CLIST(clist),
				   0,
				   TRUE);

      /* resize column automatically to its optimal width */
      gtk_clist_set_column_auto_resize (GTK_CLIST(clist),
					0,
					TRUE);



      gtk_clist_column_titles_show (GTK_CLIST (clist));

      info_ppt = gtk_label_new (_("Property"));
      gtk_widget_ref (info_ppt);
      gtk_object_set_data_full (GTK_OBJECT (info_region), 
				labels_name[i][0], 
				info_ppt,
				(GtkDestroyNotify) gtk_widget_unref);
      gtk_widget_show (info_ppt);
      gtk_clist_set_column_widget (GTK_CLIST (clist), 0, info_ppt);

      info_val = gtk_label_new (_("Value"));
      gtk_widget_ref (info_val);
      gtk_object_set_data_full (GTK_OBJECT (info_region), 
				labels_name[i][1],
				info_val,
				(GtkDestroyNotify) gtk_widget_unref);
      gtk_widget_show (info_val);
      gtk_clist_set_column_widget (GTK_CLIST (clist), 1, info_val);
      
      label = gtk_label_new (info_name[i]);
      gtk_widget_ref (label);
      gtk_object_set_data_full (GTK_OBJECT (info_region), 
				notebook_label[i], 
				label,
				(GtkDestroyNotify) gtk_widget_unref);
      gtk_widget_show (label);
      gtk_notebook_set_tab_label (GTK_NOTEBOOK (notebook1), 
				  gtk_notebook_get_nth_page
				  (GTK_NOTEBOOK (notebook1), i), 
				  label);
    }


  GtkWidget* clist_geo = lookup_widget(info_region,list_name[0]);
  
  gtk_signal_connect (GTK_OBJECT (geo), "activate",
                      GTK_SIGNAL_FUNC (on_export_geo_activate),
                      clist_geo);

  GtkWidget* clist_photo = lookup_widget(info_region,list_name[1]);

  gtk_signal_connect (GTK_OBJECT (photo), "activate",
                      GTK_SIGNAL_FUNC (on_export_photo_activate),
                      clist_photo);

  GtkWidget* clist_topo = lookup_widget(info_region,list_name[2]);

  gtk_signal_connect (GTK_OBJECT (topo), "activate",
                      GTK_SIGNAL_FUNC (on_export_topo_activate),
                      clist_topo);

  return info_region;
}

void gtk_info_region_add_property(GtkWidget* toplevel,
				  gchar* text[],
				  gtk_info_region_type_list list)
{
  GtkWidget* clist = lookup_widget(toplevel,list_name[(int)list]);

  gtk_clist_append(GTK_CLIST(clist),text);
}
