/*  descartes
 *  Copyright (C) 2001 Luc Brun
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
*/

#ifndef __HISTO1D_H__
#define __HISTO1D_H__

#include "classe.h"
#include <contour_set.h>

CLASSE(histo1d);

typedef int  (*PFprojection)(int,int,int);


extern histo1d FAIRE_histo1d         (contour_set,
				      dart,
				      PFprojection histo);

extern void    DEFAIRE_histo1d       (histo1d);

extern int     histo1d_get_value     (histo1d, int);
extern int     histo1d_get_maxX      (histo1d);
extern int     histo1d_get_minX      (histo1d);
extern int     histo1d_get_maxY      (histo1d);
extern int     histo1d_get_M1_red    (histo1d, int);
extern int     histo1d_get_M1_green  (histo1d, int);
extern int     histo1d_get_M1_blue   (histo1d, int);

extern void    histo1d_affiche_histo (histo1d);
extern void    histo1d_affiche_histo_color (histo1d self, int color);

#endif /* histo1d.h*/
