/*  descartes
 *  Copyright (C) 2001 Luc Brun
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
*/

#include "histogramme.h"
#include "gtk_histo1d.h"
#include "gtk_histo2d.h"
#include <glib.h>
#include <gnome.h>
#include "conversion.h"

int create_histogramme(contour_set contours,
		       dart f,
		       PFprojection proj,
		       gchar* title)
{  
  GtkWidget* main_widget;
  
  if(contours==NULL)
    return -1;
  
  if(!contour_set_is_face_defined(contours,f))
    return -2;
  
  if(contour_set_is_infinite(contours,f))
    return -3;
  
  histo1d histo = FAIRE_histo1d(contours,f,proj);

  /*test conversion Lab_to_RGB
  PFconversion* conv = changer_espace(RGB_to_Lab);
  PFconversion* conv1 = revenir_espace(Lab_to_RGB);

  int R=71,G=66,B=101;
  int L,a,b;

  L = conv[0](R,G,B);
  a = conv[1](R,G,B);
  b = conv[2](R,G,B);


  printf("\n");
  printf("L = ");
  printf("%d \n",L);
  printf("a = ");
  printf("%d \n",a);
  printf("b = ");
  printf("%d \n",b);
  printf("\n");


  printf("\n");
  printf("R = ");
  printf("%d \n",conv1[0](L,a,b));
  printf("G = ");
  printf("%d \n",conv1[1](L,a,b));
  printf("B = ");
  printf("%d \n",conv1[2](L,a,b));
  printf("\n");
  */

  main_widget = create_gtk_histogramme(histo,title);
  
  gtk_widget_show(main_widget);
  
  return 0;
}

int create_histo2d(contour_set contours,dart f,int p1,int p2,gchar* title)
{
  GtkWidget* main_widget;
  
  if(contours==NULL)
    return -1;
  
  if(!contour_set_is_face_defined(contours,f))
    return -2;
  
  if(contour_set_is_infinite(contours,f))
    return -3;
  
  PFconversion* conv1 = changer_espace((int)(p1/3));
  PFconversion* conv2 = changer_espace((int)(p2/3));

  PFprojection proj1 = conv1[p1-3*(int)(p1/3)];
  PFprojection proj2 = conv2[p2-3*(int)(p2/3)];

  histo2d histo = FAIRE_histo2d(contours,f,proj1,proj2);
    
  main_widget = create_gtk_histo2d(histo,title);
  
  gtk_widget_show(main_widget);

  return 0;
}
