/*  descartes
 *  Copyright (C) 2001 Luc Brun
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
*/

#ifndef __INTERFACE_H__
#define __INTERFACE_H__

#include <gtk/gtk.h>
#include "segmentation_link.h"
#include "rules_link.h"
#include "export_regions.h"
#include "histo1d.h"
#include "histo2d.h"

typedef enum {region_selection,
	      segment_selection,
	      region_englobante_selection} selection;

#define READ_WIDGET_PPT 1
#define WRITE_WIDGET_PPT 0

#define READ_HISTO 1
#define WRITE_HISTO 0

gint interface_load_image_from_name           (gchar*);
gint interface_load_segmentation_from_name    (gchar*);

gint interface_load_image                      (GtkObject *);
gint interface_load_segmentation               (GtkObject *);
gint interface_save_segmentation               (GtkObject *);
void interface_set_selection                   (selection);
void interface_apply_segmentation              (segmentation_alg);
void interface_apply_rule                      (rule_alg);
void interface_delete_selection                ();
void interface_update_selection                (int, int);

extern gint interface_export_region            (GtkObject *);
extern gboolean interface_finite_face_selected ();
extern void interface_set_export_region_mode   (export_region_kind);

/* AJOUT MODULE Pierre Guerinet*/
extern bouleen is_image_chargee                ();
extern gint interface_save_tablabel            (GtkObject *FileSelection );
extern gint interface_load_tablabel            (GtkObject *FileSelection );
extern void interface_info_region              ();
extern void on_zoom_activate_interface         ( int zfactor );



extern void interface_histo2d                  (void);

extern void interface_histogramme_R            (gpointer);
extern void interface_histogramme_G            (gpointer);
extern void interface_histogramme_B            (gpointer);
extern void interface_histogramme_I1           (gpointer);
extern void interface_histogramme_I2           (gpointer);
extern void interface_histogramme_I3           (gpointer);
extern void interface_histogramme_L            (gpointer);
extern void interface_histogramme_u            (gpointer);
extern void interface_histogramme_v            (gpointer);
extern void interface_histogramme_a            (gpointer);
extern void interface_histogramme_b            (gpointer);
extern void interface_histogramme_Y            (gpointer);
extern void interface_histogramme_I            (gpointer);
extern void interface_histogramme_Q            (gpointer);
extern void interface_histogramme_Ht           (gpointer);
extern void interface_histogramme_St           (gpointer);
extern void interface_histogramme_Lt           (gpointer);
extern void interface_histogramme_Hh           (gpointer);
extern void interface_histogramme_Sh           (gpointer);
extern void interface_histogramme_Vh           (gpointer);
extern void interface_histogramme_Hd           (gpointer);
extern void interface_histogramme_Ld           (gpointer);
extern void interface_histogramme_Sd           (gpointer);


extern void get_store_widget_ppt               (GtkWidget**, int);
extern gint interface_export_geo_info          (GtkObject*);
extern gint interface_export_photo_info        (GtkObject*);
extern gint interface_export_topo_info         (GtkObject*);

extern void get_store_histo1d                  (histo1d*, int);
extern gint interface_export_histo1d           (GtkObject*);

extern void get_store_histo2d                  (histo2d*, int);
extern gint interface_export_histo2d           (GtkObject*);

#endif
