/*  descartes
 *  Copyright (C) 2001 Luc Brun
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
*/

#include <assert.h>
#include "moments.h"

static moments tmp_moments;

#define M1 SELF(m1)
#define M0 SELF(m0)

struct moments
{
  int m1[3];
  int m0;
};

moments FAIRE_moments()
{
  INSTANCIER(moments);

  int i;
  
  for(i=0; i<3; i++)
    {
      M1[i] = 0;
    }
  M0 = 0;  
  tmp_moments = self;
  
  return self;
}

void DEFAIRE_moments(moments self)
{
  assert(self);
  
  free(self);
}

int moments_get_m1_red(moments self)
{
  assert(self);
     
  return M1[0];
}

void moments_set_m1_red(moments self,int val)
{
  assert(self);
  
  M1[0] = val;
}

int moments_get_m1_green(moments self)
{
  assert(self);

  return M1[1];
}

void moments_set_m1_green(moments self,int val)
{
  assert(self);
  
  M1[1] = val;
}

int moments_get_m1_blue(moments self)
{
  assert(self);

  return M1[2];
}

void moments_set_m1_blue(moments self,int val)
{
  assert(self);
  
  M1[2] = val;
}

int moments_get_m0(moments self)
{
  assert(self);

  return M0;
}

void moments_set_m0(moments self,int val)
{
  assert(self);
  
  M0 = val;
}
