/*  descartes
 *  Copyright (C) 2001 Luc Brun
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
*/

#include "topologie.h"

int infinite_neighbour_calc(contour_set contours,dart f)
{
  int bool=0;
  dart_list b_list;
  dart b,neighbor;

  b_list=FAIRE_dart_list();
  contour_set_give_segments_of_face(contours,f,b_list);

  dart_list_first(b_list);
  do
    {
      b=dart_list_give_current(b_list);
      if(contour_set_face_has_neighbour(contours,f,b))
	{
	  neighbor=contour_set_assoc_seg_face(contours,-b);
	
	  if (contour_set_is_infinite(contours,neighbor))
	    {
	      DEFAIRE_dart_list(b_list);
	      bool=1;
	      return bool;
	    }
	}
    }
  while(dart_list_next(b_list));

      
  DEFAIRE_dart_list(b_list);

  return bool;
}

int nb_neighbour_calc(contour_set contours,dart f)
{
  int res;
  dart_list init,neighbours;
  
  init = contour_set_give_image_faces(contours);
  
  if (dart_list_give_cardinal(init)==1)
    {
      DEFAIRE_dart_list(init);
      return 0;
    }
  dart_list_reinitialize(init);
  init=FAIRE_dart_list();
  neighbours=FAIRE_dart_list();
  dart_list_insert(init,f);
  
  
  contour_set_complete_face_adjacence(contours,init,neighbours);

  res=dart_list_give_cardinal(neighbours);

  DEFAIRE_dart_list(init);
  DEFAIRE_dart_list(neighbours);

  return res;
}


int nb_included_faces_calc(contour_set contours,dart f)
{
  int res;

  dart_list included;
  
  included = FAIRE_dart_list();
  
  contour_set_give_included_faces(contours,f,included);

  res=dart_list_give_cardinal(included);

  DEFAIRE_dart_list(included);

  return res;
}

int nb_hole_calc(contour_set contours,dart f)
{
  int res,nb_comp;
  res=0;

  dart_list included,faces;
  dart b;

  included = FAIRE_dart_list();
  faces = FAIRE_dart_list();

  contour_set_give_included_faces(contours,f,included);

  if(dart_list_give_cardinal(included)==0) 
    return 0;
  else {
    dart_list_first(included);
    do
      {
	b=dart_list_give_current(included);
	
	dart_list_reinitialize(faces); 

	contour_set_give_finite_faces(contours,b,faces);

	nb_comp=dart_list_give_cardinal(faces);

	res+=nb_comp;
      }
    while(dart_list_next(included));
  }
  
  DEFAIRE_dart_list(faces);
  DEFAIRE_dart_list(included);
  
  return res;
}
