/*  descartes
 *  Copyright (C) 2001 Luc Brun
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
*/

/*
 * NE PAS EDITER CE FICHIER - il est gnr par Glade.
 */

#ifdef HAVE_CONFIG_H
#  include <config.h>
#endif

#include <sys/stat.h>
#include <unistd.h>
#include <string.h>

#include <gnome.h>
#include "xdrawing.h"
#include "contour_set.h"

#include "callbacks_zoom.h"
#include "interface_zoom.h"
#include "support_zoom.h"
#include "chemin_euclidien.h"

gboolean xdrawing_exposure(GtkWidget *widget,GdkEventExpose *event,gpointer user_data)
{
  xdrawing_draw_selected_face(user_data);
  return TRUE;
}

GtkWidget* create_Zoom ( display dis, 
			 int zfactor, 
			 contour_set contours, 
			 dart d, 
			 unsigned char *normal_color )
{
  GtkWidget *Zoom;
  GtkWidget *vbox1;
  GtkWidget *menu;
  GtkWidget *menu_tmp;
  GtkWidget *drawingarea1;
  GtkWidget *align;
  GtkWidget *scrolled_window;
  GtkTooltips *tooltips;
  xdrawing self;
  Chemin_Eucl eucl;
  float peri, surf;

  GtkWidget* Fichier_Zoom,*Quitter;
  GtkWidget* Fond,*fond_effacer,*fond_tracer, *segments_effacer;
  GtkWidget* Chemin,*chemin_discret,*chemin_euclidien, *chemin_discret_euclidien;
  GtkWidget* Parametre,*parametre_perimetre,*parametre_surface;

  tooltips = gtk_tooltips_new ();

  Zoom = gtk_window_new (GTK_WINDOW_TOPLEVEL);
  gtk_object_set_data (GTK_OBJECT (Zoom), "Zoom", Zoom);
  gtk_tooltips_set_tip (tooltips, Zoom, N_("Fenetre de Zoom"), NULL);
  gtk_window_set_title (GTK_WINDOW (Zoom), N_("Zoom"));
  gtk_window_set_policy (GTK_WINDOW (Zoom), TRUE, TRUE, FALSE);

  vbox1 = gtk_vbox_new (FALSE, 0);
  gtk_widget_ref (vbox1);
  gtk_object_set_data_full (GTK_OBJECT (Zoom), "vbox1", vbox1,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (vbox1);
  gtk_container_add (GTK_CONTAINER (Zoom), vbox1);
  
  menu = gtk_menu_bar_new ();
  gtk_widget_ref (menu);
  gtk_object_set_data_full (GTK_OBJECT (Zoom), "menu_zoom", menu,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (menu);
  gtk_box_pack_start (GTK_BOX (vbox1), menu, FALSE, FALSE, 0);

  Fichier_Zoom = gtk_menu_item_new_with_label ("Fichier");
  gtk_object_set_data (GTK_OBJECT (Zoom), "Fichier", Fichier_Zoom);
  gtk_widget_show (Fichier_Zoom);
  gtk_container_add (GTK_CONTAINER (menu), Fichier_Zoom);

  menu_tmp = gtk_menu_new ();
  gtk_object_set_data (GTK_OBJECT (Zoom), "menu_fichier_zoom", menu_tmp);
  gtk_menu_item_set_submenu (GTK_MENU_ITEM (Fichier_Zoom), menu_tmp);

  Quitter = gtk_menu_item_new_with_label ("Quitter");
  gtk_object_set_data (GTK_OBJECT (Zoom), "Quitter", Quitter);
  gtk_widget_show (Quitter);
  gtk_container_add (GTK_CONTAINER (menu_tmp), Quitter);

  Fond = gtk_menu_item_new_with_label ("Fond");
  gtk_object_set_data (GTK_OBJECT (Zoom), "Fond", Zoom);
  gtk_widget_show (Fond);
  gtk_container_add (GTK_CONTAINER (menu), Fond);

  menu_tmp = gtk_menu_new ();
  gtk_object_set_data (GTK_OBJECT (Zoom), "menu_fond", menu_tmp);
  gtk_menu_item_set_submenu (GTK_MENU_ITEM (Fond), menu_tmp);

  fond_tracer = gtk_menu_item_new_with_label ("Image + Segments");
  gtk_object_set_data (GTK_OBJECT (Zoom), "Image + Segments", fond_tracer);
  gtk_widget_show (fond_tracer);
  gtk_container_add (GTK_CONTAINER (menu_tmp), fond_tracer);

  fond_effacer = gtk_menu_item_new_with_label ("Segments");
  gtk_object_set_data (GTK_OBJECT (Zoom), "Segments", fond_effacer);
  gtk_widget_show (fond_effacer);
  gtk_container_add (GTK_CONTAINER (menu_tmp), fond_effacer);

  segments_effacer = gtk_menu_item_new_with_label ("Fond noir");
  gtk_object_set_data (GTK_OBJECT (Zoom), "Fond noir", segments_effacer);
  gtk_widget_show (segments_effacer);
  gtk_container_add (GTK_CONTAINER (menu_tmp), segments_effacer);

  /* Les Chemins */
  Chemin = gtk_menu_item_new_with_label ("Chemin");
  gtk_object_set_data (GTK_OBJECT (Zoom), "Chemin", Zoom);
  gtk_widget_show (Chemin);
  gtk_container_add (GTK_CONTAINER (menu), Chemin);

  menu_tmp = gtk_menu_new ();
  gtk_object_set_data (GTK_OBJECT (Zoom), "menu_chemin", menu_tmp);
  gtk_menu_item_set_submenu (GTK_MENU_ITEM (Chemin), menu_tmp);

  chemin_discret = gtk_menu_item_new_with_label ("Chemin Discrets");
  gtk_object_set_data (GTK_OBJECT (Zoom), "chemin_discret", chemin_discret);
  gtk_widget_show (chemin_discret);
  gtk_container_add (GTK_CONTAINER (menu_tmp), chemin_discret);
 
  chemin_euclidien = gtk_menu_item_new_with_label ("Chemin Euclidien");
  gtk_object_set_data (GTK_OBJECT (Zoom), 
		       "chemin_euclidien", 
		       chemin_euclidien);
  gtk_widget_show (chemin_euclidien);
  gtk_container_add (GTK_CONTAINER (menu_tmp), chemin_euclidien);

  chemin_discret_euclidien  = gtk_menu_item_new_with_label ("Chemins Discrets & Euclidien");
  gtk_object_set_data (GTK_OBJECT (Zoom), "chemin_discret_euclidien", chemin_discret_euclidien);
  gtk_widget_show (chemin_discret_euclidien);
  gtk_container_add (GTK_CONTAINER (menu_tmp), chemin_discret_euclidien);

  /* Parametres */
  Parametre = gtk_menu_item_new_with_label ("Parametre");
  gtk_object_set_data (GTK_OBJECT (Zoom), "Parametre", Zoom);
  gtk_widget_show (Parametre);
  gtk_container_add (GTK_CONTAINER (menu), Parametre);

  menu_tmp = gtk_menu_new ();
  gtk_object_set_data (GTK_OBJECT (Zoom), "menu_parametre", menu_tmp);
  gtk_menu_item_set_submenu (GTK_MENU_ITEM (Parametre), menu_tmp);

  parametre_perimetre = gtk_menu_item_new_with_label ("Perimetre");
  gtk_object_set_data (GTK_OBJECT (Zoom), 
		       "parametre_perimetre", 
		       parametre_perimetre);
  gtk_widget_show (parametre_perimetre);
  gtk_container_add (GTK_CONTAINER (menu_tmp), parametre_perimetre);

  parametre_surface = gtk_menu_item_new_with_label ("Surface");
  gtk_object_set_data (GTK_OBJECT (Zoom), 
		       "parametre_surface", 
		       parametre_surface);
  gtk_widget_show (parametre_surface);
  gtk_container_add (GTK_CONTAINER (menu_tmp), parametre_surface);

  scrolled_window = gtk_scrolled_window_new (NULL, NULL);
  gtk_container_border_width (GTK_CONTAINER (scrolled_window), 1);
  gtk_scrolled_window_set_policy (GTK_SCROLLED_WINDOW (scrolled_window),
				  GTK_POLICY_AUTOMATIC,GTK_POLICY_AUTOMATIC);
  gtk_container_add(GTK_CONTAINER(vbox1),scrolled_window);
  gtk_widget_realize(scrolled_window);
  gtk_widget_set_usize(GTK_WIDGET(scrolled_window),256,256);
  gtk_widget_show (scrolled_window);

  align = gtk_alignment_new(.5,.5,.0,.0);

  gtk_scrolled_window_add_with_viewport(GTK_SCROLLED_WINDOW(scrolled_window),align);
  gtk_widget_realize(align);
  gtk_widget_show(align);

  drawingarea1 = gtk_drawing_area_new ();
  gtk_widget_ref (drawingarea1);
  gtk_object_set_data_full (GTK_OBJECT (Zoom), "drawingarea1", drawingarea1,
                            (GtkDestroyNotify) gtk_widget_unref);  
  gtk_container_add(GTK_CONTAINER(align),drawingarea1);

  self = FAIRE_xdrawing(Zoom,drawingarea1,dis,zfactor,contours,normal_color);

  // --- pour le moment
  //  if(d != -1)
  //  else
  //    xdrawing_set_bounding_box(self,

  //fprintf(stderr,"after xdrawing_set_face");
  xdrawing_set_face(self,d);
  xdrawing_draw_face(self);

  // on calcule le primtre & la surface
  eucl = FAIRE_Chemin_Eucl();
  Chemin_Eucl_compute_from_face(eucl,contours,d);
  peri = Chemin_Eucl_perimetre(eucl);
  surf = Chemin_Eucl_surface(eucl);
  DEFAIRE_Chemin_Eucl(eucl);  
//  compute_bounding_box(Contours,Sface,&Pmin,&Pmax);


  gtk_drawing_area_size(GTK_DRAWING_AREA(drawingarea1),xdrawing_get_width(self),xdrawing_get_height(self));
  gtk_widget_realize(drawingarea1);
 
  gtk_object_set_data (GTK_OBJECT (Zoom), "tooltips", tooltips);

  // definit a la fin, on est sur que tous les objets on ete crees
  gtk_signal_connect (GTK_OBJECT (chemin_discret), "activate",
                      GTK_SIGNAL_FUNC (on_chemins_discrets_zoom_activate),
                      self);

  gtk_signal_connect (GTK_OBJECT (chemin_euclidien), "activate",
                      GTK_SIGNAL_FUNC (on_chemins_euclidiens1_activate),
                      self);

  gtk_signal_connect (GTK_OBJECT (chemin_discret_euclidien), "activate",
                      GTK_SIGNAL_FUNC (on_chemins_discrets_and_euclidiens_activate),
                      self);

  gtk_signal_connect (GTK_OBJECT (Quitter), "activate",
                      GTK_SIGNAL_FUNC (on_quitter_zoom_activate),
                      self);
  gtk_signal_connect (GTK_OBJECT (fond_tracer), "activate",
                      GTK_SIGNAL_FUNC (on_tracer_fond1_activate),
                      self);

  gtk_signal_connect (GTK_OBJECT (segments_effacer), "activate",
                      GTK_SIGNAL_FUNC (on_supprimer_segments_activate),
                      drawingarea1);

  gtk_signal_connect (GTK_OBJECT (fond_effacer), "activate",
                      GTK_SIGNAL_FUNC (on_supprimer_fond1_activate),
                      self);

  gtk_signal_connect (GTK_OBJECT (parametre_perimetre), "activate",
                      GTK_SIGNAL_FUNC (on_perimetre1_activate),
                      GINT_TO_POINTER((int)(peri*100.0)));

  gtk_signal_connect (GTK_OBJECT (parametre_surface), "activate",
                      GTK_SIGNAL_FUNC (on_parametre_surface_zoom_activate),
                      GINT_TO_POINTER((int)(surf*100.0)));


  gdk_window_set_back_pixmap(drawingarea1->window,xdrawing_get_pixmap(self), 0);
 
  gdk_window_set_cursor(align->window,gdk_cursor_new(GDK_HAND1));

  gtk_signal_connect (GTK_OBJECT (drawingarea1), "expose-event",GTK_SIGNAL_FUNC (xdrawing_exposure), self);

  gtk_widget_realize(Zoom);
  gtk_widget_show(drawingarea1);
  return Zoom;
}

