/*  descartes
 *  Copyright (C) 2001 Luc Brun
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
*/


#ifndef BITMAP_H
#define BITMAP_H



#include "bitmap_gen.h"
#include "seg_tmp.h"


#define UNLIGHT         0
#define RIGHT_NEIGHBOUR 1
#define LEFT_NEIGHBOUR  2
#define UP_NEIGHBOUR    4
#define NODE_CONST      8

#define IS_NODE(val)     ((val) & NODE_CONST)
#define IS_UNLIGHT(val)  ((val) == UNLIGHT)
#define IS_INFINITE(val) ((val) == INFINITE)


#include "objet.h"
#include "classe.h"

CLASSE(bitmap);

#include "segment.h"



extern bitmap     FAIRE_bitmap  (long,long);
extern void       DEFAIRE_bitmap(bitmap);

extern void       bitmap_clear_bitmap(bitmap);

extern angle      bitmap_move_to       (bitmap, point);
extern void       bitmap_give_current  (bitmap,point);
extern angle      bitmap_give_mask     (bitmap);
extern angle      bitmap_move_in_bitmap(bitmap, move_type);

extern angle      bitmap_right_point(bitmap);
extern angle      bitmap_left_point (bitmap);
extern angle      bitmap_up_point   (bitmap);
extern angle      bitmap_down_point (bitmap);

extern void       bitmap_unlight_point(bitmap);
extern void       bitmap_make_node    (bitmap, point, bouleen);
extern void       bitmap_light_point  (bitmap, move_type, move_type, bouleen);

extern void       bitmap_draw_segment    (bitmap, seg_tmp);
extern void       bitmap_remove_seg      (bitmap, segment);
extern void       bitmap_contour_tracking(bitmap, point, move_type *,point);
extern void       bitmap_sounding        (bitmap, point,point);


extern bouleen    bitmap_has_right_neighbour       (bitmap, angle);
extern bouleen    bitmap_has_up_neighbour          (bitmap, angle);
extern bouleen    bitmap_has_left_neighbour        (bitmap, angle);
extern bouleen    bitmap_has_down_neighbour        (bitmap, angle);
extern bouleen    bitmap_has_neighbour_in_direction(bitmap,angle,move_type);

extern move_type  bitmap_give_direction           (bitmap,angle,move_type);

extern void       bitmap_save(bitmap,char*);

#endif /* BITMAP_H */


