/*  descartes
 *  Copyright (C) 2001 Luc Brun
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
*/

#ifndef __CLUSTER_H__
#define __CLUSTER_H__

#include "vector.h"
#include "type_obj.h"
#include "types.h"
#include "classe.h"

struct cluster 
{
  bouleen exist;
  int     canonic;
  vector mean;
  double sqe;
  double mom0;
  vector mom1;
  vector mom2;
};

CLASSE(cluster);

extern void    cluster_add_color_to_cluster(cluster,int[3]);
extern bouleen cluster_is_empty            (cluster);
extern void    cluster_copy                (cluster,cluster);
extern double  cluster_give_sqe            (cluster);
extern void    cluster_give_moments        (cluster,double*,vector,vector);
extern void    cluster_set_moments         (cluster,double,vector,vector);
#endif
