/*  descartes
 *  Copyright (C) 2001 Luc Brun
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
*/

#ifndef __CLUSTER_SET__H
#define __CLUSTER_SET__H

#include "matrice.h"
#include "cluster.h"
#include "classe.h"
#include "contour_set.h"
#include "partition.h"
#include "dart_tab.h"

CLASSE(cluster_set);

extern cluster_set FAIRE_cluster_set  ();
extern void        DEFAIRE_cluster_set(cluster_set);

extern void  cluster_set_init_from_face       (cluster_set,
					       contour_set contours,
					       dart,
					       partition,
					       int,
					       int);
extern void  cluster_set_init_from_set_of_face(cluster_set,
					       contour_set,
					       dart_list);  

extern int     cluster_set_give_cardinal        (cluster_set);
extern void    cluster_set_merge_cluster        (cluster_set,int,int);
extern double  cluster_set_get_dist             (cluster_set,int,int);
extern double  cluster_set_get_dist_mean        (cluster_set,int,int);
extern double  cluster_set_get_color_dist       (cluster_set,int,int);
extern int     cluster_set_give_canonic_cluster (cluster_set,int);
extern void    cluster_set_set_canonic          (cluster_set);
extern void    cluster_set_give_canonics        (cluster_set,dart_tab,int*);
extern void    cluster_set_give_table           (cluster_set,double*);
extern double  cluster_set_give_sqe_sum         (cluster_set);
extern double  cluster_set_give_global_sqe      (cluster_set);
extern double  cluster_set_give_sqe             (cluster_set,int);
extern double  cluster_set_give_color_variance  (cluster_set);
#endif


