/*  descartes
 *  Copyright (C) 2001 Luc Brun
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
*/

#ifndef __EUCLID_PATH_SET_H__
#define __EUCLID_PATH_SET_H__
#include "contour_set.h"
#include "display.h"
#include "type_obj.h"
#include "classe.h"

CLASSE(euclid_path);

extern euclid_path FAIRE_euclid_path(contour_set);
extern void        DEFAIRE_euclid_path(euclid_path);


extern void euclid_path_reinitialize(euclid_path);

extern void euclid_path_init_from_all_faces      (euclid_path,
						  contour_set);
extern void euclid_path_write_all_euclidean_paths(euclid_path ,
						  contour_set,
						  display,
						  unsigned char*);
extern void euclid_path_init_from_face(euclid_path,
				       contour_set,
				       dart);
extern void euclid_path_write_face    (euclid_path ,
				       contour_set,
				       dart,
				       display,
				       int,
				       point,
				       unsigned char*);


#endif
