/*  descartes
 *  Copyright (C) 2001 Luc Brun
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
*/

#ifndef FACE_H
#define FACE_H

#include "type_obj.h"
#include "vector.h"

#include "classe.h"
#include "objet.h"

CLASSE(face);

extern face FAIRE_face(int);
extern void DEFAIRE_face(face);

extern bouleen face_is_computed(face);

extern double  face_give_area              (face);
extern double* face_give_mean_value        (face);
extern double* face_give_moment1_value     (face);
extern void    face_give_moments           (face,double*,vector,vector);
extern double  face_give_squared_error     (face);
extern double  face_give_mean_squared_error(face);

extern void    face_merge(face,face);

extern void    face_initialize(face,double,vector,vector,int,dart);
extern void    face_uninitialize(face);

#endif /* FACE_H */
