/*  descartes
 *  Copyright (C) 2001 Luc Brun
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
*/

#ifndef __INTERFACE_H__
#define __INTERFACE_H__

#include <gtk/gtk.h>
#include "segmentation_link.h"
#include "rules_link.h"

typedef enum {region_selection,
	      segment_selection,
	      region_englobante_selection} selection;

gint interface_load_image_from_name(gchar*);
gint interface_load_segmentation_from_name(gchar*);

gint interface_load_image(GtkObject *);
gint interface_load_segmentation(GtkObject *);
gint interface_save_segmentation(GtkObject *);
void interface_set_selection(selection);
void interface_apply_segmentation(segmentation_alg);
void interface_apply_rule(rule_alg);
void interface_delete_selection();
void interface_update_selection(int,int);

// AJOUT MODULE
bouleen is_image_chargee();
gint interface_save_tablabel( GtkObject *FileSelection );
gint interface_load_tablabel( GtkObject *FileSelection );

void on_zoom_activate_interface( int zfactor );

#endif
