/*  descartes
 *  Copyright (C) 2001 Luc Brun
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
*/

#ifndef __LIST_GEN__
#define __LIST_GEN__
#include "type_obj.h"


#include "classe.h"


typedef bouleen (*PFequal)(any_ptr,any_ptr);

CLASSE(list_gen);

#define NULL_LIST_GEN (list_gen)NULL

extern void        ALLOC_list_gen();
extern void        DEALLOC_list_gen();

extern list_gen    FAIRE_list_gen();
extern void        DEFAIRE_list_gen(list_gen,void (*del)(void*));

extern void        list_gen_reinitialize(list_gen);
extern void        list_gen_insert(list_gen, any_ptr);
extern void        list_gen_copy  (list_gen,list_gen);

extern void        list_gen_first(list_gen);
extern void        list_gen_last(list_gen);

extern bouleen     list_gen_next(list_gen);
extern bouleen     list_gen_previous(list_gen);

extern void        list_gen_remove_current(list_gen);
extern bouleen     list_gen_remove_object(list_gen,PFequal,any_ptr);

extern any_ptr     list_gen_give_current(list_gen);
extern int         list_gen_give_cardinal(list_gen);

extern bouleen     list_gen_is_empty(list_gen);

#endif /* LIST_GEN_H */

