/*  descartes
 *  Copyright (C) 2001 Luc Brun
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
*/

#ifndef MAP_H
#define MAP_H
#include "objet.h"
#include "classe.h"

#include "type_obj.h"
#include "dart_list.h"

CLASSE(map);

extern map       FAIRE_map  ();
extern void      DEFAIRE_map(map);

extern void      map_merge_lambda(map, dart, dart);

extern dart      map_change_lambda_cycle(map, dart);


extern dart      map_give_sigma           (map, dart);
extern dart      map_give_sigma_1         (map, dart);
extern dart      map_give_phi             (map, dart);
extern dart      map_give_phi_1           (map, dart);
extern dart      map_give_lambda          (map, dart);
extern int       map_give_lambda_1        (map, dart);
extern bouleen   map_give_mark            (map, dart);
extern dart_list map_give_cycle_phi       (map, dart);
extern dart_list map_give_cycle_sigma     (map, dart);
extern int       map_give_card_cycle_sigma(map, dart);
extern dart_list map_give_all_faces       (map);

extern void      map_set_mark    (map, dart);
extern void      map_set_lambda_1(map, dart, dart);

extern dart      map_split(map, dart);

extern dart      map_insert_segment (map, dart, dart);
extern dart      map_insert_tangeant(map,dart);
extern dart      map_insert_map     (map);


extern void      map_remove_label    (map, dart);
extern void      map_remove_mark     (map, dart);
extern void      map_remove_all_mark (map);
extern void      map_remove_edge     (map, dart);
extern void      map_remove_node     (map, dart);
extern void      map_remove_tangeant (map,dart);
extern void      map_remove_map      (map,dart);

extern void      map_mark_face  (map,dart);
extern void      map_unmark_face(map,dart);

#endif /* MAP_H */

