/*  descartes
 *  Copyright (C) 2001 Luc Brun
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
*/

#ifndef POINT_H
#define POINT_H

#include "classe.h"
#include "move_type.h"
#include "type_obj.h"

struct point
{
  int coordx;
  int coordy;
};

CLASSE(point);

typedef struct point Point;

#define NULL_POINT ((point)NULL)

#define EGAL_POINT(P1,P2) \
( ( (P1).coordx == (P2).coordx )&&( (P1).coordy == (P2).coordy ) )

#define COORDX(P) ((P).coordx)
#define COORDY(P) ((P).coordy)
#define IS_RIGHTER_POINT(p1,p2)\
((p1).coordx > (p2).coordx)
#define AFFECTE_POINT(p1,p2) ((p1).coordx = (p2).coordx,\
			      (p1).coordy = (p2).coordy)

#define MOVE_RIGHT_POINT(p) ( (p).coordx++ )
#define MOVE_LEFT_POINT(p) ( (p).coordx--)
#define MOVE_UP_POINT(p) ( (p).coordy--)
#define MOVE_DOWN_POINT(p) ( (p).coordy++)

#define INFINITE_POINT(p) \
( ( (p).coordx == INFINITE ) && ( (p).coordy == INFINITE ) )

extern void modify_point_position (point,move_type);
extern void point_affiche         (point);
extern void point_give_adjacents  (point,move_type,point);
extern void point_translate       (point,point,move_type,move_type);
extern void point_give_right_point(point,move_type,point);
extern void  point_give_p_1_2     (point,point,point,angle*);
#endif /* POINT_H*/




