/*  descartes
 *  Copyright (C) 2001 Luc Brun
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
*/

#ifndef __RULES_LINK_H__
#define __RULES_LINK_H__

#include "remove_included_faces.h"
#include "drive_segmentation.h"
#include "remove_details.h"
#include "merge_faces.h"
#include "recursive_seg.h"
#include "meta_seg_uniform.h"
#include "meta_seg_uniform_rec.h"
#include "recursive_seg2.h"
#include "remove_all_details.h"
#include "lissage.h"

#include "rule.h"

typedef enum
{
  remove_included_faces_rule,
  split_face_rule,
  recursive_split_rule,
  recursive_split2_rule,
  meta_seg_uniform_rule,
  meta_seg_uniform_rec_rule,
  remove_details_rule,
  remove_all_details_rule,
  merge_face_by_mean_rule,
  merge_face_by_gradiant_rule,
  smooth_rule
} rule_alg;

static PFget_rule_name algo_rule[]=
{
  remove_included_faces_rule_set_algorithm,
  split_face_rule_set_algorithm,
  recursive_split_rule_set_algorithm,
  recursive_split2_rule_set_algorithm,
  meta_seg_uniform_rule_set_algorithm,
  meta_seg_uniform_rec_rule_set_algorithm,
  remove_details_rule_set_algorithm, 
  remove_all_details_rule_set_algorithm,
  merge_face_by_mean_rule_set_algorithm ,
  merge_face_by_gradiant_rule_set_algorithm,
  smooth_rule_set_algorithm
};
#endif
