/*  descartes
 *  Copyright (C) 2001 Luc Brun
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
*/

#ifndef SEG_TMP_H
#define SEG_TMP_H


#include "type_obj.h"
#include "move_type.h"
#include "point.h"
#include "image.h"
#include "tab_mark.h"

#include "classe.h"

#define SEG_TMP_EMPTY 0

CLASSE(seg_tmp);

#define NULL_SEG_TMP (seg_tmp)NULL

extern void     ALLOC_seg_tmp  ();
extern void     DEALLOC_seg_tmp();

extern seg_tmp   FAIRE_seg_tmp  ();
extern void      DEFAIRE_seg_tmp(seg_tmp);
extern void      free_seg_tmp(void*);
/******* Partie  reservee au modules de segmentations */

extern void      seg_tmp_insert_segment1  (seg_tmp,point,move_type);
extern void      seg_tmp_insert_segment2  (seg_tmp,point,move_type);
extern void      seg_tmp_unmark_seg       (seg_tmp,
					   void (*unmark_fct)(tab_mark,
							      point),
					   tab_mark);
extern seg_tmp   seg_tmp_copy_closed_curve(seg_tmp,image);

/******* Partie a utilise  pour retire des infos de seg_tmp */

extern void      seg_tmp_give_first_point  (seg_tmp,point);
extern void      seg_tmp_give_last_point   (seg_tmp ,point);
extern void      seg_tmp_give_right_point  (seg_tmp,point);
extern move_type seg_tmp_give_first_move   (seg_tmp);
extern move_type seg_tmp_give_last_move    (seg_tmp);
extern int       seg_tmp_give_longueur     (seg_tmp);
extern long      seg_tmp_give_clock        (seg_tmp);
extern dart      seg_tmp_give_dart_nb      (seg_tmp);

extern void      seg_tmp_first             (seg_tmp);
extern bouleen   seg_tmp_next              (seg_tmp);

extern void      seg_tmp_last              (seg_tmp);
extern bouleen   seg_tmp_previous          (seg_tmp);

extern move_type seg_tmp_give_current_move (seg_tmp);
extern void      seg_tmp_give_current_point(seg_tmp,point);

extern bouleen   seg_tmp_is_closed         (seg_tmp);
extern bouleen   seg_tmp_is_empty          (seg_tmp);

extern void      seg_tmp_set_dart_nb       (seg_tmp,dart);

extern void      seg_tmp_reinitialize      (seg_tmp); 
#endif /* SEG_TMP_H*/


