/*  descartes
 *  Copyright (C) 2001 Luc Brun
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
*/

#ifndef __SEGMENTATION__
#define __SEGMENTATION__

#include "type_obj.h"
#include "contour_set.h"
#include "classe.h"


CLASSE(segmentation);

typedef void (*PFcompute_params)(segmentation,contour_set,dart,double);
typedef void (*PFclose)();
typedef void (*PFinit)(segmentation);

CLASSE(segmentation_priv);

struct segmentation
{
  PFcompute_params compute_params;
  PFsame_cluster   same_cluster;
  PFclose          close_params;
  segmentation_priv private_field;
};

extern segmentation FAIRE_segmentation();
extern void         DEFAIRE_segmentation(segmentation);

extern void         segmentation_set_algorithm    (segmentation,PFinit);
extern void         segmentation_set_space        (segmentation,int);

extern int          segmentation_give_space       (segmentation);

extern void         segmentation_make_segments    (segmentation,
						   contour_set,
						   dart,
						   double);


#endif

