/*  descartes
 *  Copyright (C) 2001 Luc Brun
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
*/

#include <assert.h>

#include "bitmap_gen.h"

#include "list_gen.h"

#define List_point SELF ( list_point )

typedef struct point_list_ 
{
  Point p;
  int   attribute;
  move_type neg_move;
  move_type pos_move;

}*point_list,Point_list;


struct bitmap_gen
{
  list_gen list_point;
};

/***********************************************************************/
bitmap_gen FAIRE_bitmap_gen()
{
  INSTANCIER(bitmap_gen);

  List_point = FAIRE_list_gen();

  return self;
}
/**************************************************************************/
void DEFAIRE_bitmap_gen(bitmap_gen self)
{
  point_list ptr_free;

  list_gen_first(List_point);

  do
    {
      ptr_free = (point_list)list_gen_give_current(List_point);
      free(ptr_free);
    }
  while(list_gen_next(List_point));
  
  DEFAIRE_list_gen(List_point,free);
    
  free(self);
}

/***************************************************************************/  
void  bitmap_gen_first(bitmap_gen self)
{
  list_gen_first(List_point);
}
/*****************************************************************************/
void  bitmap_gen_last(bitmap_gen self)
{
  list_gen_last(List_point);
}
/*****************************************************************************/
bouleen bitmap_gen_next(bitmap_gen self)
{
  return list_gen_next(List_point);
}
/*****************************************************************************/
bouleen bitmap_gen_previous(bitmap_gen self)
{
  return list_gen_previous(List_point);

}
/*****************************************************************************/
void bitmap_gen_insert(bitmap_gen self,point p, int
		       attribute,move_type neg_move,move_type pos_move)
{
  point_list p_list;

  assert(p);

  p_list = (point_list)malloc(sizeof(Point_list));
  AFFECTE_POINT(p_list->p,*p);
  p_list->neg_move = neg_move;
  p_list->pos_move = pos_move;
  p_list->attribute = attribute;

  list_gen_insert(List_point,p_list);
}
/*****************************************************************************/
int bitmap_gen_current_attribute(bitmap_gen self)
{
  point_list current;

  current = (point_list)list_gen_give_current(List_point);
  
  return current->attribute;
}

void bitmap_gen_current_point(bitmap_gen self,point return_point)
{
  point_list current;

  assert(return_point);

  current = (point_list)list_gen_give_current(List_point);

  AFFECTE_POINT(*return_point,current->p);

}
/*****************************************************************************/
move_type bitmap_gen_positive_move(bitmap_gen self)
{
  point_list current;

  current = (point_list)list_gen_give_current(List_point);

  return current->pos_move;
}
/*****************************************************************************/
move_type bitmap_gen_negative_move(bitmap_gen self)
{
  point_list current;

  current = (point_list)list_gen_give_current(List_point);

  return current->neg_move;
}
/*****************************************************************************/
bouleen bitmap_gen_is_empty(bitmap_gen self)
{
  int cardinal;

  cardinal = list_gen_give_cardinal(List_point);

  return (cardinal ==0);
}
