/*  descartes
 *  Copyright (C) 2001 Luc Brun
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
*/

#ifndef __conversion__
#define __conversion__

/* Espace RGB to espace X */  
#define RGB_to_RGB     0
#define RGB_to_I1I2I3  1
#define RGB_to_Luv     2
#define RGB_to_Lab     3
#define RGB_to_YIQ     4
#define RGB_to_HSL     5
#define RGB_to_HSV     6
#define RGB_to_HLS     7
#define RGB_to_H1H2H3  8
#define RGB_to_V1V2V3  9
#define RGB_to_K1K2K3 10
#define RGB_to_T1T2T3 11

/* Espace X to Espace RGB */
#define I1I2I3_to_RGB  1
#define Luv_to_RGB     2
#define Lab_to_RGB     3
#define YIQ_to_RGB     4
#define HSL_to_RGB     5
#define HSV_to_RGB     6
#define HLS_to_RGB     7
#define H1H2H3_to_RGB  8
#define V1V2V3_to_RGB  9
#define K1K2K3_to_RGB 10
#define T1T2T3_to_RGB 11 


typedef int (*PFconversion)(int,int,int);

extern PFconversion* changer_espace(int);
extern PFconversion* revenir_espace(int);
#endif


