/*  descartes
 *  Copyright (C) 2001 Luc Brun
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
*/

#define __NO_MOVES__
#include "point.h"
#include "types.h"
#include "type_obj.h"
#include "image.h"
#include "display.h"
#include <glib.h>
#include "objet.h"
#include <gdk_imlib.h>

#define SELFISH(obj,champ) (obj->champ)

#define Child      SELF(child)
#define Draw_point  SELF(draw_point)
#define Draw_line SELF(draw_line)

#define Indices    SELF(indices)
#define Width      SELF(width)
#define Lenght     SELF(lenght)


struct display
{
  any_ptr child;
  PFdisplay_pt draw_point;
  PFdisplay_line draw_line;

// DISPLAY_COLOR* indices;

  unsigned char *indices;
  int width;
  int lenght;
};
static void make_table_of_indices_priv(display,image);

//--- fonctions rajoutes ---
//--- begin ---
inline bouleen display_draw_point_is_set(display self)
{
  return (Draw_point == DRAW_POINT_NULL);
}

//--- end ---

display FAIRE_display(image img)
{
  INSTANCIER(display);

  Width = image_give_largeur(img); 
  Lenght = image_give_hauteur(img);

  Draw_point = DRAW_POINT_NULL;
  Draw_line = DRAW_LINE_NULL;

  make_table_of_indices_priv(self,img);

  return self;
}

void DEFAIRE_display(display self)
{
  free(self);
}

void display_set_child(display self,any_ptr obj)
{
  Child = obj;
}
void display_set_draw_point(display self,PFdisplay_pt draw)
{
  Draw_point = draw;
}
void display_set_draw_line(display self,PFdisplay_line draw)
{
  Draw_line = draw;
}

int display_give_width(display self)
{
  return Width;
}
int display_give_lenght(display self)
{
  return Lenght;
}
void display_draw_point(display self,point p,unsigned char* col)
{
  Draw_point(Child,p,col);
}

void display_draw_line(display self,float x1,float y1,float x2,float y2)
{
  Draw_line(Child,x1,y1,x2,y2);
}

unsigned char *display_give_point_value( display self, point p)
{
  int dep;
  int i,j;

  assert(self);
  assert(p);
  
  i = COORDY(*p);
  j = COORDX(*p);
  
  assert( (i<Lenght) && (i>=0) );
  assert( (j<Width ) && (j>=0) );

  dep = (Width*i+j)*3;

  return (Indices+dep);
}

static void make_table_of_indices_priv(display self,image img)
{
//  DISPLAY_COLOR *tab;
  unsigned char *tab;

  int* pixel;
  int dim;
  int i;

  dim = image_give_dim(img);
  
  /* On initialize L'image dans la ximage */
  Indices = (unsigned char *)malloc(Width*Lenght*3);
  assert(Indices);

  tab = Indices;
  image_debut(img);
  do
    {
      do
	{

	  pixel = image_lire_pixel(img);	  	  

	  for( i = 0; i < dim; i++ )
	    tab[i] = (unsigned char)pixel[i];

	  tab+=dim;
	}
      while( image_pixel_droite(img) );
    }
  while( image_pixel_suivant(img) );
}

GdkImlibImage *display_give_gdk_imlib_image( display self )
{
  GdkImlibImage *tmp;
  tmp = gdk_imlib_create_image_from_data(Indices,
					 NULL,
					 Width,
					 Lenght);
  assert(tmp);
  return tmp;
}


/*static DISPLAY_COLOR make_pixel_priv(int* pixel)
  {
  DISPLAY_COLOR val;
  
  val = pixel[2];
  val+= ((DISPLAY_COLOR)pixel[1])<<8;
  val += ((DISPLAY_COLOR)pixel[0])<<16;
  

  return val;
  }*/
