/*  descartes
 *  Copyright (C) 2001 Luc Brun
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
*/

#define SEUIL_VAR 200.0

#include "segmentation_link.h"
#include "rule.h"
#include "drive_segmentation.h"


void drive_segmentation(contour_set contours,
			dart f,
			double ecart_max,
			int space)
{
  double var;
  segmentation seg;

  assert(contours);
  assert(f);

  seg = FAIRE_segmentation();
  var = contour_set_give_face_variance(contours,f);

  printf("variance :%lf\n",var);

  if ( (var <SEUIL_VAR) )
    segmentation_set_algorithm(seg,algo_seg[local_segmentation]);
  else
    segmentation_set_algorithm(seg,algo_seg[global_segmentation]);
  
  segmentation_make_segments(seg,contours,f,ecart_max);
  
  DEFAIRE_segmentation(seg);
}

void split_face_rule_set_algorithm(rule father)
{
  father->specified_rule = split_face_rule_algorithm;
}
void split_face_rule_algorithm(contour_set contours,
			       dart f,
			       va_list arg_list)
{
  double ecart_max;
  int space;
  
  ecart_max = va_arg(arg_list,double);
  space     = va_arg(arg_list,int);
  drive_segmentation(contours,f,ecart_max,space);
}

