/*  descartes
 *  Copyright (C) 2001 Luc Brun
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
*/

#include <assert.h>

#include "node_set.h"


#define Table    SELF (table)

struct node_set
{
  hash_table  table;
};

node_set FAIRE_node_set()
{
  node n; 
  Point p;
  INSTANCIER(node_set);

  Table = FAIRE_hash_table();

  /* On s'occupe du noeud de l'ecran */
  COORDX(p) = -1;
  COORDY(p) = -1;
  n = FAIRE_node(&p,1);
  node_set_insert_node(self,n);

  return self;
}    

void DEFAIRE_node_set(node_set self)
{
  assert(self);
  DEFAIRE_hash_table(Table);
  free(self);
}

/*---------------------------------------------------------------------------*/
bouleen node_set_is_node(node_set self, point p)
{
  assert(self);
  assert(p);

  return hash_table_is_in(Table,p);
}
/*---------------------------------------------------------------------------*/
node node_set_give_node(node_set self, point p)
{
  assert(self);
  assert(p);
  return  hash_table_give_node(Table,p);
}

/*---------------------------------------------------------------------------*/
void node_set_insert_node(node_set self, node n)
{
  assert(self);
  assert(n);
  hash_table_insert(Table, n);
}
/*---------------------------------------------------------------------------*/
void node_set_remove_node(node_set self, point p)
{
  node  n;

  assert(self);
  assert(p);
  n = hash_table_give_node(Table,p); 
  assert(n);
  hash_table_remove_elt(Table,p);
  DEFAIRE_node(n);
}

hash_table node_set_give_hash_table(node_set self)
{
  assert(self);
  return Table;
}


