/*  descartes
 *  Copyright (C) 2001 Luc Brun
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
*/

#include <stdio.h>
#include <assert.h>
#include "point_set.h"





#define Main_tab     SELF (main_tab)
#define Cardinal     SELF (cardinal)
#define Nb_ligne     SELF (nb_ligne)
#define Taille_ligne SELF(taille_ligne)


#define ALLOC_NB_LIGNE 50

#define NUM_LIGNE(n) ((n)/(Taille_ligne))
#define NUM_COLONNE(n) ((n)%Taille_ligne)

static void private_realloc_point_set(point_set);
 
struct point_set
{    
  point *main_tab;
  int   cardinal;
  int   nb_ligne;
  int   taille_ligne;
};

point_set FAIRE_point_set(int taille_ligne)
{
  INSTANCIER(point_set);

  Taille_ligne = taille_ligne;
  Main_tab = (point *) malloc(ALLOC_NB_LIGNE*sizeof(point));

  *Main_tab = (point) malloc(Taille_ligne*sizeof(Point));
  Cardinal = 0;
  Nb_ligne = 1;
  
  return self;
}

/*---------------------------------------------------------------------------*/
/* Ne supprime pas les segments stocke, voir si c'est souhaitable */
/*---------------------------------------------------------------------------*/
void DEFAIRE_point_set(point_set self)
{
  point *tmp;
  int i;
  
  assert(self);

  tmp = Main_tab;

  for(i=0;i<Nb_ligne;i++)
    {
      free (*tmp);
      tmp++;
    }
  free(Main_tab);
  free(self);
}


/*---------------------------------------------------------------------------*/
void point_set_initialize(point_set self)
{
  assert(self);
  Cardinal =0;
}
point point_set_give_point(point_set self, int num)
{
  int ligne,colonne;
  static Point p;

  if (num < 0) num = -num;

  assert(self);
  assert(num < Cardinal);


  ligne  = NUM_LIGNE(num);
  colonne = NUM_COLONNE(num);
  
  while(ligne >= Nb_ligne)
    private_realloc_point_set(self);
  
  
  AFFECTE_POINT(p,Main_tab[ligne][colonne]);
  
  return &p;
}
void  point_set_insert_point(point_set self,point p)
{
  int ligne,colonne;

  assert(self);
  assert(p);

  ligne  = NUM_LIGNE(Cardinal);
  colonne = NUM_COLONNE(Cardinal);
  
  while(ligne >= Nb_ligne)
    private_realloc_point_set(self);
  
  AFFECTE_POINT(Main_tab[ligne][colonne],*p);

  Cardinal++;

}

int point_set_give_cardinal(point_set self)
{
  assert(self);
  
  return Cardinal;
}
static void private_realloc_point_set(point_set self)
{
  assert(self);
  /* On regarde si on na pas depasse le nb max de ligne alloue */
  if(Nb_ligne%ALLOC_NB_LIGNE == 0)
    {
      Main_tab = (point*)realloc(Main_tab,
				 (Nb_ligne+ALLOC_NB_LIGNE)*
				 sizeof(point*));
      assert(Main_tab);
    }
  Main_tab[Nb_ligne] = (point)malloc(Taille_ligne*sizeof(Point));
  Nb_ligne++;
}






