/*  descartes
 *  Copyright (C) 2001 Luc Brun
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
*/

#include "rule.h"
#include "remove_all_details.h"
#include "merge_faces.h"
#include "tab_mark_dart.h"


static void remove_all_details(contour_set contours,
			       dart unused,
			       va_list list)
{
  dart_list all_face,seg_to_del;
  dart f;
  double image_var;
  tab_mark_dart merge_faces;
  Point p;
  bouleen meta_face;
  guint threshold;
  
  threshold = va_arg(list,guint);
  image_var  = contour_set_give_image_variance(contours);
  
  
  merge_faces = FAIRE_tab_mark_dart();
  seg_to_del = FAIRE_dart_list();
  all_face = contour_set_give_image_faces(contours);
  dart_list_first(all_face);
  do
    {
      f = dart_list_give_current(all_face);
      move_face_to_specified_area(contours,
				  f,
				  threshold,
				  image_var,
				  merge_faces,
				  seg_to_del,
				  &p,
				  &meta_face);
    }
  while(dart_list_next(all_face));

  contour_set_remove_set_of_arc(contours,seg_to_del);

  DEFAIRE_tab_mark_dart(merge_faces);
  DEFAIRE_dart_list(all_face);
  DEFAIRE_dart_list(seg_to_del);
}
void remove_all_details_rule_set_algorithm(rule father)
{
  father->specified_rule = remove_all_details;
}







