/*  descartes
 *  Copyright (C) 2001 Luc Brun
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
*/

#include <assert.h>
#include <glib.h>

#include "rule.h"
#include "remove_details.h"



static void remove_details_priv                     (contour_set,
						     dart,
						     va_list);
static void remove_details_give_segments_to_del_priv(contour_set,
						     dart,
						     dart_list,
						     guint);

static void remove_details_give_segments_to_del_priv(contour_set contours,
						     dart f,
						     dart_list b_list,
						     guint seuil)
{
  double current_area,f_area;
  dart current_face;
  dart_list included_face;

  assert(contours);
  assert(f>0);
  
  if(contour_set_is_infinite(contours,f))
    return;
  

  f_area = contour_set_give_face_area(contours,f);
  included_face = contour_set_give_all_finite_faces(contours,f);
  if(dart_list_is_empty(included_face))
    {
      DEFAIRE_dart_list(included_face);
      return;
    }

  dart_list_first(included_face);
  do
    {
      current_face = dart_list_give_current(included_face);
      current_area = contour_set_give_face_area(contours,current_face);
      if(current_area <= seuil)
	merge_face_by_mean_give_segments_to_delete(contours,
						   current_face,
						   b_list);
    }
  while(dart_list_next(included_face));
  
  DEFAIRE_dart_list(included_face);
}
static void remove_details_priv(contour_set contours,
				dart f,
				va_list list)
{
  list_gen removed_seg;
  dart_list b_to_remove;
  guint seuil;

  b_to_remove = FAIRE_dart_list();
  seuil   = va_arg(list,guint);

  
  contour_set_remove_double_arc_of_face(contours,f);
  remove_details_give_segments_to_del_priv(contours,
					   f,
					   b_to_remove,
					   seuil);
 
  
  contour_set_remove_set_of_arc(contours,b_to_remove);
  
  DEFAIRE_dart_list(b_to_remove);
}

void remove_details_rule_set_algorithm(rule father)
{
  father->specified_rule = remove_details_priv;
}



