/*  descartes
 *  Copyright (C) 2001 Luc Brun
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
*/

#include <assert.h>
#include "rule.h"

static void remove_included_faces(contour_set contours,
				  dart f,
				  va_list arg_list)
{
  dart_list included_faces;
  dart current_face;

  assert(contours);
  assert(f>0);
  
  contour_set_remove_double_arc_of_face(contours,f);
  included_faces = FAIRE_dart_list();
  contour_set_give_included_faces(contours,f,included_faces);

  if(dart_list_is_empty(included_faces))
    {
      DEFAIRE_dart_list(included_faces);
      return;
    }

  dart_list_first(included_faces);  
  do
    {      
      current_face = dart_list_give_current(included_faces);
      contour_set_remove_face(contours,current_face);
    }
  while(dart_list_next(included_faces));
  
  DEFAIRE_dart_list(included_faces);
}

void remove_included_faces_rule_set_algorithm(rule father)
{
  father->specified_rule = remove_included_faces;
}
