/*  descartes
 *  Copyright (C) 2001 Luc Brun
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
*/

#include <assert.h>
#include "rule.h"
#include "objet.h"
#include "garbage.h"

#define Specified_rule SELF(specified_rule)

static rule alloc_rule_priv();
static void dealloc_rule_priv(rule);

static garbage rules_collector;

void ALLOC_rule()
{ 
  rules_collector = FAIRE_garbage();
}
void DEALLOC_rule()
{
  DEFAIRE_garbage(rules_collector,free);
}

rule FAIRE_rule()
{
  rule self;
  
  self = alloc_rule_priv();

  return self;
}
void DEFAIRE_rule(rule self)
{
  dealloc_rule_priv(self);
}
void rule_specify_rule(rule self,PFget_rule_name get_rule_name )
{
  get_rule_name(self);
}
void rule_apply_rule(rule self,contour_set contours,dart f,...)
{
  va_list arg_list;
  va_start(arg_list,f);
  Specified_rule(contours,f,arg_list);
  va_end(arg_list);
}
static rule alloc_rule_priv()
{
  rule self;

  if(garbage_is_empty(rules_collector))
    {
      self = (rule)malloc(sizeof(struct rule));
      assert(self);
      return self;
    }
  
  return garbage_give_object(rules_collector);
}
static void dealloc_rule_priv(rule self)
{
  garbage_insert_object(rules_collector,self);
}



