/*  descartes
 *  Copyright (C) 2001 Luc Brun
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
*/

#include <stdio.h>
#include <malloc.h>
#include <math.h>
#include "segmente_local.h"



static  void    init_params_priv           (segmentation,
					    contour_set,
					    dart,
					    double);
static  bouleen same_cluster_criterion_priv(point,int*,point,int*);
static  void    do_nothing();
  
static double mean[DIM_MAX];
static double main_color_area;

void segmente_local_exp_init_segmente(segmentation seg)
{
  seg->compute_params = init_params_priv;
  seg->same_cluster   = same_cluster_criterion_priv;
  seg->close_params   = do_nothing;
}
static void do_nothing()
{
}
  /*******************************************/
 /* Calcule l'histograme associe a l'image  */
/*******************************************/
static void init_params_priv(segmentation seg,
			     contour_set contours,
			     dart f,
			     double ecart_max)	
{
  double var,ecart;
  printf("Segmente local\n");
  if(ecart_max <=0.0)
    {
      printf("ecart max intra classe non valide\n");
      printf("entrez en un nouveau ");
      scanf("%lf",&ecart_max);
    }

  ecart = ecart_max/100.0;
  contour_set_give_face_mean(contours,f,mean);
  var = contour_set_give_face_variance(contours,f);
  main_color_area = -log(ecart)*var;
}

static bouleen same_cluster_criterion_priv(point p1,
					   int* pixel1,
					   point p2,
					   int* pixel2)
{
  bouleen pix1_belong_main_cluster;
  bouleen pix2_belong_main_cluster;
  
  double dist;
  int i;

  dist =0.0;
  for(i=0;i<3;i++)
    dist += (pixel1[i]-mean[i])*(pixel1[i]-mean[i]);
  
  pix1_belong_main_cluster = (dist < main_color_area);

  
  dist =0.0;
  for(i=0;i<3;i++)
    dist += (pixel2[i]-mean[i])*(pixel2[i]-mean[i]);

  pix2_belong_main_cluster = (dist < main_color_area);
  
  if ( pix1_belong_main_cluster && pix2_belong_main_cluster )
    return vrai;
  
  if ( (!pix1_belong_main_cluster) && (!pix2_belong_main_cluster) )
    return vrai;

  return faux;
}





