/*  descartes
 *  Copyright (C) 2001 Luc Brun
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
*/

#include "vector.h"
#include <assert.h>

double vector_dist(vector v1,vector v2,int dim)
{
  int i;
  double dist;

  assert(dim<=DIM_MAX);

  dist = 0;
  for(i=0;i<dim;i++)
    dist += (v1[i]-v2[i])*(v1[i]-v2[i]);

  return dist;
}

void vector_equal_plus(vector v1,vector v2,int dim)
{
  int i;

  assert(dim<=DIM_MAX);

  for(i=0;i<dim;i++)
    v1[i] += v2[i];
} 
void vector_divide(vector v1,vector v2,double denum,int dim)
{
  int i;
  
  assert(denum);
  assert(dim<=DIM_MAX);
  
  for(i=0;i<dim;i++)
    v1[i] = v2[i]/denum;
}
