/*  descartes
 *  Copyright (C) 2001 Luc Brun
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
*/

#ifdef HAVE_CONFIG_H
#  include <config.h>
#endif

#include <gnome.h>

#include "callbacks_zoom.h"
#include "interface_zoom.h"
#include "support_zoom.h"
#include "xdrawing.h"
#include "my_gtk.h"
#include <stdio.h>
#include <string.h>

static char global_msg[50];

static char *peri_msg =  " La face a un perimetre de ";
static char *surf_msg =  " La face a une surface de ";

void
on_quitter_zoom_activate                   (GtkMenuItem     *menuitem,
					    gpointer         user_data)
{
  GtkWidget *zoom = xdrawing_get_parent(user_data);
  DEFAIRE_xdrawing(user_data);
  gtk_widget_destroy(zoom);
  
}


void
on_supprimer_fond1_activate            (GtkMenuItem     *menuitem,
                                        gpointer         user_data)
{
  xdrawing_unset_background(user_data);
}


void
on_tracer_fond1_activate               (GtkMenuItem     *menuitem,
                                        gpointer         user_data)
{
  xdrawing_set_background(user_data);
}


void
on_chemins_discrets_zoom_activate          (GtkMenuItem     *menuitem,
					    gpointer         user_data)
{
  xdrawing_set_mode(user_data,sharp);
  xdrawing_draw_selected_face(user_data);
}


void
on_chemins_euclidiens1_activate        (GtkMenuItem     *menuitem,
                                        gpointer         user_data)
{
  xdrawing_set_mode(user_data,smooth);
  xdrawing_draw_selected_face(user_data);
}

void on_chemins_discrets_and_euclidiens_activate ( GtkMenuItem   *menuitem,
						   gpointer user_data
						   )
{
  xdrawing_set_mode(user_data,sharp_and_smooth);
  xdrawing_draw_selected_face(user_data);
}  

void on_supprimer_segments_activate ( GtkMenuItem *menuitem,
				      gpointer user_data )
{

  GdkColor black;
  GdkGC *gc = gdk_gc_new(GTK_WIDGET(user_data)->window);
  GdkColormap *cmap = gdk_window_get_colormap(GTK_WIDGET(user_data)->window);
  gdk_color_black(cmap,&black);
  gdk_window_set_background(GTK_WIDGET(user_data)->window,&black);
  gdk_window_clear(GTK_WIDGET(user_data)->window);
  gdk_window_hide(GTK_WIDGET(user_data)->window);
  gdk_window_show(GTK_WIDGET(user_data)->window);
}
 
  

void
on_perimetre1_activate                 (GtkMenuItem     *menuitem,
                                        gpointer         user_data)
{
  strncpy(global_msg,peri_msg,strlen(peri_msg));
  snprintf(global_msg+strlen(peri_msg),15,"%.2f pixels ",((float)GPOINTER_TO_INT(user_data))/100.0);
  create_dialog(global_msg,gtk_widget_destroy);
}


void
on_parametre_surface_zoom_activate                   (GtkMenuItem     *menuitem,
						      gpointer         user_data)
{
  strncpy(global_msg,surf_msg,strlen(peri_msg));
  snprintf(global_msg+strlen(surf_msg),15,"%.2f pixels",((float)GPOINTER_TO_INT(user_data))/100.0);
  create_dialog(global_msg,gtk_widget_destroy);
}


void
on_aide1_activate                      (GtkMenuItem     *menuitem,
                                        gpointer         user_data)
{

}

