#ifdef HAVE_CONFIG_H
#  include <config.h>
#endif

#include <gnome.h>

#include "callbacks_zoom.h"
#include "interface_zoom.h"
#include "support_zoom.h"
#include "xdrawing.h"
#include "my_gtk.h"
#include <stdio.h>
#include <string.h>

static char global_msg[50];

static char *peri_msg =  " Le Perimetre de la face est : ";
static char *surf_msg =  " La Surface de la face est : ";

void
on_quitter_zoom_activate                   (GtkMenuItem     *menuitem,
					    gpointer         user_data)
{
  GtkWidget *zoom = xdrawing_get_parent(user_data);
  DEFAIRE_xdrawing(user_data);
  gtk_widget_destroy(zoom);
  
}


void
on_supprimer_fond1_activate            (GtkMenuItem     *menuitem,
                                        gpointer         user_data)
{
  xdrawing_unset_background(user_data);
}


void
on_tracer_fond1_activate               (GtkMenuItem     *menuitem,
                                        gpointer         user_data)
{
  xdrawing_set_background(user_data);
}


void
on_chemins_discrets_zoom_activate          (GtkMenuItem     *menuitem,
					    gpointer         user_data)
{
  xdrawing_set_mode(user_data,sharp);
  xdrawing_draw_selected_face(user_data);
}


void
on_chemins_euclidiens1_activate        (GtkMenuItem     *menuitem,
                                        gpointer         user_data)
{
  xdrawing_set_mode(user_data,smooth);
  xdrawing_draw_selected_face(user_data);
}

void on_chemins_discrets_and_euclidiens_activate ( GtkMenuItem   *menuitem,
						   gpointer user_data
						   )
{
  xdrawing_set_mode(user_data,sharp_and_smooth);
  xdrawing_draw_selected_face(user_data);
}  

void on_supprimer_segments_activate ( GtkMenuItem *menuitem,
				      gpointer user_data )
{

  GdkColor black;
  GdkGC *gc = gdk_gc_new(GTK_WIDGET(user_data)->window);
  GdkColormap *cmap = gdk_window_get_colormap(GTK_WIDGET(user_data)->window);
  gdk_color_black(cmap,&black);
  gdk_window_set_background(GTK_WIDGET(user_data)->window,&black);
  gdk_window_clear(GTK_WIDGET(user_data)->window);
  gdk_window_hide(GTK_WIDGET(user_data)->window);
  gdk_window_show(GTK_WIDGET(user_data)->window);
}
 
  

void
on_perimetre1_activate                 (GtkMenuItem     *menuitem,
                                        gpointer         user_data)
{
  strncpy(global_msg,peri_msg,strlen(peri_msg));
  snprintf(global_msg+strlen(peri_msg),15,"%f",xdrawing_get_perimetre(user_data));
  create_dialog(global_msg,gtk_widget_destroy);
}


void
on_parametre_surface_zoom_activate                   (GtkMenuItem     *menuitem,
						      gpointer         user_data)
{
  strncpy(global_msg,surf_msg,strlen(peri_msg));
  snprintf(global_msg+strlen(surf_msg),15,"%f",xdrawing_get_surface(user_data));
  create_dialog(global_msg,gtk_widget_destroy);
}


void
on_aide1_activate                      (GtkMenuItem     *menuitem,
                                        gpointer         user_data)
{

}

