#define SEUIL_VAR 200.0

#include "segmentation_link.h"
#include "rule.h"
#include "drive_segmentation.h"


void drive_segmentation(contour_set contours,
			dart f,
			double ecart_max,
			int space)
{
  double var;
  segmentation seg;

  assert(contours);
  assert(f);

  seg = FAIRE_segmentation();
  var = contour_set_give_face_variance(contours,f);

  printf("variance :%lf\n",var);

  if ( (var <SEUIL_VAR) )
    segmentation_set_algorithm(seg,algo_seg[local_segmentation]);
  else
    segmentation_set_algorithm(seg,algo_seg[global_segmentation]);
  
  segmentation_make_segments(seg,contours,f,ecart_max);
  
  DEFAIRE_segmentation(seg);
}

void split_face_rule_set_algorithm(rule father)
{
  father->specified_rule = split_face_rule_algorithm;
}
void split_face_rule_algorithm(contour_set contours,
			       dart f,
			       va_list arg_list)
{
  double ecart_max;
  int space;
  
  ecart_max = va_arg(arg_list,double);
  space     = va_arg(arg_list,int);
  drive_segmentation(contours,f,ecart_max,space);
}

