#include <stdio.h>
#include <math.h>
#include <malloc.h>
#include "mfk.h"
#include "rule.h"
#include "macros.h"
#include "types.h"
#include "image.h"
#include "arbre.h"
#include "definitions.h"
#include "quantification.h"
#include "display.h"
#include "ximage.h"
#include "xdrawing.h"
#include "point.h"
#include "segmentation.h"
#include "rules_link.h"
#include "segmentation_link.h"
#include "euclid_path_set.h"
#include "chemin_euclidien.h"
#include "chargement_seg.h"

#define NB_IMAGE 1
#define NB_MAX_DE_COULEUR 256

#define SHELL_GRAPHIC_NAME    "Fenetre_image"
#define TOP_GRAPHIC_NAME      "fenetre_image"
#define GRAPHIC_NAME          "image"

#define ZOOM_NAME             "Zoom"
#define ZOOM_WIDGET_NAME      "fenetre_zoom"
#define ZOOM_IMAGE_NAME       "*image_zoom"

#define AFF_SURF              "*affiche_surface"
#define AFF_PERI              "*affiche_perimetre"
#define CALLBACK(nom,fct)    WcRegisterCallback(app,nom,fct,"rien");
 
/* Amelioration a faire au lieu d' avoir des tableaux locaux de */
/* ximage, largeur,hauteur, cree un tableau de structures */
/* largeur,hauteur, ximage :global, et passe tab+nb_d_image ds la */
/* XtCallbackStruck*/


static Comp_rgb couleur_normal;
static Comp_rgb couleur_selection;

static Widget widget_zoom;
static Widget drawing;
static unsigned long  correspondance[NB_MAX_DE_COULEUR];
static ximage ximg;
static Colormap palette_image;

static double ecart_max      = 30.0;
static int espace            = 6;
static bouleen select_face   = vrai;
static bouleen select_seg    = faux;
static bouleen existe        = vrai;
static contour_set contours  = NULL_CONTOUR_SET;
static bouleen image_chargee = faux;
static dart selected_face    = 1;
static segmentation seg_algorithms;
static rule regle;
static output_segment selected_segment;
static Point p_mouse;
static display gen_disp;
static xdrawing draw_zoom;
static euclid_path euclids;
static int scale_zoom;
static bouleen euclid_mode;
static Point p_min,p_max;
static point p_mini;

static void CreerFenetreZoom(int);
static void WriteEuclideanFaceZoom(xdrawing,point);
static void WriteDiscreteFaceZoom(xdrawing,point);

typedef void (*PFcallback)();



void selectioner_meilleur_visual_pseudo_color (Display *AppDisplay,
					       int screen, 
					       XVisualInfo *vinfo)
{

  XVisualInfo *visual_list;
  int number_visual = 0;
  XVisualInfo info_select;
  
  
  info_select.class  = PseudoColor;
  info_select.screen = screen;
  info_select.depth  = 8;
  
  visual_list = XGetVisualInfo(AppDisplay,
			       VisualClassMask|
			       VisualScreenMask|
			       VisualDepthMask,
			       &info_select,
			       &number_visual); 
  
  if(visual_list == NULL)
    {
      fprintf(stderr,"Visual introuvable\n");
      XFree((char *) visual_list);
      return;
    }

  *vinfo = visual_list[0];

  XFree((char *) visual_list);

}

Status pseudo_couleur(Widget w)
{
    Status resultat;
    Display *aff = XtDisplay(w);
    int ecran = DefaultScreen(aff);
    XVisualInfo infos;
    Visual *type_affichage;

    resultat =  XMatchVisualInfo(aff,
				 ecran,
				 DefaultDepth(aff,ecran),
				 PseudoColor,
				 &infos);
    
    return(resultat);
}
void CopyColor(XColor* coul1,XColor* coul2)
{
	coul1->red   = coul2->red;
	coul1->green = coul2->green ;
	coul1->blue  = coul2->blue;
	coul1->pixel = coul2->pixel;
	coul1->flags = coul2->flags;
	coul1->pad   = coul2->pad;
}
void Allouer_la_palette(Widget w,
			image table_de_couleur,
			unsigned long *cellules,
			Colormap* palette,
			XVisualInfo* vinfo)
{
    Display *aff = XtDisplay(w);
    int ecran = XDefaultScreen(aff);
    XColor coul_appli[4],coul[NB_MAX_DE_COULEUR];
    Window fenetre = RootWindow(aff,ecran);
    int R,G,B;
    int i,erreur;
    int *tab_cour;
    int nb_de_couleur = image_give_largeur(table_de_couleur);
    int* pixel;
    int nb_couleur_total = nb_de_couleur +6;
    Kidget_color *col = MkGetColors(MkKidget("menu1"));
	
    coul_appli->pixel = col->fg;
    XQueryColor(mKdisplay,DefaultColormap(mKdisplay,DefaultScreen(mKdisplay)),coul_appli);
    
   coul_appli[1].pixel = col->bg;
    XQueryColor(mKdisplay,DefaultColormap(mKdisplay,DefaultScreen(mKdisplay)),coul_appli+1);
    
    coul_appli[2].pixel = col->ts;
    XQueryColor(mKdisplay,DefaultColormap(mKdisplay,DefaultScreen(mKdisplay)),coul_appli+2);
  
    coul_appli[3].pixel = col->bs;
    XQueryColor(mKdisplay,DefaultColormap(mKdisplay,DefaultScreen(mKdisplay)),coul_appli+3);
    
   *palette = XCreateColormap(aff,
			      fenetre,
			      vinfo->visual,
			      AllocNone);
    printf("\nnb de couleurs =%d,palette = %d\n\n",nb_de_couleur,*palette);
	
    	

    if(!(erreur=XAllocColorCells(aff,
				 *palette,
				 FALSE,
				 NULL,
				 0,
				 cellules,
				 (unsigned int)nb_couleur_total
				 )
	 ))
      {
	fprintf(stderr,
		" main.c : Allocation de couleurs impossible( erreur%d) : \n",
		erreur);
	return;
      }
    
    printf("nb de bits utilises : %d\n",vinfo->bits_per_rgb);
    i=0;
    image_debut(table_de_couleur);
    do
      {
	while(cellules[i]== col->fg || cellules[i] == col->bg ||
	      cellules[i]== col->ts || cellules[i] == col->bs)
	   	i++;
	   
	pixel  = image_lire_pixel(table_de_couleur);
	
	coul[i].red   = pixel[0] << 8;
	coul[i].green = pixel[1] << 8 ;
	coul[i].blue  = pixel[2] << 8;
	coul[i].pixel = cellules[i];
	coul[i].flags = DoRed|DoGreen|DoBlue;
#ifdef DEBUG
	printf("%d,%d,%d ->coul.r =%d,coul.v=%d,coul.b=%d cellule =%d\n",
	       pixel[0],pixel[1],pixel[2],
	       coul[i].red,coul[i].green,coul[i].blue,cellules[i]);
#endif
	i++;
      }
    while( image_pixel_suivant(table_de_couleur) );

    while(cellules[i]== col->fg || cellules[i] == col->bg ||
	   cellules[i]== col->ts || cellules[i] == col->bs)
		i++;
    /* Le vert servira a ecrire les segments */
    coul[i].red =0;
    coul[i].green = 255<<8;
    coul[i].blue =0;
    coul[i].pixel = cellules[i];
    coul[i].flags = DoRed|DoGreen|DoBlue;

    couleur_normal = i;
	i++;
  while(cellules[i]== col->fg || cellules[i] == col->bg ||
	   cellules[i]== col->ts || cellules[i] == col->bs)
		i++;

    coul[i].red =255<<8;
    coul[i].green = 0;
    coul[i].blue =0;
    coul[i].pixel = cellules[i];
    coul[i].flags = DoRed|DoGreen|DoBlue;

    couleur_selection = i;

     CopyColor(coul+col->fg,coul_appli);
     CopyColor(coul+col->bg,coul_appli+1);
     CopyColor(coul+col->ts,coul_appli+2);
     CopyColor(coul+col->bs,coul_appli+3);
    XStoreColors(aff,*palette,coul,i+1);    
}

void ReflexeQuitter(Widget w, XtPointer client_data, XtPointer cb)
{

  if(contours != NULL_CONTOUR_SET)
    {
      DEFAIRE_contour_set(contours);
      DEFAIRE_ximage(ximg);
    }
    DEALLOC_tab_move();
    DEALLOC_seg_tmp();
    DEALLOC_output_segment();
    DEALLOC_rule();
    DEALLOC_dart_list(); 
    DEALLOC_tab_mark_dart();   

    DEALLOC_list_gen();
    exit(0);
}
	   
void ReflexeFichier(Widget w, XtPointer client_data, XtPointer cb)
{
    if (MkChoiceData(client_data)==4) MkManageChild("warning_fin");
}

void ReflexeLireValeur(Widget w,
		       XtPointer p1,
		       XtPointer cb)
{
    char *chaine=MkFieldGetString("finessefield"); 

    ecart_max = atof(chaine);
    
    printf("L'ecart intra classe  maximum  est fixe a :%f\n",ecart_max);
}
void  EvenementSelectPoint(Widget drawing_area,XtPointer p1,XEvent*evt)
{
  dart b;

  COORDX(p_mouse) = evt->xbutton.x;
  COORDY(p_mouse) = evt->xbutton.y;
  
  if (select_face)
    {
      if(existe)
	ximage_draw_face(ximg,contours,selected_face,couleur_normal);
      selected_face = contour_set_assoc_point_face(contours,&p_mouse);
      ximage_draw_face(ximg,contours,selected_face,couleur_selection);
    }
  if (select_seg)
    {
      if (existe)
	ximage_draw_segment(ximg,selected_segment,couleur_normal);
      
      b = contour_set_assoc_point_arc(contours,&p_mouse);
      contour_set_extend_seg(contours,b);
      contour_set_give_segment(contours,b,selected_segment);
      ximage_draw_segment(ximg,selected_segment,couleur_selection);
    }

  ximage_display(ximg,drawing_area);
  existe = vrai;
}
void ReflexeRafraichissement(Widget drawing_area,
			     XtPointer rien,
			     XtPointer cb)
{
  ximage_display(ximg,drawing_area);
}

void ReflexeChargement(Widget w, XtPointer client_data, XtPointer cb)
{
   switch(MkChoiceData(client_data))
   {
   	case 0:
   		MkManageChild("chargeimagewin");
   		break;
   	
   	case 2:
   		MkManageChild("chargesegwin");
   		break;   	
   }
}
 
void ReflexeSauvegarde(Widget w, XtPointer client_data, XtPointer cb)
{
   switch(MkChoiceData(client_data))
   {
   	case 0:
   		MkManageChild("sauvwin");
   		break;
   }
}
 
void ReflexeFinesseSegmentation(Widget w, XtPointer client_data, XtPointer cb)
{
   switch(MkChoiceData(client_data))
   {
   	case 0:
   		MkManageChild("finessewin");
   		break;
   }
}

void ReflexeChargementImage (Widget w,
			     XtPointer client_data,
			     XtPointer cb		       
			     )
{
  static nb_de_couleur = 250;
  XmFileSelectionBoxCallbackStruct *retour_reflexe=(XmFileSelectionBoxCallbackStruct
  *)cb;
  char *nom_fichier;
  int indice_coul;
  char nom_nettoye[100];
  int n,i,j,ncouleurs;
  size_t taille = sizeof(Comp_rgb);
  int* pixel;
  image image_chargement,table_couleur;
  Comp_rgb *tab,*table_d_indice;
  arbre_binaire arbre;
  int largeur,hauteur;
  Widget drawing_area;
  
  /* decalarations X*/
  unsigned long cellules[NB_MAX_DE_COULEUR];
  Display *aff = mKdisplay;
  GC gc;
  XGCValues valeur;
  XVisualInfo vinfo;
  int ecran = XDefaultScreen(aff);
  Colormap palette;
  Kidget_color *col = MkGetColors(MkKidget("menu1"));
  
  if (!XmStringGetLtoR(retour_reflexe->value,
		       XmSTRING_DEFAULT_CHARSET,
		       &nom_fichier))
	{       
	  fprintf (stderr,"getting filename error\n");
	  return;
	}

  printf ("Nom du fichier a charger=%s\n", nom_fichier);
  
  image_chargement = FAIRE_image();
  if(image_charger(image_chargement,nom_fichier) ==-1)
    {
      fprintf(stderr,"Image Non Lue, pas pxm ou inexistante\n");
      return;
    }

  if(!pseudo_couleur(w))
    {
      fprintf(stderr,"Pas d'ecran Pseudo couleur sur ce terminal.\n");
      fprintf(stderr,"AFFichage de l'image impossible\n");
      DEFAIRE_image(image_chargement);
      return;
    }
  image_chargee = vrai;				/* on libere un flag */
						/* permettant le */
                                             /* chargement d'un segmentation */
  selectioner_meilleur_visual_pseudo_color(aff,ecran,&vinfo);
  
  if(vinfo.colormap_size < nb_de_couleur)
    nb_de_couleur = vinfo.colormap_size;
  
  /* On cree la table de couleur propre a l'image */
  quantification_creer_table(image_chargement,
			     &arbre,
			     &table_couleur,
			     250,
			     &nb_de_couleur,
			     1,0,0,espace,0);
  /* On transvase cette table dans la table de couleur X */
  Allouer_la_palette(w,
		     table_couleur,
		     cellules,
		     &palette,
		     &vinfo);
  /* On cree la fenetre shell contenant la drawing area */
/*  XtVaSetValues(MkWidget("imagedraw"),XmNcolormap,palette,NULL);*/
 /* XtSetArg(argsw[2],XtNvisual,  vinfo.visual); n++;*/
  
      
  drawing_area = MkWidget("imagedraw");

  largeur = image_give_largeur(image_chargement);
  hauteur = image_give_hauteur(image_chargement);     

  XtVaSetValues(drawing_area, XmNheight, hauteur+1, XmNwidth, largeur+1, NULL);
  XtVaSetValues(XtParent(drawing_area), XmNheight, hauteur+1, XmNwidth, largeur+1, NULL);
	
  XSetWindowColormap(mKdisplay,XtWindow(XtParent(XtParent(drawing_area))),palette);
  MkManageChild("imagewin");
  
  j=0;
  for(i=0;i<250;i++)
  {
  	while(cellules[j]==col->bg || 
  	      cellules[j]==col->fg ||
  	      cellules[j]==col->ts ||
  	      cellules[j]==col->bs ||
  	      cellules[j]==couleur_normal ||
  	      cellules[j]==couleur_selection)
  	      j++; 
    correspondance[i] = cellules[j];
    j++;
    }
  gen_disp = FAIRE_display(image_chargement,
			   arbre,
			   espace);
  /* On cree l'ximage */
  gc =XtGetGC(drawing_area,0,&valeur);
  aff = XtDisplay(drawing_area);
  ximg = FAIRE_ximage(aff,
		      &vinfo,
		      gen_disp,
		      correspondance,
		      couleur_normal);

  DEFAIRE_image(image_chargement);
  DEFAIRE_arbre_binaire(arbre);
  drawing          = drawing_area;
  palette_image    = palette;
/* Allocation des objets utilises tout au long du programme */
  draw_zoom        = FAIRE_xdrawing(gen_disp);
  contours         = FAIRE_contour_set(nom_fichier);
  seg_algorithms   = FAIRE_segmentation();
  regle            = FAIRE_rule();
  selected_segment = FAIRE_output_segment();

  euclids          = FAIRE_euclid_path(contours);  
  ximage_draw_face(ximg,contours,selected_face,couleur_selection);
  /* On affiche l'ximage dans la drawing area */
  ximage_display(ximg,drawing_area);
}	       
void ReflexeChargementSegmentation(Widget w,
				   XtPointer client_data,
				   XtPointer cb
				   )
{
  char *nom_fichier;
  XmFileSelectionBoxCallbackStruct *retour_reflexe=(XmFileSelectionBoxCallbackStruct
  *)cb;
  char nom_nettoye[100];
  int n,i,j;
  int* pixel;
  image image_seg;
  int largeur,hauteur;
  
  if(!image_chargee)
    return;
  
  
  if (!XmStringGetLtoR(retour_reflexe->value,
		       XmSTRING_DEFAULT_CHARSET,
		       &nom_fichier))
    {       
      fprintf (stderr,"getting filename error\n");
	  return;
    }
  
  printf ("Nom du fichier a charger=%s\n", nom_fichier);
  
  
  if(open_load_seg(contours,nom_fichier) != 0)    
    return;
  do_load_seg();
  close_load_seg();
  ximage_redraw_all(ximg,contours,couleur_normal,couleur_selection);
  ximage_display(ximg,drawing);
}
void SetScale1()
{
  scale_zoom = 1;
  CreerFenetreZoom(scale_zoom);
}
void SetScale2()
{
  scale_zoom = 2;
  CreerFenetreZoom(scale_zoom);
}
void SetScale4()
{
  scale_zoom = 4;
  CreerFenetreZoom(scale_zoom);
}
void SetScale10()
{
  scale_zoom = 10;
  CreerFenetreZoom(scale_zoom);
}
void SetDiscreteMode()
{
  euclid_mode = faux;
  xdrawing_draw_face(draw_zoom,
		     contours,
		     selected_face,
		     scale_zoom,
		     couleur_selection);
}
void SetEuclidianMode()
{

  euclid_mode = vrai;
  compute_bounding_box(contours,selected_face,&p_min,&p_max);
  WriteEuclideanFaceZoom(draw_zoom,&p_min);
}



void ReflexeRafraichissementZoom(Widget w,
				 XtPointer client_data,
				 XtPointer p2)
{

  if(euclid_mode)
    {
      WriteEuclideanFaceZoom(draw_zoom,p_mini);
      return;
    }

  xdrawing_draw_face(draw_zoom,
		     contours,
		     selected_face,
		     scale_zoom,
		     couleur_selection);

}
static void CreerFenetreZoom(int scale)
{
  Widget top_zoom;
  Widget drawing_area;
  Arg argsw[10];
  int n;
  Display *aff = mKdisplay;
  Colormap palette;
  XVisualInfo vinfo;
  int ecran = XDefaultScreen(aff);
  int width,lenght;
  const int x_band = 10;
  const int y_band = 10;
  Point orig = {x_band,y_band};
  Kidget_color *col = MkGetColors(MkKidget("zoommenu"));
  Widget parent1,parent2,parent3,parent4;
  Widget h_bar,v_bar;
  unsigned long   h_bar_height,v_bar_width;
  int    width_total,lenght_total;
  int    width_ecran,lenght_ecran;

  if(!select_face)
    return;
  

  compute_bounding_box(contours,selected_face,&p_min,&p_max);
  width = COORDX(p_max) - COORDX(p_min);
  lenght = COORDY(p_max)- COORDY(p_min);

  selectioner_meilleur_visual_pseudo_color(aff,ecran,&vinfo);
  palette = palette_image;

     
  drawing_area = MkWidget("zoomdraw");
  parent1      = XtParent(drawing_area);
  parent2      = XtParent(parent1);
  parent3      = XtParent(parent2);
  parent4      = XtParent(parent3);

  MkManageChild("zoomwin");
  XtVaGetValues(parent2,
		XmNhorizontalScrollBar,&h_bar,
		NULL);
  XtVaGetValues(parent2,
		XmNverticalScrollBar,&v_bar,
		NULL);

  XtVaSetValues(v_bar,
		XmNwidth,30,
		NULL);

  XtVaGetValues(v_bar,
		XmNwidth,&v_bar_width,
		NULL);
  XtVaGetValues(h_bar,
		XmNheight,&h_bar_height,
		NULL);
  v_bar_width = 30;
  h_bar_height = 30;

  lenght_total = scale*lenght + 2*y_band + h_bar_height;
  width_total  = scale*width  + 2*x_band + v_bar_width;

  lenght_ecran = aff->screens[ecran].height;
  width_ecran = aff->screens[ecran].width;
  
  width_total = (width_total > width_ecran?width_ecran:width_total);
  lenght_total = (lenght_total > lenght_ecran?lenght_ecran:lenght_total);

  XtVaSetValues(drawing_area,
  		XmNheight,scale*lenght + 2*y_band,
  		XmNwidth ,scale*width  + 2*x_band, 
  		XmNbackground, col->bg,
  		NULL);
  XtVaSetValues(parent3,
  		XmNheight,lenght_total,
  		XmNwidth, width_total,
  		NULL);

  XSetWindowColormap(mKdisplay,
  		    XtWindow(parent4),
  		    palette);

  euclid_path_reinitialize(euclids);
  euclid_path_init_from_face(euclids,contours,selected_face);

  xdrawing_set_drawing_and_origin(draw_zoom,
				  drawing_area,
				  correspondance,
				  &orig);
  xdrawing_set_background(draw_zoom,
			  &p_min,&p_max,
			  scale);
  euclid_mode = vrai;
/*  WriteEuclideanFaceZoom(draw_zoom,&p_min);*/
  p_mini = &p_min;
}
static void WriteEuclideanFaceZoom(xdrawing draw_zoom,point p_mini)
{
  display_set_child(gen_disp,draw_zoom,xdrawing_draw_point_gen);

  euclid_path_write_face(euclids,
			 contours,
			 selected_face,
			 gen_disp,
			 scale_zoom,
			 p_mini,
			 couleur_normal);
}
void AfficherCheminDiscrets()
{
  ximage_redraw_all(ximg,contours,couleur_normal,couleur_selection);
  ximage_display(ximg,drawing);
}
void AfficherSurface()
{
  float surf;
  Widget aff_surf;
  char messg[80];
  XmString string_messg;
  Arg args[10];
  int n;
  Chemin_Eucl eucl;

  eucl = FAIRE_Chemin_Eucl();
  Chemin_Eucl_compute_from_face(eucl,contours,selected_face);
  surf = Chemin_Eucl_surface(eucl);
  DEFAIRE_Chemin_Eucl(eucl);

  aff_surf = MkWidget("info_widget");
  sprintf(messg,"Cette Face a une surface de %f",surf);
  string_messg = XmStringCreate(messg,XmSTRING_DEFAULT_CHARSET);

  n=0;
  XtSetArg(args[n],XmNmessageString,string_messg);n++;
  XtSetValues(aff_surf,args,n);
  XtManageChild(aff_surf);

}
void AfficherPerimetre()
{
  float peri;
  Widget aff_peri;
  char messg[80];
  XmString string_messg;
  Arg args[10];
  int n;
  Chemin_Eucl eucl;

  eucl = FAIRE_Chemin_Eucl();
  Chemin_Eucl_compute_from_face(eucl,contours,selected_face);
  peri = Chemin_Eucl_perimetre(eucl);
  DEFAIRE_Chemin_Eucl(eucl);

  aff_peri = MkWidget("info_widget");
  sprintf(messg,"Cette Face a un perimetre de %f",peri);
  string_messg = XmStringCreate(messg,XmSTRING_DEFAULT_CHARSET);
  n=0;
  XtSetArg(args[n],XmNmessageString,string_messg);n++;
  XtSetValues(aff_peri,args,n);
  XtManageChild(aff_peri);
}


void ReflexeSauvegardeSegmentation(Widget w,XtPointer
				   p1,XtPointer cb)
{
  char *nom_fichier;
  XmFileSelectionBoxCallbackStruct *retour_reflexe=(XmFileSelectionBoxCallbackStruct
  *)cb;
  if (! XmStringGetLtoR(retour_reflexe->value,
			XmSTRING_DEFAULT_CHARSET,
			&nom_fichier)
      )
    {  
      fprintf (stderr,"getting filename error\n");
      return;
    }
  
  printf ("Nom du fichier a sauvegarder= %s\n",nom_fichier);
  contour_set_save(contours,nom_fichier);
}
void SelectionFace()
{
  if (existe)
    {
      if (select_face)
	ximage_draw_face(ximg,contours,selected_face,couleur_normal);
      
      if (select_seg)
	ximage_draw_segment(ximg,selected_segment,couleur_normal);
    }
  printf("J'ai selectione la face\n");

  select_seg  = faux;
  select_face = vrai;
  existe      = faux;
}
void SelectionSegment()
{
  if (existe)
    {
      if (select_face)
	ximage_draw_face(ximg,contours,selected_face,couleur_normal);
      
      if (select_seg)
	ximage_draw_segment(ximg,selected_segment,couleur_normal);
    }
  printf("J'ai selectione le segment\n");    

  select_face = faux;
  select_seg  = vrai;
  existe      = faux;
}
void SplitFace()
{
  
  dart_list face_list;

  if(!select_face)
    return;

  if(contour_set_is_infinite(contours,selected_face))
    return;

  if(existe)
    ximage_draw_face(ximg,contours,selected_face,couleur_normal);

  contour_set_memorize_inserted_faces(contours);


  rule_specify_rule(regle,SPLIT_FACE);
  rule_apply_rule(regle,contours,selected_face,ecart_max,espace);

  face_list = FAIRE_dart_list();
  contour_set_give_inserted_faces(contours,face_list);
  ximage_draw_set_of_faces(ximg,contours,face_list,couleur_normal);
  
  ximage_display(ximg,drawing);

  DEFAIRE_dart_list(face_list);
  existe = vrai;
}
void SplitRec()
{
  
  if(!select_face)
     return;
   
   if(contour_set_is_infinite(contours,selected_face))
     return;

   if(existe)
     ximage_draw_face(ximg,contours,selected_face,couleur_normal);
   

  rule_specify_rule(regle,RECURSIVE_SPLIT);
  rule_apply_rule(regle,contours,selected_face,
		  ximg,drawing,couleur_normal,ecart_max,espace);
  
  ximage_redraw_all(ximg,contours,couleur_normal,couleur_selection);
  ximage_display(ximg,drawing);
  existe = faux;
}

void MetaSegUniformRec()
{
  
  if(!select_face)
     return;
   
   if(contour_set_is_infinite(contours,selected_face))
     return;

  if(existe)
    ximage_draw_face(ximg,contours,selected_face,couleur_normal);
   

  rule_specify_rule(regle,META_SEG_UNIFORM_REC);
  rule_apply_rule(regle,
		  contours,
		  selected_face,
		  ecart_max,
		  ximg,
		  drawing,
		  couleur_normal);
  
  ximage_redraw_all(ximg,contours,couleur_normal,couleur_selection);
  ximage_display(ximg,drawing);
  existe = faux;
}
void MetaSegUniform()
{
  
  if(!select_face)
     return;
   
   if(contour_set_is_infinite(contours,selected_face))
     return;

   if(existe)
     ximage_draw_face(ximg,contours,selected_face,couleur_normal);
   

  rule_specify_rule(regle,META_SEG_UNIFORM);
  rule_apply_rule(regle,contours,selected_face,ecart_max,
		  ximg,drawing,couleur_normal);
  
  ximage_redraw_all(ximg,contours,couleur_normal,couleur_selection);
  ximage_display(ximg,drawing);
  existe = faux;
} 
void SegmentationGlobale()
{
  dart_list face_list;

  if(!select_face)
    return;

  if(contour_set_is_infinite(contours,selected_face))
    return;

  if(existe)
    ximage_draw_face(ximg,contours,selected_face,couleur_normal);

  
  contour_set_memorize_inserted_faces(contours);

  segmentation_set_algorithm(seg_algorithms,GLOBAL_SEGMENTATION);
  segmentation_make_segments(seg_algorithms,contours,selected_face,ecart_max);
  
  face_list = FAIRE_dart_list();
  contour_set_give_inserted_faces(contours,face_list);
  ximage_draw_set_of_faces(ximg,contours,face_list,couleur_normal);

  ximage_display(ximg,drawing);

  DEFAIRE_dart_list(face_list);
  existe = vrai;

}
void SegmentationUniforme()
{
  dart_list face_list;
  int nb_face_cree;

  if(!select_face)
    return;

  if(contour_set_is_infinite(contours,selected_face))
    return;

  if(existe)
    ximage_draw_face(ximg,contours,selected_face,couleur_normal);

  contour_set_memorize_inserted_faces(contours);


  segmentation_set_algorithm(seg_algorithms,UNIFORM_SEGMENTATION);
  segmentation_make_segments(seg_algorithms,contours,selected_face,ecart_max);

  face_list = FAIRE_dart_list();
  contour_set_give_inserted_faces(contours,face_list);
  ximage_draw_set_of_faces(ximg,contours,face_list,couleur_normal);

  ximage_display(ximg,drawing);
  nb_face_cree = dart_list_give_cardinal(face_list);
  printf("%d faces ont etes crees \n",nb_face_cree);
  DEFAIRE_dart_list(face_list);
  existe = vrai;
}

void SegmentationLocale()
{
  dart_list face_list;

  if(!select_face)
    return;

  if(contour_set_is_infinite(contours,selected_face))
    return;

  if(existe)
    ximage_draw_face(ximg,contours,selected_face,couleur_normal);

  contour_set_memorize_inserted_faces(contours);


  segmentation_set_algorithm(seg_algorithms,LOCAL_SEGMENTATION);
  segmentation_make_segments(seg_algorithms,contours,selected_face,ecart_max);

  face_list = FAIRE_dart_list();
  contour_set_give_inserted_faces(contours,face_list);
  ximage_draw_set_of_faces(ximg,contours,face_list,couleur_normal);

  ximage_display(ximg,drawing);

  DEFAIRE_dart_list(face_list);
  existe = vrai;
}
void SegmentationLocaleExp()
{
  dart_list face_list;
  
  if(!select_face)
    return;

  if(contour_set_is_infinite(contours,selected_face))
    return;

  if(existe)
    ximage_draw_face(ximg,contours,selected_face,couleur_normal);

  contour_set_memorize_inserted_faces(contours);


  segmentation_set_algorithm(seg_algorithms,LOCAL_EXP_SEGMENTATION);
  segmentation_make_segments(seg_algorithms,contours,selected_face,ecart_max);

  face_list = FAIRE_dart_list();
  contour_set_give_inserted_faces(contours,face_list);
  ximage_draw_set_of_faces(ximg,contours,face_list,couleur_normal);

  ximage_display(ximg,drawing);

  DEFAIRE_dart_list(face_list);
  existe = vrai;
}

void SelectionFaceIncluante()
{
  
  if(!select_face)
    return;

  if(!contour_set_is_infinite(contours,selected_face))
    return;

  if(existe)
    ximage_draw_face(ximg,contours,selected_face,couleur_normal);
  
  selected_face =  contour_set_give_including_face(contours,
						   selected_face);
  
  ximage_draw_face(ximg,contours,selected_face,couleur_selection);

  ximage_display(ximg,drawing);
  existe = vrai;
}
void Effacement()
{
  list_gen seg_list;
  dart b;

  if(!existe)
    return;

  contour_set_memorize_modified_segments(contours);

  if(select_face)
      contour_set_remove_face(contours,selected_face);

  if(select_seg)
    {
      b = output_segment_give_dart_nb(selected_segment);
      contour_set_remove_arc(contours,b);
    }
  seg_list = FAIRE_list_gen();
  contour_set_give_modified_segments(contours,seg_list);

  ximage_erase_set_of_segments(ximg,seg_list);

  ximage_display(ximg,drawing);

  DEFAIRE_list_gen(seg_list,free_output_segment);
  existe = faux;
}
void EffaceFacesEnglobees()
{
  dart_list included_faces;
  list_gen seg_list;

  if(!select_face)
    return;

  contour_set_memorize_modified_segments(contours);
  
  contour_set_remove_double_arc_of_face(contours,selected_face);

  rule_specify_rule(regle,REMOVE_INCLUDED_FACES);
  rule_apply_rule(regle,contours,selected_face);
  
  seg_list = FAIRE_list_gen();
  contour_set_give_modified_segments(contours,seg_list);
  ximage_erase_set_of_segments(ximg,seg_list);  
  DEFAIRE_list_gen(seg_list,free_output_segment);

  ximage_display(ximg,drawing);
}
void EffaceDetails()
{
  list_gen seg_list;
  
  if(!select_face)
    return;

  if (contour_set_is_infinite(contours,selected_face) )
    return ;

  seg_list = FAIRE_list_gen();

  rule_specify_rule(regle,REMOVE_DETAILS);
  rule_apply_rule(regle,contours,selected_face,seg_list);

  ximage_erase_set_of_segments(ximg,seg_list);

  DEFAIRE_list_gen(seg_list,free_output_segment);

  ximage_display(ximg,drawing);
}
void EffaceDetailsGlobal()
{
  

  rule_specify_rule(regle,REMOVE_ALL_DETAILS);
  rule_apply_rule(regle,contours,0);

  ximage_redraw_all(ximg,contours,couleur_normal,couleur_selection);
  ximage_display(ximg,drawing);
  existe = faux;
}
void Lissage()
{
  if(!select_face)
    return;

  /*  if(contour_set_is_infinite(contours,selected_face))
    return*/

  rule_specify_rule(regle,SMOOTHING);
  rule_apply_rule(regle,contours,selected_face,ximg,drawing);

  ximage_redraw_all(ximg,contours,couleur_normal,couleur_selection);
  ximage_display(ximg,drawing);
  existe = faux;
}
void  CalculTousLesCheminsEuclidiens()
{

  euclid_path_reinitialize(euclids);
  euclid_path_init_from_all_faces(euclids,contours);
  ximage_erase_all(ximg);
  display_set_child(gen_disp,ximg,ximage_draw_point_gen);
  euclid_path_write_all_euclidean_paths(euclids,
					contours,
					gen_disp,
					couleur_normal);
  ximage_display(ximg,drawing);
}
void  CalculCheminsEuclidiensFace()
{
  Point zero = {0,0};
  
  if(!select_face)
    return;

  euclid_path_reinitialize(euclids);
  display_set_child(gen_disp,ximg,ximage_draw_point_gen);
  ximage_erase_face(ximg,contours,selected_face);

  euclid_path_init_from_face(euclids,contours,selected_face);

  euclid_path_write_face(euclids,
			 contours,
			 selected_face,
			 gen_disp,
			 1,
			 &zero,
			 couleur_normal);
  ximage_display(ximg,drawing);

}

void ReflexeFaceEuclidienne(Widget w, XtPointer client_data, XtPointer cb)
{
   switch(MkChoiceData(client_data))
   {
   	case 0:
   		CalculCheminsEuclidiensFace();
   		break;
   }
}
void ReflexeEffacement(Widget w, XtPointer client_data, XtPointer cb)
{

   switch(MkChoiceData(client_data))
   {
   	case 0:
   		Effacement();
  		break;
   }
}


void ReflexeMenuZoom(Widget w, XtPointer client_data, XtPointer cb)
{
  switch(MkChoiceData(client_data))
    {
    case 0:
      break;
    case 2:
      break;
    case 4:
      break;
    case 6:
      xdrawing_unset_background(draw_zoom);
      MkUnmanageChild("zoomwin"); 
      break;
    }
}
void ReflexeFondZoom(Widget w, XtPointer client_data, XtPointer cb)
{
  switch(MkChoiceData(client_data))
    {
    case 0:
      xdrawing_erase_all(draw_zoom);
      break;
    case 2:
      xdrawing_restore_background(draw_zoom);
      break;
    }
}
void ReflexeHelp(Widget w, XtPointer client_data, XtPointer cb)
{
   switch(MkChoiceData(client_data))
   {
   	case 0:
 		MkManageChild("help_win");
   		break;
   }
}

void ReflexeCarteEuclidienne(Widget w, XtPointer client_data, XtPointer cb)
{
   switch(MkChoiceData(client_data))
   {
   	case 0:
   		CalculTousLesCheminsEuclidiens();
   		break;
   	case 2:
   		AfficherCheminDiscrets();
   		break;
   }
}

void ReflexeZoomParametres(Widget w, XtPointer client_data, XtPointer cb)
{
   switch(MkChoiceData(client_data))
   {
   	case 0:
   		AfficherSurface();
   		break;
   	case 2:
   		AfficherPerimetre();
   		break;
   }
}

void ReflexeZoomChemins(Widget w, XtPointer client_data, XtPointer cb)
{
   switch(MkChoiceData(client_data))
   {
   	case 0:
   		SetEuclidianMode();
   		break;
   	case 2:
   		SetDiscreteMode();
   		break;
   }
}
/*
void ReflexeEffaceZoom(Widget w, XtPointer client_data, XtPointer cb)
{
   switch(MkChoiceData(client_data))
   {
   	case 0:
   		WriteEuclidianFaceZoom();
   		break;
   }
}
*/
void ReflexeSelection(Widget w, XtPointer client_data, XtPointer cb)
{
   switch(MkChoiceData(client_data))
   {
   	case 0:
   		SelectionFace();   		
   		break;
   	case 2:
   		SelectionSegment();
   		break;
   	case 4:
   		SelectionFaceIncluante();
   		break;
   }
}

void ReflexeZoom(Widget w, XtPointer client_data, XtPointer cb)
{
   switch(MkChoiceData(client_data))
   {
   	case 0:
   		SetScale1();
   		break;
   	case 2:
   		SetScale2();
   		break;
   	case 4:
   		SetScale4();
   		break;
   	case 6:
   		SetScale10();
   		break;
   }
}

void ReflexeRegles(Widget w, XtPointer client_data, XtPointer cb)
{
   switch(MkChoiceData(client_data))
   {
   	case 0:
   		EffaceFacesEnglobees();
   		break;
   	case 2:
   		EffaceDetails();
   		break;
   	case 4:
   		EffaceDetailsGlobal();
   		break;
   	case 6:
   		SplitFace();
   		break;
   	case 8:
   		SplitRec();
   		break;
   	case 10:
   		MetaSegUniformRec();
   		break;
   	case 12:
   		MetaSegUniform();
   		break;
   	case 14:
   		Lissage();
   		break;
   }
}

void ReflexeSegmentation(Widget w, XtPointer client_data, XtPointer cb)
{
   switch(MkChoiceData(client_data))
   {
   	case 0:
   		SegmentationGlobale();
   		break;
   	case 2:
   		SegmentationUniforme();
   		break;
   	case 4:
   		SegmentationLocale();
   		break;
   	case 6:
   		SegmentationLocaleExp();
   		break;
   }
}

void register_callback()
{
    MkAddCB(ReflexeFichier);		/* menu Fichier */
    MkAddCB(ReflexeHelp);		/* menu Help */
    MkAddCB(ReflexeFinesseSegmentation);/* menu Finesse */
    MkAddCB(ReflexeChargement);		/* sous-menu Chargement */
    MkAddCB(ReflexeSauvegarde);		/* sous-menu Sauvegarde */
    MkAddCB(ReflexeRafraichissement);	/* expose drawing image */
    MkAddCB(ReflexeRafraichissementZoom);	/* expose drawing zoom */
    MkAddCB(ReflexeLireValeur);		/* ok dialogue finesse */
    MkAddCB(ReflexeChargementImage);	/* ok file charger image */
    MkAddCB(ReflexeChargementSegmentation);	/* ok file charger seg */
    MkAddCB(ReflexeSauvegardeSegmentation);	/* ok file sauver seg */
    MkAddCB(ReflexeQuitter);		/* ok warning fin */
    MkAddCB(ReflexeSelection);		/* menu Selection */
    MkAddCB(ReflexeRegles);		/* menu Regles */
    MkAddCB(ReflexeSegmentation);	/* menu Segmentation */
    MkAddCB(ReflexeEffacement);		/* menu Effacement */
    MkAddCB(ReflexeFaceEuclidienne);	/* menu Face Eucl. */
    MkAddCB(ReflexeCarteEuclidienne);	/* menu Carte Eucl. */
    MkAddCB(ReflexeZoom);		/* menu Zoom */
    MkAddCB(ReflexeMenuZoom);	        /* menu fenetre_zoom */
    MkAddCB(ReflexeZoomChemins);	/* menu fenetre_zoom/Chemins */
    MkAddCB(ReflexeZoomParametres);	/* menu fenetre_zoom/Parametres */
    MkAddCB(ReflexeFondZoom);	       /* menu fenetre_zoom / Image */
}

void register_event()
{
    MkAddEvent(EvenementSelectPoint);
}
void uniformiser(char* chaine)
{
  int i=0;

  do
    {
      chaine[i] = tolower(chaine[i]);
      i++;
    }
  while(chaine[i] != '\0');

}

int recuperer_argument(char* commande,
		       char* nom_param,
		       char* param[],
		       int* nb_param)
{
  int i,j;


  for(i=1;i<*nb_param;i++)
    if(strcmp(param[i],nom_param)==0)
      break;

  if(i==*nb_param)
    return faux;
	  
  for(j=i;j<*nb_param-1;j++)
    {
      param[j] = param[j+1];
    }
  
  *nb_param = *nb_param-1;
  
  return vrai;
}

void usage(char* nom)
{
  fprintf(stderr,"USAGE :\n\n %s [ dir of images to load]",nom);
  fprintf(stderr," [dir of segmented images to load]");
  fprintf(stderr,"[dir of saved segmented images]\n");
}
int main (int argc,char **argv)
{
  

    int           data = 123456;
    Widget h_bar,v_bar;
    char * commande;

    commande = argv[0];
    if(recuperer_argument(commande,"-help",argv,&argc))
      {
	usage(commande);
	exit(1);
      }

    if (argc > 4)
      {
	usage(commande);
	exit(1);
      }
    /*---------------------\
    | CREATION WIDGET MERE |
    \---------------------*/
    ALLOC_list_gen();
    ALLOC_dart_list();
    ALLOC_rule();
    ALLOC_output_segment();
    ALLOC_seg_tmp();
    ALLOC_tab_move();
    ALLOC_tab_mark_dart();

    
    /*------------------------\
    | CREATION DE L'INTERFACE |
    \------------------------*/
    register_callback();
    register_event();
    
    MkCreateApp("segmente", "segmente.mfk","color.mfk", argc, argv);

    /*-------------------------------\
    | PRISE EN COMPTE DES EVENEMENTS |
    \-------------------------------*/
    switch(argc)
      {
      case 1:
	break;
      case 4:
	XtVaSetValues(MkWidget("sauvfile"),
		      XmNdirectory,
		      XmStringCreate(argv[3],XmSTRING_DEFAULT_CHARSET),
		      NULL);
      case 3:
	XtVaSetValues(MkWidget("chargesegfile"),
		      XmNdirectory,
		      XmStringCreate(argv[2],XmSTRING_DEFAULT_CHARSET),
		      NULL);
      case 2:
	XtVaSetValues(MkWidget("chargeimagefile"),
		      XmNdirectory,
		      XmStringCreate(argv[1],XmSTRING_DEFAULT_CHARSET),
		      NULL);
	break;
      default:
	usage(argv[0]);
	exit(1);
      }

    MkAppMainLoop ();

}










