#include "my_gtk.h"


GtkWidget* create_file_selection(const char* message,
				 const gchar* pattern,
				 GtkSignalFunc ok_func,
				 GtkSignalFunc cancel_func
				 )
{
  GtkWidget * ImageSelection;
  
  ImageSelection =  gtk_file_selection_new(message);
  gtk_file_selection_hide_fileop_buttons(GTK_FILE_SELECTION(ImageSelection));

  if(pattern != NULL)
    gtk_file_selection_complete(GTK_FILE_SELECTION(ImageSelection),
				pattern);
  
  gtk_signal_connect_object(GTK_OBJECT(GTK_FILE_SELECTION(ImageSelection)->cancel_button),
			    "clicked",
			    cancel_func,
			    GTK_OBJECT(ImageSelection)
			    );

  gtk_signal_connect_object(GTK_OBJECT(GTK_FILE_SELECTION(ImageSelection)->ok_button),
			    "clicked",
			    ok_func,
			    GTK_OBJECT(ImageSelection)
			    );

  gtk_widget_show(ImageSelection);
  return ImageSelection;
}

GtkWidget* create_confirm(const char* message,
			 GtkSignalFunc ok_func,
			 GtkSignalFunc cancel_func
			 )
{
  
  GtkWidget *Dialogue;
  GtkWidget *HBox;
  GtkWidget *BoutonAnuller;
  GtkWidget *BoutonQuitter;
  GtkWidget *Label;
  

  Dialogue = gtk_dialog_new();

  Label = gtk_label_new(message);
  gtk_box_pack_start(GTK_BOX(GTK_DIALOG(Dialogue)->vbox),
		     Label,
		     TRUE,TRUE,20);
  gtk_widget_show(Label);


  HBox = gtk_hbox_new(TRUE,5);
  gtk_box_pack_start(GTK_BOX(GTK_DIALOG(Dialogue)->action_area),
		     HBox,
		     TRUE,TRUE,0);
  gtk_widget_show(HBox);

  BoutonQuitter = gtk_button_new_with_label("Quitter");
  gtk_signal_connect_object(GTK_OBJECT(BoutonQuitter),
			    "clicked",
			    (GtkSignalFunc)ok_func,
			    NULL);
  gtk_box_pack_start(GTK_BOX(HBox),BoutonQuitter,TRUE,TRUE,0);
  gtk_widget_show(BoutonQuitter);
  
  BoutonAnuller = gtk_button_new_with_label("Annuler");
  gtk_signal_connect_object(GTK_OBJECT(BoutonAnuller),
			    "clicked",
			    (GtkSignalFunc)cancel_func,
			    (GtkObject*)Dialogue);
  
  gtk_box_pack_start(GTK_BOX(HBox),BoutonAnuller,TRUE,TRUE,0);
  gtk_widget_show(BoutonAnuller);

  gtk_widget_show(Dialogue);
  gtk_widget_set_uposition(Dialogue,
			   (gdk_screen_width()-(Dialogue->allocation.width))>>1,
			   (gdk_screen_height()-(Dialogue->allocation.height))>>1);

  return Dialogue;
}
void create_dialog(const char* message,
		   GtkSignalFunc ok_func
		   )
{
  
  GtkWidget *Dialogue;
  GtkWidget *HBox;
  GtkWidget *BoutonOK;
  GtkWidget *Label;
  

  Dialogue = gtk_dialog_new();

  Label = gtk_label_new(message);
  gtk_box_pack_start(GTK_BOX(GTK_DIALOG(Dialogue)->vbox),
		     Label,
		     TRUE,TRUE,20);
  gtk_widget_show(Label);


  HBox = gtk_hbox_new(TRUE,5);
  gtk_box_pack_start(GTK_BOX(GTK_DIALOG(Dialogue)->action_area),
		     HBox,
		     TRUE,TRUE,0);
  gtk_widget_show(HBox);

  BoutonOK = gtk_button_new_with_label("OK");
  gtk_signal_connect_object(GTK_OBJECT(BoutonOK),
			    "clicked",
			    (GtkSignalFunc)ok_func,
			    (GtkObject*)Dialogue);
  gtk_box_pack_start(GTK_BOX(HBox),BoutonOK,TRUE,TRUE,0);
  gtk_widget_show(BoutonOK);

  gtk_widget_show(Dialogue);
}
