#include <math.h>
#include <malloc.h>
#include "rule.h"
#include "macros.h"
#include "types.h"
#include "image.h"
#include "arbre.h"
#include "definitions.h"
#include "quantification.h"
#include "display.h"
#include "point.h"
#include "segmentation.h"
#include "rules_link.h"
#include "segmentation_link.h"


void usage(char* nom)
{
  fprintf(stderr,"Usage %s alpha src.ppm > dest.ppm\n",nom);
  fprintf(stderr,"      alpha : integer in [0,100]\n",nom);
}
int main (int argc,char* argv[])
{
  

    int           data = 123456;
    contour_set contours;
    segmentation seg_algorithms;

    if(argc != 3)
      {
	usage(argv[0]);
	exit(1);
      }
    /* Initialisations  */
    ALLOC_list_gen();
    ALLOC_dart_list();
    ALLOC_rule();
    ALLOC_output_segment();
    ALLOC_seg_tmp();
    ALLOC_tab_move();
    ALLOC_tab_mark_dart();

    alpha = atof(argv[1]);
    contours = FAIRE_contour_set(argv[2]);
    seg_algorithms = FAIRE_segmentation();
    /* segmentation initiale */
    contour_set_memorize_inserted_faces(contours);
    segmentation_set_algorithm(seg_algorithms,UNIFORM_SEGMENTATION);
    segmentation_make_segments(seg_algorithms,
			       contours,
			       1,
			       alpha);
    
    face_list = FAIRE_dart_list();
    contour_set_give_inserted_faces(contours,face_list);
    make_quant_priv(contours,face_list);
    DEALLOC_tab_move();
    DEALLOC_seg_tmp();
    DEALLOC_output_segment();
    DEALLOC_list_gen();
    DEALLOC_rule();
    DEALLOC_dart_list();    
    DEFAIRE_contour_set(contours);
    DEFAIRE_ximage(ximg);
    DEALLOC_tab_mark_dart();
}

void make_quant_priv(contour_set contours,
		     dart_list face_list,
		     double I_sqe,
		     double alpha)
{
  tab_gen color_tab;
  int i;
  dart f;

  color_tab = FAIRE_tab_gen();
  i = 0;

  dart_list_fist(face_list);

  do
    {
      f = dart_list_give_current(face_list);
      f_sqe = contour_set_give_face_squared_error(contours,f);

      if(f_sqe < alpha*I_sqe)
	store_one_color(color_tab,&i,f);
      else
	store_many_colors(color_tab,&i,f);
    }
  while(dart_list_next(face_list));
  
  











