#define VAR_SPLIT_ABSOLUTE_THRESHOLD  0.02
#define AREA_SPLIT_ABSOLUTE_THRESHOLD 0.04
#define AREA_MERGE_THRESHOLD  0.001
#define AREA_SPLIT_THRESHOLD  0.2
#define VAR_SPLIT_THRESHOLD   0.25
#define VAR_MERGE_THRESHOLD   0.2
#include <assert.h>
#include <stdarg.h>
#include "ximage.h"

#include "recursive_seg.h"
#include "contour_set.h"
#include "dart_list.h"
#include "point_set.h"
#include "type_obj.h"
#include "tab_mark_dart.h"


static ximage ximg;
static int couleur_normal;

static void segmentation_rec_priv   (contour_set,
				     dart,
				     dart_list,
				     double,
				     double,
				     va_list);

static void get_face_list_from_point(contour_set,
				     point_set,
				     dart_list);

void recursive_split(contour_set contours,
		     dart f,		    
		     va_list list)
{
  dart_list face_list,faces_to_merge;
  double f_area,son_area;
  double f_var;
  dart son;
  dart_list seg_to_del;
  double threshold;
  tab_mark_dart merge_faces;
  point_set meta_face;
  Point     pt_in_meta_face;
  bouleen   new_meta_face;
  int       nb_meta_face;

  assert(contours);
  
  /* A effacer */
  ximg           = va_arg(list,ximage);
  couleur_normal = va_arg(list,int);

  meta_face = FAIRE_point_set(100); /* A corriger,enjoliver */
  face_list = FAIRE_dart_list();
  f_area = contour_set_give_face_area(contours,f);
  f_var  = contour_set_give_face_variance(contours,f);

  threshold = f_area*AREA_MERGE_THRESHOLD;

  segmentation_rec_priv(contours,f,face_list,f_area,f_var,list);
  /* On agrandi les faces jusqu'a avoir la taille souhaite par rapport */
  /* a la face initiale */
  merge_faces = FAIRE_tab_mark_dart();
  seg_to_del = FAIRE_dart_list();  
  dart_list_first(face_list);
  do
    {
      son = dart_list_give_current(face_list);
      son_area = contour_set_give_face_area(contours,son);
      move_face_to_specified_area(contours,
				  son,
				  threshold,
				  f_var,
				  merge_faces,
				  seg_to_del,
				  &pt_in_meta_face,
				  &new_meta_face);
      if(new_meta_face)
	point_set_insert_point(meta_face,&pt_in_meta_face);
    }
  while(dart_list_next(face_list));

  contour_set_remove_set_of_arc(contours,seg_to_del);

  /* Parmis les faces agrandies on merge celles qui sont */
  /* photometriquement semblables */
  DEFAIRE_tab_mark_dart(merge_faces);

  faces_to_merge = FAIRE_dart_list();
  dart_list_reinitialize    (seg_to_del);
  dart_list_reinitialize    (face_list);
  threshold = VAR_MERGE_THRESHOLD*f_var;
  get_face_list_from_point(contours,meta_face,face_list);

  DEFAIRE_point_set(meta_face);
  do
    {
      dart_list_first(face_list);
      son = dart_list_give_current(face_list);
      merge_same_color_face(contours,
			    son,
			    threshold,
			    faces_to_merge,
			    seg_to_del);
      contour_set_remove_set_of_arc(contours,seg_to_del);
      dart_list_remove_list(face_list,faces_to_merge);
      dart_list_reinitialize(seg_to_del);
      dart_list_reinitialize(faces_to_merge);
    }
  while(!dart_list_is_empty(face_list));

  DEFAIRE_dart_list(seg_to_del);
  DEFAIRE_dart_list(face_list);
  DEFAIRE_dart_list(faces_to_merge);
}

static void segmentation_rec_priv(contour_set contours,
				  dart f,
				  dart_list face_list,
				  double root_area,
				  double root_var,
				  va_list list)
{
  double f_area,f_var;
  dart_list added_face;
  dart son;
  double son_area,son_var;
  char c;

  f_area = contour_set_give_face_area(contours,f);
  f_var  = contour_set_give_face_variance(contours,f);

/* Securite pour ne pas descendre trop bas */
  if(f_area/root_area <= AREA_SPLIT_ABSOLUTE_THRESHOLD)
    return;

  if(f_var/root_var   <= VAR_SPLIT_ABSOLUTE_THRESHOLD)
    return;

  printf("son_area = %lf,root_area = %lf\n,son_area/root_area = %lf\n",
	 f_area,root_area,f_area/root_area);
  printf("son_var = %lf,root_var = %lf\n,son_var/root_var = %lf\n",
	 f_var,root_var,f_var/root_var);
  ximage_draw_face(ximg,contours,f,couleur_normal);
  ximage_display(ximg);
  contour_set_memorize_inserted_faces(contours);
  
  split_face_rule_algorithm(contours,f,list);

  added_face = FAIRE_dart_list();
  contour_set_give_inserted_faces(contours,added_face);
  /* A effacer */
  ximage_draw_set_of_faces(ximg,contours,added_face,couleur_normal+1);
  ximage_display(ximg);
  printf("On continu..");
  if(dart_list_is_empty(added_face))
    {
      DEFAIRE_dart_list(added_face);
      return;
    }
  dart_list_first(added_face);
  do
    {
      son      = dart_list_give_current(added_face);
      son_area = contour_set_give_face_area(contours,son);
      son_var  = contour_set_give_face_variance(contours,son);
      assert(son_area < f_area);
      if ((son_area/f_area > AREA_SPLIT_THRESHOLD) &&
	  (son_var/f_var   > VAR_SPLIT_THRESHOLD))
	{
	  printf("son_area = %lf,f_area = %lf\n,son_area/f_area = %lf\n",
		 son_area,f_area,son_area/f_area);
	  
	  printf("son_var = %lf,f_var = %lf\n,son_var/f_var = %lf\n",
		 son_var,f_var,son_var/f_var);
	  
	  segmentation_rec_priv(contours,
				son,
				face_list,
				root_area,
				root_var,
				list);
	}
    }
  while(dart_list_next(added_face));
  
  dart_list_merge_list(face_list,added_face);
}

void recursive_split_rule_set_algorithm(rule father)
{
  father->specified_rule = recursive_split;
}


static void get_face_list_from_point(contour_set contours,
				     point_set meta_face,
				     dart_list face_list)
{
  int i,nb_of_face;
  dart f;
  point p_f;
  tab_mark_dart inserted;

  inserted = FAIRE_tab_mark_dart();

  nb_of_face = point_set_give_cardinal(meta_face);
  for(i=0;i<nb_of_face;i++)
    {
      p_f = point_set_give_point(meta_face,i);
      f = contour_set_assoc_point_face(contours,p_f);
      if(contour_set_is_infinite(contours,f))
	f = contour_set_give_including_face(contours,f);
      if(!tab_mark_dart_is_marked(inserted,f))
	dart_list_insert(face_list,f);
      tab_mark_dart_mark_dart(inserted,f);
    }
  DEFAIRE_tab_mark_dart(inserted);
}




