#define VAR_SPLIT_ABSOLUTE_THRESHOLD  0.02
#define AREA_SPLIT_ABSOLUTE_THRESHOLD 0.04
#define AREA_MERGE_THRESHOLD  0.001
#define AREA_SPLIT_THRESHOLD  0.2
#define VAR_SPLIT_THRESHOLD   0.25
#define VAR_MERGE_THRESHOLD   0.2
#include <assert.h>
#include <stdarg.h>
#include "ximage.h"

#include "recursive_seg.h"
#include "contour_set.h"
#include "dart_list.h"
#include "point_set.h"
#include "type_obj.h"
#include "tab_mark_dart.h"


static ximage ximg;
static int couleur_normal;

static void segmentation_rec2_priv   (contour_set,
				      dart,
				      dart_list,
				      double,
				      va_list);


void recursive_split2(contour_set contours,
		      dart f,		    
		      va_list list)
{
  dart_list face_list;
  double f_se;
  dart son;
  dart_list seg_to_del;
  double threshold;
  tab_mark_dart merge_faces;
  double ecart;

  assert(contours);
  
  ecart          = va_arg(list,double); 
  ecart /= 100.0;
  /* A effacer */ 
  ximg           = va_arg(list,ximage);
  couleur_normal = va_arg(list,int);
  
  face_list = FAIRE_dart_list();
  f_se   = contour_set_give_face_squared_error(contours,f);
  threshold = ecart*f_se;

  segmentation_rec2_priv(contours,f,face_list,threshold,list);

  /* Parmis les faces agrandies on merge celles qui sont */
  /* photometriquement semblables */
  /* On agrandi les faces jusqu'a avoir la taille souhaite par rapport */
  /* a la face initiale */
/*  threshold /= 10.0;*/
  merge_faces = FAIRE_tab_mark_dart();
  seg_to_del = FAIRE_dart_list();  
  dart_list_first(face_list);
  do
    {
      son = dart_list_give_current(face_list);
      move_face_to_specified_squared_error(contours,
					   son,
					   threshold,
					   merge_faces,
					   seg_to_del);
    }
  while(dart_list_next(face_list));

  contour_set_remove_set_of_arc(contours,seg_to_del);

  DEFAIRE_tab_mark_dart(merge_faces);
  DEFAIRE_dart_list(seg_to_del);
  DEFAIRE_dart_list(face_list);
}

static void segmentation_rec2_priv(contour_set contours,
				   dart f,
				   dart_list face_list,
				   double threshold,
				   va_list list)
{
  double f_se;
  dart_list added_face;
  dart son;

  f_se  = contour_set_give_face_squared_error(contours,f);

  if(f_se  <= threshold)
    return;

  printf("J'ai trouve une face d'erreur quadratique superieure\n");
  printf("a threshold f_se = %f, threshold =%f\n",f_se,threshold); 
  ximage_draw_face(ximg,contours,f,couleur_normal);
  ximage_display(ximg);
  contour_set_memorize_inserted_faces(contours);
  
  split_face_rule_algorithm(contours,f,list);

  added_face = FAIRE_dart_list();
  contour_set_give_inserted_faces(contours,added_face);
  /* A effacer */
  ximage_draw_set_of_faces(ximg,contours,added_face,couleur_normal+1);
  ximage_display(ximg);
  printf("On continu..\n");
  if(dart_list_is_empty(added_face))
    {
      DEFAIRE_dart_list(added_face);
      return;
    }
  dart_list_first(added_face);
  do
    {
      son      = dart_list_give_current(added_face);
      segmentation_rec2_priv(contours,
			     son,
			     face_list,
			     threshold,
			     list);
    }
  while(dart_list_next(added_face));

  dart_list_merge_list(face_list,added_face);
}
void recursive_split2_rule_set_algorithm(rule father)
{
  father->specified_rule = recursive_split2;
}





