#ifndef SEGMENT_H
#define SEGMENT_H

#include "move_type.h"
#include "type_obj.h"
#include "point.h"
#include "seg_tmp.h"
#include "output_segment.h"
#include "image.h"

#include "classe.h"


CLASSE(segment);

#include "bitmap.h"

#define NULL_SEGMENT (segment)NULL 

extern segment   FAIRE_segment  (bitmap);
extern void      DEFAIRE_segment(segment);

extern void      segment_init_from_seg_tmp  (segment,seg_tmp);
extern void      segment_init_output_segment(segment,output_segment);

extern void      segment_first(segment);
extern void      segment_last (segment);

extern bouleen   segment_is_first (segment,point);
extern bouleen   segment_is_last  (segment,point);
extern bouleen   segment_is_closed(segment);
extern bouleen   segment_is_in    (segment, point);

extern void      segment_give_current_point(segment,point);
extern move_type segment_give_current_move (segment);

extern bouleen   segment_next    (segment);
extern bouleen   segment_previous(segment);

extern void      segment_get_first     (segment,point);
extern void      segment_get_last      (segment,point);
extern move_type segment_get_first_move(segment);
extern move_type segment_get_last_move (segment);
extern int       segment_get_longueur  (segment);

extern double    segment_compute_gradiant(segment,image);

extern int       segment_give_clock      (segment);
extern dart      segment_give_dart_nb    (segment);
extern void      segment_give_right_point(segment,point);

extern void      segment_set_dart_nb    (segment, dart);
extern void      segment_set_first_point(segment,point);
extern void      segment_set_last_point (segment, point);
extern void      segment_set_first_move (segment,move_type);
extern void      segment_set_last_move  (segment,move_type);
extern void      segment_set_right_point(segment, point);
extern void      segment_set_clockSense (segment, long);

extern void      segment_set_longueur    (segment, int);

extern void      segment_concat      (segment, segment);
extern segment   segment_split       (segment,point,dart);
extern void      segment_reverse     (segment);
/* Plus specifiquement reserve a des buts de segmentation */
extern void      segment_mark_segment  (segment,
					void (*mark_fct)(tab_mark,
							 point),
					tab_mark);
extern void      segment_unmark_segment(segment,
					void (*unmark_fct)(tab_mark,
							   point),
					tab_mark);


#endif /* SEGMENT_H */

