#ifndef __SEGMENTATION__
#define __SEGMENTATION__

#include "type_obj.h"
#include "contour_set.h"
#include "classe.h"


CLASSE(segmentation);

typedef void (*PFcompute_params)(segmentation,contour_set,dart,double);
typedef void (*PFclose)();
typedef void (*PFinit)(segmentation);

CLASSE(segmentation_priv);

struct segmentation
{
  PFcompute_params compute_params;
  PFsame_cluster   same_cluster;
  PFclose          close_params;
  segmentation_priv private_field;
};

extern segmentation FAIRE_segmentation();
extern void         DEFAIRE_segmentation(segmentation);

extern void         segmentation_set_algorithm    (segmentation,PFinit);
extern void         segmentation_set_space        (segmentation,int);

extern int          segmentation_give_space       (segmentation);

extern void         segmentation_make_segments    (segmentation,
						   contour_set,
						   dart,
						   double);


#endif

