#include "vector.h"
#include <assert.h>

double vector_dist(vector v1,vector v2,int dim)
{
  int i;
  double dist;

  assert(dim<=DIM_MAX);

  dist = 0;
  for(i=0;i<dim;i++)
    dist += (v1[i]-v2[i])*(v1[i]-v2[i]);

  return dist;
}

void vector_equal_plus(vector v1,vector v2,int dim)
{
  int i;

  assert(dim<=DIM_MAX);

  for(i=0;i<dim;i++)
    v1[i] += v2[i];
} 
void vector_divide(vector v1,vector v2,double denum,int dim)
{
  int i;
  
  assert(denum);
  assert(dim<=DIM_MAX);
  
  for(i=0;i<dim;i++)
    v1[i] = v2[i]/denum;
}
