#ifndef __XDRAWING_H__
#define __XDRAWING_H__


#include <gtk/gtk.h>
#include "types.h"
#include "point.h"
#include "output_segment.h"
#include "contour_set.h"
#include "display.h"
#include "type_obj.h"

#include "classe.h"

typedef enum { sharp, smooth, sharp_and_smooth } draw_mode;

CLASSE(xdrawing);


extern xdrawing FAIRE_xdrawing( GtkWidget *_parent, 
				GtkWidget *_darea,  
				display dis, 
				int zfactor, 
				contour_set contours, 
				unsigned char *normal_color);

extern void DEFAIRE_xdrawing(xdrawing);

extern GtkWidget* xdrawing_get_parent( xdrawing self );
extern GdkPixmap* xdrawing_get_pixmap( xdrawing self );

extern int xdrawing_get_width( xdrawing self );
extern int xdrawing_get_height( xdrawing self );

extern void xdrawing_set_background(xdrawing self);
extern void xdrawing_unset_background(xdrawing self);

extern void xdrawing_draw_face(xdrawing self);

extern void xdrawing_set_mode( xdrawing self, draw_mode mode );
extern void xdrawing_draw_selected_face( xdrawing self );

extern void xdrawing_set_face(xdrawing self, dart d);
extern void xdrawing_set_bounding_box( xdrawing self, point sp, point dp );

extern float xdrawing_get_perimetre( xdrawing self );
extern float xdrawing_get_surface( xdrawing self );

#endif


